Package: CTdata
Title: Data companion to CTexploreR
Version: 1.12.0
Authors@R: 
    c(person(given = "Axelle",
           family = "Loriot",
           role = "aut",
           email = "axelle.loriot@uclouvain.be",
                 comment = c(ORCID = "0000-0002-5288-8561")),
      person(given = "Julie",
           family = "Devis",
           role = "aut",
           email = "julie.devis@uclouvain.be",
           comment = c(ORCID = "0000-0001-5525-5666")),
      person(given = "Anna",
           family = "Diacofotaki",
           role = "ctb",
           email = "anna.diacofotaki@uclouvain.be"),
      person(given = "Charles",
           family = "De Smet",
           role = "ths",
           email = "charles.desmet@uclouvain.be"),
      person(given = "Laurent",
           family = "Gatto",
           role = c("aut","ths", "cre"),
           email = "laurent.gatto@uclouvain.be",
           comment = c(ORCID = "0000-0002-1520-2268")))
Description: Data from publicly available databases (GTEx, CCLE, TCGA
      and ENCODE) that go with CTexploreR in order to re-define a
      comprehensive and thoroughly curated list of CT genes and their
      main characteristics.
License: Artistic-2.0
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
Depends: R (>= 4.2)
biocViews: Transcriptomics, Epigenetics, GeneExpression, DataImport,
        ExperimentHubSoftware
Imports: ExperimentHub, utils
Suggests: testthat (>= 3.0.0), DT, BiocStyle, knitr, rmarkdown,
        SummarizedExperiment, SingleCellExperiment
VignetteBuilder: knitr
BugReports: https://github.com/UCLouvain-CBIO/CTdata/issues
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/CTdata
git_branch: RELEASE_3_23
git_last_commit: 875c873
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:52:42 UTC; biocbuild
Author: Axelle Loriot [aut] (ORCID: <https://orcid.org/0000-0002-5288-8561>),
  Julie Devis [aut] (ORCID: <https://orcid.org/0000-0001-5525-5666>),
  Anna Diacofotaki [ctb],
  Charles De Smet [ths],
  Laurent Gatto [aut, ths, cre] (ORCID:
    <https://orcid.org/0000-0002-1520-2268>)
Maintainer: Laurent Gatto <laurent.gatto@uclouvain.be>
Built: R 4.6.0; ; 2026-04-29 04:38:59 UTC; unix

# CTdata

Companion Package for CTexploreR containing omics data to select and characterise CT genes. 

Data comes from public databases. One can find in this package, expression and methylation values of genes in normal and tumor samples as well as in tumor cell lines. Expression in cells treated with a demethylating agent is also available. 

A list of defined CT genes and their characteristics can also be found in the package

metadata <-
    data.frame(
        Title = c(
            "GTEX_data",
            "CCLE_data",
            "normal_tissues_multimapping_data",
            "DAC_treated_cells",
            "DAC_treated_cells_multimapping",
            "TCGA_TPM",
            "CT_methylation_in_tissues",
            "CT_mean_methylation_in_tissues",
            "TCGA_CT_methylation",
            "CT_genes",
            "CCLE_correlation_matrix",
            "testis_sce",
            "scRNAseq_HPA",
            "all_genes",
            "FGC_sce",
            "HPA_cell_type_specificities",
            "mean_methylation_in_tissues",
            "methylation_in_tissues",
            "oocytes_sce",
            "TCGA_methylation",
            "embryo_sce_Zhu",
            "embryo_sce_Petropoulos",
            "hESC_data",
            "methylation_in_hESC",
            "mean_methylation_in_hESC",
            "methylation_in_FGC",
            "mean_methylation_in_FGC",
            "methylation_in_embryo",
            "mean_methylation_in_embryo"),
        Description = c(
            "Gene expression data in normal tissues from GTEx database",
            "Gene expression data in cancer cell lines from CCLE",
            "Gene expression values in normal tissues with or without allowing multimapping",
            "Gene expression values in a set of cell lines treated or not with 5-Aza-2'-Deoxycytidine (DAC), a demethylating agent",
            "Gene expression values (multimapping allowed) in a set of cell lines treated or not with 5-Aza-2'-Deoxycytidine (DAC)",
            "Gene expression data in TCGA samples",
            "Methylation values of CpGs located within Cancer-Testis promoters in a set of normal tissues",
            "Mean methylation values of all CpGs located within Cancer-Testis (CT) promoters in a set of normal tissues",
            "Methylation of CT promoters in TCGA samples",
            "Cancer-Testis (CT) genes description",
            "Gene correlations in CCLE cancer cell lines",
            "Testis scRNAseq data",
            "Gene expression profiles in different human cell types based on scRNAseq data from The Human Protein Atlas",
            "All genes description, according to the analysis done for CT genes",
            "Fetal gonad scRNAseq",
            "Cell type specificities (from HPA)",
            "Mean methylation values of all CpGs located within all (CT) promoters in a set of normal tissues",
            "Methylation values of CpGs located within all promoters in a set of normal tissues",
            "Oocytes scRNAseq",
            "Methylation of all genes promoters in TCGA samples",
            "Gene expression values in early embryo (blastocyst)",
            "Gene expression values in early embryo (blastocyst and Morula)",
            "Gene expression data in human embryonic stem cells",
            "Methylation values of CpGs located within all promoters in human embryonic stem cells",
            "Mean methylation values of all CpGs located within all promoters in human embryonic stem cells",
            "Methylation values of CpGs located within all promoters in fetal germ cells",
            "Mean methylation values of all CpGs located within all promoters in fetal germ cells",
            "Methylation values of CpGs located within all promoters in early embryo",
            "Mean methylation values of all CpGs located within all promoters in early embryo"
            ),
        BiocVersion = c(
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.17",
            "3.17",
            "3.17",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19",
            "3.19"),
        Genome = c(rep("hg38", 25), rep ("hg19", 4)),
        SourceType = c(
            "tab",
            "CSV",
            "FASTQ",
            "FASTQ",
            "FASTQ",
            "TSV",
            "BED",
            "BED",
            "TXT",
            "TSV",
            "CSV",
            "FASTQ",
            "TSV",
            "TSV",
            "RDS",
            "TSV",
            "BED",
            "BED",
            "TXT",
            "TSV",
            "tab",
            "TXT",
            "FASTQ",
            "BED",
            "BED",
            "TXT",
            "TXT",
            "BED",
            "BED"),
        SourceUrl = c(
            "https://storage.googleapis.com/gtex_analysis_v8/rna_seq_data/GTEx_Analysis_2017-06-05_v8_RNASeQCv1.1.9_gene_median_tpm.gct.gz",
            "https://ndownloader.figshare.com/files/34989922, https://ndownloader.figshare.com/files/35020903",
            "https://www.encodeproject.org/",
            "https://www.encodeproject.org/",
            "https://www.encodeproject.org/",
            "https://portal.gdc.cancer.gov/",
            "https://www.encodeproject.org/",
            "https://www.encodeproject.org/",
            "https://portal.gdc.cancer.gov/",
            "https://zenodo.org/record/7537824/files/cancermine_collated.tsv?download=1",
            "https://ndownloader.figshare.com/files/34989922, https://ndownloader.figshare.com/files/35020903",
            "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE120508",
            "https://www.proteinatlas.org/download/rna_single_cell_type.tsv.zip",
            "https://zenodo.org/record/7537824/files/cancermine_collated.tsv?download=1",
            "https://cellxgene.cziscience.com/collections/661a402a-2a5a-4c71-9b05-b346c57bc451Data",
            "https://www.proteinatlas.org/",
            "https://www.encodeproject.org/",
            "https://www.encodeproject.org/",
            "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE154762",
            "https://portal.gdc.cancer.gov/",
            "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE81233",
            "https://www.ebi.ac.uk/biostudies/files/E-MTAB-3929/",
            "https://www.encodeproject.org/",
            "https://www.encodeproject.org/",
            "https://www.encodeproject.org/",
            "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE107714",
            "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE107714",
            "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE81233",
            "https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE81233"),
        SourceVersion = c(
            "8",
            "22Q2",
            "5",
            "5",
            "5",
            "36.0",
            "5",
            "5",
            "36.0",
            "49",
            "22Q2",
            "1",
            "1",
            "49",
            "1",
            "23",
            "5",
            "5",
            "1",
            "36.0",
            "1",
            "1",
            "5",
            "5",
            "5",
            "1",
            "1",
            "1",
            "1"),
        Species = "Homo sapiens",
        TaxonomyId = "9606",
        Coordinate_1_based = "TRUE",
        DataProvider = c(
            "The Genotype-Tissue Expression",
            "Cancer Cell Line Encyclopedia",
            "ENCODE Project",
            "ENCODE Project",
            "ENCODE Project",
            "The Cancer Genome Atlas",
            "ENCODE Project",
            "ENCODE Project",
            "The Cancer Genome Atlas",
            "CancerMine",
            "Cancer Cell Line Encyclopedia",
            "The adult human testis transcriptional cell atlas, Guo et al. 2018",
            "The Human Protein Atlas",
            "CancerMine",
            "Single-cell roadmap of human gonadal development (Garcia-Alonso, Nature 2022)",
            "The Human Protein Atlas",
            "ENCODE Project",
            "ENCODE Project",
            "NCBI GEO : Decoding dynamic epigenetic landscapes in human oocytes
            using single-cell multi-omics sequencing (Yan et al. Cell Stem Cell 2021)",
            "The Cancer Genome Atlas",
            "Single Cell DNA Methylome Sequencing of Human Preimplantation Embryos (Zhu et al. 2018)",
            "Single-Cell RNA-Seq Reveals Lineage and X Chromosome Dynamics in
            Human Preimplantation Embryos (Petropulous et al, 2014)",
            "ENCODE Project",
            "ENCODE Project",
            "ENCODE Project",
            "Data from Dissecting the epigenomic dynamics of human fetal germ cell
            development at single-cell resolution (Li et al. 2021)",
            "Data from Dissecting the epigenomic dynamics of human fetal germ cell
            development at single-cell resolution (Li et al. 2021)",
            "Single Cell DNA Methylome Sequencing of Human Preimplantation Embryos (Zhu et al. 2018)",
            "Single Cell DNA Methylome Sequencing of Human Preimplantation Embryos (Zhu et al. 2018)"),
        Maintainer = "Axelle Loriot <axelle.loriot@uclouvain.be>",
        RDataClass = c(
            "SummarizedExperiment",
            "SummarizedExperiment",
            "SummarizedExperiment",
            "SummarizedExperiment",
            "SummarizedExperiment",
            "SummarizedExperiment",
            "RangedSummarizedExperiment",
            "SummarizedExperiment",
            "RangedSummarizedExperiment",
            "tibble",
            "matrix",
            "SingleCellExperiment",
            "SingleCellExperiment",
            "tibble",
            "SingleCellExperiment",
            "SingleCellExperiment",
            "SummarizedExperiment",
            "RangedSummarizedExperiment",
            "SingleCellExperiment",
            "SummarizedExperiment",
            "SingleCellExperiment",
            "SingleCellExperiment",
            "SummarizedExperiment",
            "RangedSummarizedExperiment",
            "SummarizedExperiment",
            "RangedSummarizedExperiment",
            "RangedSummarizedExperiment",
            "RangedSummarizedExperiment",
            "RangedSummarizedExperiment"),
        DispatchClass = "Rda",
        RDataPath = c(
            "CTdata/eh_data/v2/GTEX_data.rda",
            "CTdata/eh_data/v2/CCLE_data.rda",
            "CTdata/eh_data/v2/normal_tissues_multimapping_data.rda",
            "CTdata/eh_data/v2/DAC_treated_cells.rda",
            "CTdata/eh_data/v2/DAC_treated_cells_multimapping.rda",
            "CTdata/eh_data/v2/TCGA_TPM.rda",
            "CTdata/eh_data/v2/CT_methylation_in_tissues.rda",
            "CTdata/eh_data/v2/CT_mean_methylation_in_tissues.rda",
            "CTdata/eh_data/v2/TCGA_CT_methylation.rda",
            "CTdata/eh_data/v3/CT_genes.rda",
            "CTdata/eh_data/v3/CCLE_correlation_matrix.rda",
            "CTdata/eh_data/v2/testis_sce.rda",
            "CTdata/eh_data/v2/scRNAseq_HPA.rda",
            "CTdata/eh_data/all_genes.rda",
            "CTdata/eh_data/FGC_sce.rda",
            "CTdata/eh_data/HPA_cell_type_specificities.rda",
            "CTdata/eh_data/mean_methylation_in_tissues.rda",
            "CTdata/eh_data/methylation_in_tissues.rda",
            "CTdata/eh_data/oocytes_sce.rda",
            "CTdata/eh_data/TCGA_methylation.rda",
            "CTdata/eh_data/embryo_sce_Zhu.rda",
            "CTdata/eh_data/embryo_sce_Petropoulos.rda",
            "CTdata/eh_data/hESC_data.rda",
            "CTdata/eh_data/methylation_in_hESC.rda",
            "CTdata/eh_data/mean_methylation_in_hESC.rda",
            "CTdata/eh_data/methylation_in_FGC.rda",
            "CTdata/eh_data/mean_methylation_in_FGC.rda",
            "CTdata/eh_data/methylation_in_embryo.rda",
            "CTdata/eh_data/mean_methylation_in_embryo.rda"),
        Tags = c("GeneExpression:NormalTissues",
                 "GeneExpression:CancerData:CellLines",
                 "GeneExpression:NormalTissues:Multimapping",
                 "GeneExpression:CellLines:DemethylatingAgent",
                 "GeneExpression:CellLines:DemethylatingAgent:Multimapping",
                 "GeneExpression:CancerData:TumorSamples",
                 "MethylationData:CancerTestis:NormalTissues",
                 "MethylationData:CancerTestis:NormalTissues",
                 "MethylationData:CancerTestis:CancerData:TumorSamples",
                 "CancerTestis:MethylationData:GeneExpression:CancerData:NormalTissues:TumorSamples",
                 "CancerTestis:GeneExpression:CancerData:CellLines",
                 "GeneExpression:scRNAseq:testis",
                 "GeneExpression:scRNAseq:normalCellTypes",
                 "MethylationData:GeneExpression:CancerData:NormalTissues:TumorSamples",
                 "GeneExpression:scRNAseq:FetalCells:Gonad",
                 "GeneActivation:scRNAseq:testis:normalCellTypes",
                 "MethylationData:NormalTissues",
                 "MethylationData:NormalTissues",
                 "GeneExpression:scRNAseq:Oocyts:Gonad",
                 "GeneExpression:CancerData:TumorSamples",
                 "GeneExpression:scRNAseq:embryo",
                 "GeneExpression:scRNAseq:embryo",
                 "GeneExpression:hESC",
                 "MethylationData:hESC",
                 "MethylationData:hESC",
                 "MethylationData:FetalGermCells",
                 "MethylationData:FetalGermCells",
                 "MethylationData:embryo",
                 "MethylationData:embryo")
    )



## Add default tags
metadata$Tags <- CTdata:::makeTags(metadata$Tags)

write.csv(metadata, file = "../extdata/metadata.csv", row.names = FALSE)

pathToPkg <- "~/dev/" ## change this accordingly

ExperimentHubData::makeExperimentHubMetadata(
                       pathToPackage = file.path(pathToPkg, "CTdata"),
                       fileName = "metadata.csv")

## Code to prepare `hESC_data` dataset goes here

library("tidyverse")
library("SummarizedExperiment")
load("../../eh_data/all_genes.rda")


## RNAseq data from embryonic stem cells were downloaded from Encode.
## H1 (total RNA)  (ENCFF892WVN.fastq.gz, ENCFF481BLH.fastq.gz)
## H7 (total RNA)  (ENCFF002DMP.fastq.gz, ENCFF002DMQ.fastq.gz)
## H9 (total RNA)  (ENCFF778LAE.fastq.gz, ENCFF650HFX.fastq.gz)
## HUES64 (polyA) (ENCFF098DFE.fastq.gz, ENCFF608FBD.fastq.gz)

## NB : No WGBS data for H7 but keeping it in expression anyway

## Data was processed using a standard RNAseq pipeline including
## [FastQC](https://www.bioinformatics.babraham.ac.uk/projects/fastqc/) for the
## quality control of the raw data, and
## [trimmomatic](http://www.usadellab.org/cms/?page=trimmomatic)
## to remove low quality reads and trim the adapter from the sequences.
## [hisat2](https://ccb.jhu.edu/software/hisat2/index.shtml) was used to align
## reads to grch38 genome.
## [featurecounts](https://rdrr.io/bioc/Rsubread/man/featureCounts.html) was
## used to assign reads to genes using Homo_sapiens.GRCh38.105.gtf.

load("../../../CTdata_extdata/hESC_RNAseq_coldata.rda")
load("../../../CTdata_extdata/hESC_RNAseq_raw_counts.rda")

################################################################################
## Coldata creation
################################################################################


coldata <- as.data.frame(coldata) %>%
  mutate(cell_type = "hESC") %>%
  mutate(genotype = factor(genotype, levels = c("XX", "XY"))) %>%
  mutate(dataset = "Encode") %>%
  mutate(data = "Expression")

rownames(coldata) <- coldata$sample

################################################################################
## TPM normalisation
################################################################################

gene_lengths <-
  read_table("../../../CTdata_extdata/H1_featurecounts.tsv",
             skip = 1) %>%
  dplyr::select(Geneid, Length)
x1 <- counts / gene_lengths$Length * 1000
total <- colSums(x1)

TPM_values <- as_tibble(x1, rownames = "Geneid") %>%
  pivot_longer(names_to = "sample", values_to = "counts", -Geneid) %>%
  left_join(enframe(total) %>%
              dplyr::rename(sample = name, total = value)) %>%
  mutate(TPM = round(counts / total * 1000000, 2)) %>%
  dplyr::select(Geneid, sample, TPM) %>%
  pivot_wider(names_from = sample, values_from = TPM) %>%
  dplyr::rename(ensembl_gene_id = Geneid) %>%
  filter(ensembl_gene_id %in% all_genes$ensembl_gene_id)



################################################################################
## Create hESC_data SE
################################################################################

rowdata <- TPM_values %>%
  dplyr::select(ensembl_gene_id) %>%
  left_join(dplyr::select(all_genes, ensembl_gene_id, external_gene_name)) %>%
  column_to_rownames("ensembl_gene_id")


hESC_data <- SummarizedExperiment(assays = column_to_rownames(TPM_values,
                                                              "ensembl_gene_id"),
                                  colData = coldata[, -1],
                                  rowData = rowdata)

save(hESC_data,
     file = "../../eh_data/hESC_data.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `TCGA_TPM` dataset goes here

library("TCGAbiolinks")
library("tidyverse")
library("SummarizedExperiment")
library("BiocFileCache")
library("org.Hs.eg.db")

load(file = "../../eh_data/GTEX_data.rda")

bfc <- BiocFileCache(cache = "../../../CTdata_extdata/BiocFileCache",
                     ask = FALSE)

# Load and save TCGA expression data
for(tumor_code in c("SKCM", "LUAD", "LUSC", "COAD", "ESCA",
                    "BRCA", "HNSC")) {

  rname <- paste0("TCGA_", tumor_code, "_STAR")
  if(length(bfcquery(bfc, rname)$rid) == 0) {

    savepath <- bfcnew(bfc, rname, ext=".RData")

    # Query data
    query_gene_counts_harmonized <-
      GDCquery(project = paste0("TCGA-", tumor_code),
               data.category = "Transcriptome Profiling",
               data.type = "Gene Expression Quantification",
               workflow.type = "STAR - Counts",
               legacy = FALSE)

    # Download files
    GDCdownload(query_gene_counts_harmonized, method = "api",
                directory = paste0("./tmp/TCGA_", tumor_code, "_STAR"),
                files.per.chunk = 20)

    # Create a Summarized-Experiment object
    GDCprepare(query_gene_counts_harmonized,
               directory = paste0("./tmp/TCGA_", tumor_code, "_STAR"),
               save = TRUE,
               save.filename = savepath,
               remove.files.prepared = FALSE)
  }
}

prepare_data <- function(tum) {
  rname <- paste0("TCGA_", tum, "_STAR")
  load(bfc[[bfcquery(bfc, rname)$rid]])

  assays(data) <- assays(data)["tpm_unstrand"]
  names(assays(data)) <- "TPM"

  data <- data[, colData(data)$shortLetterCode == "NT" |
                 colData(data)$shortLetterCode == "TP" |
                 colData(data)$shortLetterCode == "TM"]

  ## Remove duplicated ensembl ref associated to PAR_Y, and duplicated genes
  data <- data[grep("_PAR_", x = rownames(data), invert = TRUE, value = TRUE), ]
  data <- data[rowData(data)$gene_id[!duplicated(rowData(data)$gene_name)], ]
  ## Keep only genes present in Gtex data
  rownames(data) <- substr(rownames(data), 1, 15)
  data <- data[rownames(data) %in% rownames(GTEX_data), ]
  rowData(data) <- rowData(GTEX_data)[rownames(data), "external_gene_name"]
  names(rowData(data)) <- "external_gene_name"

  # Add frequencies of activation (TPM >= TPM_thr) of each gene in all tumor
  # samples.
  tumors_only <- data[ , colData(data)$shortLetterCode != 'NT']
  TPM_thr <- 1
  rowdata <- as_tibble(rowData(tumors_only), rownames = "ensembl_gene_id")
  binary <- ifelse(assay(tumors_only) >= TPM_thr, 1, 0)
  tmp <- rowSums(binary) / ncol(binary) * 100
  tmp <- enframe(tmp, name = "ensembl_gene_id",
                 value = paste0("percent_pos_", tum))
  rowdata <- left_join(rowdata, tmp)

  # Estimate the percent of tumors in which genes are repressed
  # (TPM < TPM_low_thr)
  TPM_low_thr <- 0.5
  binary <- ifelse(assay(tumors_only) <= TPM_low_thr, 1, 0)
  tmp <- rowSums(binary) / ncol(binary) * 100
  tmp <- enframe(tmp, name = "ensembl_gene_id",
                 value = paste0("percent_neg_", tum))
  rowdata <- rowdata %>%
    filter(ensembl_gene_id %in% rownames(GTEX_data)) %>%
    left_join(tmp)

  # Estimate the q75 expression in normal peritumoral tissues
  # (only when at least 20 NT samples =>
  # exclude SKCM and ESCA where not enough NT samples)
  # Will be used to filter out genes that are expressed in a high proportion of
  # peritumoral tissues => not strictly testis-specific
  NT_only <- data[ , colData(data)$shortLetterCode == 'NT']
  if (ncol(NT_only) >= 20) {
    q75_in_NT <-  tibble(ensembl_gene_id = rownames(NT_only),
                         q75 = rowQuantiles(assay(NT_only), probs = 0.75))
    names(q75_in_NT)[-1] <- paste0('TPM_q75_in_NT_', tum)
    rowdata <- rowdata %>%
      left_join(q75_in_NT)
  }

  # Max expression (TPM) in a tumor
  max_TPM <- tibble(ensembl_gene_id = rownames(tumors_only),
                    max_TPM = rowMax(assay(tumors_only)))
  names(max_TPM) <- c("ensembl_gene_id", paste0("max_TPM_in_", tum))

  rowData(data) <- rowdata %>%
    left_join(max_TPM)
  return(assign(x = paste0(tum, "_TPM"), value = data))
}

SKCM <- prepare_data(tum = "SKCM")
LUAD <- prepare_data(tum = "LUAD")
LUSC <- prepare_data(tum = "LUSC")
COAD <- prepare_data(tum = "COAD")
ESCA <- prepare_data(tum = "ESCA")
BRCA <- prepare_data(tum = "BRCA")
HNSC <- prepare_data(tum = "HNSC")

# # Sanity check
# all(rownames(SKCM) == rownames(LUAD),
#     rownames(SKCM) == rownames(LUSC),
#     rownames(SKCM) == rownames(COAD),
#     rownames(SKCM) == rownames(BRCA),
#     rownames(SKCM) == rownames(ESCA),
#     rownames(SKCM) == rownames(HNSC))

coldata_common_variables <-
  colnames(colData(SKCM))[
    colnames(colData(SKCM)) %in% colnames(colData(LUAD)) &
      colnames(colData(SKCM)) %in% colnames(colData(LUSC)) &
      colnames(colData(SKCM)) %in% colnames(colData(COAD)) &
      colnames(colData(SKCM)) %in% colnames(colData(ESCA)) &
      colnames(colData(SKCM)) %in% colnames(colData(BRCA)) &
      colnames(colData(SKCM)) %in% colnames(colData(HNSC))]

TPM <- cbind(assay(SKCM), assay(LUAD), assay(LUSC), assay(COAD),
             assay(ESCA), assay(BRCA), assay(HNSC))

rowdata <- as_tibble(rowData(SKCM)) %>%
  left_join(as_tibble(rowData(LUAD))) %>%
  left_join(as_tibble(rowData(LUSC))) %>%
  left_join(as_tibble(rowData(COAD))) %>%
  left_join(as_tibble(rowData(ESCA))) %>%
  left_join(as_tibble(rowData(BRCA))) %>%
  left_join(as_tibble(rowData(HNSC)))

coldata <- rbind(colData(SKCM)[, coldata_common_variables],
                 colData(LUAD)[, coldata_common_variables],
                 colData(LUSC)[, coldata_common_variables],
                 colData(COAD)[, coldata_common_variables],
                 colData(ESCA)[, coldata_common_variables],
                 colData(BRCA)[, coldata_common_variables],
                 colData(HNSC)[, coldata_common_variables])

## Add to colData `global hypomethylation levels` from paper:
## DNA methylation loss promotes immune evasion of tumours with high
## mutation and copy number load. Jang et al., Nature Commun 2019
## Keep also `CD8 T cells` and `Proliferation score` columns
global_hypo <- readxl::read_xlsx(
  "../../../CTdata_extdata/41467_2019_12159_MOESM4_ESM.xlsx", skip = 3)
names(global_hypo) <- c("project_id", "Sample", "global_methylation",
                        "CD8_T_cells", "proliferation_score")
global_hypo$project_id <- paste0("TCGA-", global_hypo$project_id)
coldata$Sample <- substr(coldata$sample, 1, 15)
coldata <- as_tibble(coldata) %>%
  left_join(global_hypo) %>%
  as.data.frame()
coldata <- column_to_rownames(coldata, "barcode")
TCGA_TPM <- SummarizedExperiment(assays = list(TPM = TPM),
                                 colData = coldata,
                                 rowData = rowdata)

# Add frequencies of activation (TPM >= TPM_thr) of each gene in all types of
# tumor samples.
tumors_only <- TCGA_TPM[, colData(TCGA_TPM)$shortLetterCode != 'NT']
TPM_thr <- 1
binary <- ifelse(assay(tumors_only) >= TPM_thr, 1, 0)
tmp <- rowSums(binary) / ncol(binary) * 100
tmp <- enframe(tmp, name = "ensembl_gene_id", value = "percent_pos_tum")
rowdata <- rowdata %>%
  left_join(tmp)

# Estimate the percent of tumors in which genes are repressed
# (TPM < TPM_low_thr)
TPM_low_thr <- 0.5
binary <- ifelse(assay(tumors_only) <= TPM_low_thr, 1, 0)
tmp <- rowSums(binary) / ncol(binary) * 100
tmp <- enframe(tmp, name = "ensembl_gene_id", value = "percent_neg_tum")
rowdata <- left_join(rowdata, tmp)

rowdata$max_TPM_in_TCGA <- rowMax(assay(tumors_only))
rowdata$max_q75_in_NT <- rowMax(as.matrix(
  rowdata %>% dplyr::select(starts_with("TPM_q75"))))

rowdata <- rowdata %>%
  mutate(TCGA_category = case_when(
    percent_neg_tum < 20 ~ "leaky",
    percent_neg_tum >= 20 & percent_pos_tum >= 1  &
      max_TPM_in_TCGA >= 5 ~ "activated",
    percent_neg_tum >= 20 & percent_pos_tum < 1 ~ "not_activated",
    percent_neg_tum >= 20 & percent_pos_tum >= 1 &
      max_TPM_in_TCGA < 5 ~ "lowly_activated"))


rowdata <- as.data.frame(rowdata)
rowdata <- column_to_rownames(rowdata, "ensembl_gene_id")

rowData(TCGA_TPM) <- rowdata

save(TCGA_TPM, file = "../../eh_data/TCGA_TPM.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `methylation_in_tissues` dataset goes here

library(GenomicRanges)
library(SummarizedExperiment)
library(Biostrings)
library(tidyverse)
library(liftOver)
library(AnnotationHub)
load("../../../CTdata_extdata/all_genes_prelim.rda")

# Download human genome fasta file
# download.file("http://ftp.ensembl.org/pub/release-104/fasta/homo_sapiens/dna/Homo_sapiens.GRCh38.dna.primary_assembly.fa.gz",
#               destfile = "../extdata/Homo_sapiens.GRCh38.dna.primary_assembly.fa.gz")
hg <- rtracklayer::import(
  "../../../CTdata_extdata/Homo_sapiens.GRCh38.dna.primary_assembly.fa",
  format = "fasta")

################################################################################
# Create a GRange with all CpG positions in hg38
################################################################################

## Initiate CT_methylation tibble
## Use whole genome => identify all CpGs positions
CpG_positions <- tibble()
chromosomes <- c(1:22, "X", "Y")
for (chr_number in chromosomes) {
  chromosome_ind <- grep(hg@ranges@NAMES,
                         pattern = paste0('dna:chromosome chromosome:GRCh38:',
                                          chr_number, ':'))
  # finds the row corresponding to selected chromosome
  chr_seq <- hg[chromosome_ind][[1]] # gets the sequence of selected chromosome
  chr_CG <- matchPattern("CG", chr_seq)
  # gets the coords of CpG dinucleotides on selected chromosome
  tmp <- as_tibble(as.data.frame(chr_CG@ranges)) %>%
    mutate(chr = paste0("chr", chr_number)) %>%
    mutate(CpG_pos = start) %>%
    dplyr::rename(Cytosine_fw = start, Cytosine_rev = end) %>%
    dplyr::select(chr, CpG_pos, Cytosine_fw, Cytosine_rev)
  CpG_positions <- rbind(CpG_positions, tmp)
}

CpG_positions_gr <- makeGRangesFromDataFrame(CpG_positions,
                                             keep.extra.columns = TRUE,
                                             seqnames.field = "chr",
                                             start.field = "Cytosine_fw",
                                             end.field = "Cytosine_rev")





################################################################################
## Create a table with methylation values of all CpG in normal tissues
################################################################################
met_in_tissues <- as_tibble(CpG_positions_gr) %>%
  dplyr::rename(chr = seqnames) %>%
  dplyr::select(chr, CpG_pos)
Encode_tissues <- c("adipose", "colon", "esophagus", "heart", "intestine",
                    "lung", "muscle", "pancreas", "placenta", "skin", "stomach",
                    "testis", "thyroid")

## WGBS bed files downloaded from ENCODE website
## adipose ENCFF318AMC.bed
## colon ENCFF157POM.bed
## esophagus ENCFF625GVK.bed
## heart ENCFF536RSX.bed
## intestine ENCFF241AQC.bed
## lung ENCFF039JFT.bed
## muscle ENCFF121ZES.bed
## pancreas ENCFF763RUE.bed
## placenta ENCFF437OKM.bed
## skin ENCFF219GCQ.bed
## stomach ENCFF497YOO.bed
## testis ENCFF715DMX.bed
## thyroid ENCFF223LJW.bed

for (cell in Encode_tissues) {

  bismark_file <- paste0("../../../CTdata_extdata/", cell, ".bed")
  bismark <- read_tsv(bismark_file, col_types = cols(.default = "?", X1 = 'c'),
                      col_names = FALSE)

  bismark <- bismark %>%
    dplyr::select(X1, X2, X6, X10, X11) %>%
    dplyr::rename(chr = X1, Start = X2, strand = X6,
                  reads = X10, score = X11) %>%
    filter(reads > 1) %>%
    mutate(start = Start + 1) %>%  # change coords to 1-based system
    mutate(CpG_pos = case_when(strand == '+' ~ start,
                               strand == '-' ~ start - 1)) %>%
    dplyr::select(chr, CpG_pos, strand, score)

  # Merge methylation value of fw-score and rev-score
  bismark_merge <- as_tibble(CpG_positions_gr) %>%
    dplyr::rename(chr = seqnames) %>%
    dplyr::select(chr, CpG_pos) %>%
    left_join(bismark %>%
                filter(strand == '+'),
              by = c("chr", "CpG_pos")) %>%
    dplyr::rename(fw_score = score) %>%
    dplyr::select(- strand) %>%
    left_join(bismark %>%
                filter(strand == '-'),
              by = c("chr", "CpG_pos")) %>%
    dplyr::rename(rev_score = score) %>%
    dplyr::select(- strand) %>%
    group_by(chr, CpG_pos) %>%
    dplyr::summarise(score = mean(c(fw_score, rev_score), na.rm = TRUE))

  names(bismark_merge) <- c("chr", "CpG_pos", cell)

  # Add methylation values for the tissue in CpG_methylation tibble
  met_in_tissues <- met_in_tissues %>%
    left_join(bismark_merge, by = c("chr", "CpG_pos"))
  rm(bismark_merge)
}

## Use sperm WGBS from SRR15427118
## raw data was processed with bismark (version 0.20.0)
bismark_file <- "../../../CTdata_extdata/SRR15427118_1_val_1_bismark_bt2_pe.bismark.cov.gz"
bismark <- read_tsv(bismark_file, col_types = cols(.default = "?", X1 = 'c'),
                    col_names = FALSE)

bismark <- bismark %>%
  dplyr::rename(chr = X1, start = X2, end = X3, score = X4,
                met = X5, unmet = X6) %>%
  dplyr::mutate(chr = paste0("chr", chr)) %>%
  mutate(nReads = met + unmet) %>%
  filter(nReads > 1) %>%
  dplyr::select(-nReads)

CG_pos_strand <- as_tibble(CpG_positions_gr) %>%
  dplyr::rename(chr = seqnames) %>%
  left_join(bismark, by = c("chr" = "chr", "start" = "start")) %>%
  dplyr::mutate(end = start + 1) %>%
  dplyr::select(chr, start, end, width, strand, CpG_pos, score, met, unmet)
CG_neg_strand <- as_tibble(CpG_positions_gr) %>%
  dplyr::rename(chr = seqnames) %>%
  left_join(bismark, by = c("chr" = "chr", "end" = "start")) %>%
  dplyr::select(chr, start, end, width, strand, CpG_pos, score, met, unmet)

bismark_merge <- rbind(CG_pos_strand, CG_neg_strand) %>%
  group_by(chr, CpG_pos) %>%
  dplyr::summarise(sperm = mean(c(score), na.rm = TRUE))

met_in_tissues <- met_in_tissues %>%
  left_join(bismark_merge)


#  Save as a RangedSummarizeExperiment
met_normal_tissues_gr <-
  makeGRangesFromDataFrame(met_in_tissues,
                           keep.extra.columns = FALSE,
                           seqnames.field = "chr",
                           start.field = "CpG_pos",
                           end.field = "CpG_pos")

CpG_methylation_in_tissues <- SummarizedExperiment(
  assays = as.matrix(met_in_tissues[, -(1:2)]),
  rowRanges = met_normal_tissues_gr)


## Keep only regions around each gene TSS
promoter_regions <- all_genes_prelim %>%
  mutate(start = transcription_start_site - 5000) %>%
  mutate(stop = transcription_start_site + 5000) %>%
  mutate(chromosome_name = paste0("chr", chromosome_name)) %>%
  mutate(strand = case_when(strand == 1 ~ "+", strand == -1 ~ "-"))

prom_gr <- makeGRangesFromDataFrame(promoter_regions,
                                    keep.extra.columns = TRUE,
                                    seqnames.field = "chromosome_name",
                                    start.field = "start",
                                    end.field = "stop")


methylation_in_tissues <- subsetByOverlaps(CpG_methylation_in_tissues, prom_gr)

save(methylation_in_tissues, file = "../../eh_data/methylation_in_tissues.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `FGC_sce` dataset goes here

library(tidyverse)
library(SingleCellExperiment)
library(scater)
library(biomaRt)

## Data from paper: Single-cell roadmap of human gonadal development
## (Garcia-Alonso, Nature 2022)
## (https://www.nature.com/articles/s41586-022-04918-4)

## ee58527e-e1e4-465d-8dc8-800ee40f14f2.rds data dowloaded from
## https://cellxgene.cziscience.com/collections/661a402a-2a5a-4c71-9b05-b346c57bc451Data

seur <- readRDS("../../../CTdata_extdata/ee58527e-e1e4-465d-8dc8-800ee40f14f2.rds")

FGC_sce <- SingleCellExperiment(
  assays = list(counts = as.matrix(seur@assays$RNA$counts)),
  colData = seur@meta.data)

## Normalization.
FGC_sce <- logNormCounts(FGC_sce)
levels(FGC_sce$sex) <- c("F", "M")

FGC_sce$type <- paste0(FGC_sce$sex, "_", FGC_sce$celltype)

# Keep coherently annotated cells
FGC_sce <- FGC_sce[, FGC_sce$type %in%
             c("F_PGC", "F_GC", "F_GC_mitotic",  "F_oogonia_STRA8",
               "F_oogonia_meiotic", "F_pre_oocyte", "F_oocyte",
               "M_PGC", "M_GC", "M_GC_mitotic", "M_pre_spermatogonia")]

FGC_sce$type[FGC_sce$type %in% c("F_GC", "F_GC_mitotic")] <- "F_GC"
FGC_sce$type[FGC_sce$type %in% c("M_GC", "M_GC_mitotic")] <- "M_GC"

## Merge cell types into 5 major germ cells states.
## See Supplementary Note 3 "Characterisation of germ cells" from paper.
# table(FGC_sce$type, FGC_sce$cell_type)
FGC_sce$Type <- FGC_sce$type
FGC_sce$type[FGC_sce$type %in% c("F_oogonia_STRA8", "F_oogonia_meiotic")] <- "F_oogonia"
FGC_sce$type[FGC_sce$type %in% c("F_pre_oocyte", "F_oocyte")] <- "F_oocyte"

FGC_sce$type <- factor(FGC_sce$type, levels =
                     c("F_PGC", "F_GC","F_oogonia", "F_oocyte",
                       "M_PGC", "M_GC", "M_pre_spermatogonia"))

FGC_sce$stage <- "pre-meiotic"
FGC_sce[, FGC_sce$type %in%
      c("F_oocyte")]$stage <- "meiotic"
FGC_sce$germcell <- TRUE

## Change FGC_sce rownames (from ensembl_id to gene names,
## keeping only official gene names)
ensembl <- biomaRt::useDataset("hsapiens_gene_ensembl", useMart("ensembl"))
attributes_vector <- c("ensembl_gene_id",
                       "external_gene_name",
                       "external_synonym",
                       "ensembl_transcript_id",
                       "external_transcript_name",
                       "chromosome_name",
                       "transcript_biotype",
                       "transcript_is_canonical")
transcripts_infos <- as_tibble(biomaRt::getBM(attributes = attributes_vector,
                                              mart = ensembl))
canonical_transcripts <- transcripts_infos %>%
  dplyr::filter(transcript_is_canonical == 1) %>%
  dplyr::filter(external_transcript_name != "") %>%
  dplyr::filter(chromosome_name %in% c(1:22, "X", "Y", "MT")) %>%
  dplyr::filter(transcript_biotype == "protein_coding" |
                  transcript_biotype == "lncRNA")

FGC_sce <- FGC_sce[rownames(FGC_sce) %in%
                     canonical_transcripts$ensembl_gene_id, ]
ensembl_gene <- as.data.frame(canonical_transcripts[,1:2]) %>% unique()
rownames(ensembl_gene) <- ensembl_gene$ensembl_gene_id
rownames(FGC_sce) <- ensembl_gene[rownames(FGC_sce),]$external_gene_name

save(FGC_sce, file = "../../eh_data/FGC_sce.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `normal_tissues_multimapping_data` dataset goes here

library("tidyverse")
library("SummarizedExperiment")
load("../../eh_data/GTEX_data.rda")

## RNAseq data from a set of normal tissues were downloaded from Encode.
## testis (ENCFF140UYT.fastq.gz, ENCFF794EAB.fastq.gz)
## thyroid_gland (ENCFF151GUG.fastq.gz, ENCFF628TMU.fastq.gz)
## gastrocnemius_medialis (ENCFF004CNM.fastq.gz, ENCFF086LCO.fastq.gz)
## adrenal_gland (ENCFF911BTP.fastq.gz, ENCFF904VHM.fastq.gz)
## thoracic_aorta (ENCFF661PVB.fastq.gz, ENCFF152GUK.fastq.gz)
## subcutaneous_adipose_tissue (ENCFF667CWY.fastq.gz, ENCFF360KZB.fastq.gz)
## stomach (ENCFF741NGG.fastq.gz, ENCFF582ILA.fastq.gz)
## upper_lobe_of_left_lung (ENCFF719YBM.fastq.gz, ENCFF801ZKX.fastq.gz)
## suprapubic_skin (ENCFF398KGB.fastq.gz, ENCFF058JYK.fastq.gz)
## breast_epithelium (ENCFF767QVV.fastq.gz, ENCFF050GYP.fastq.gz)
## lower_leg_skin (ENCFF431RAQ.fastq.gz, ENCFF008OVI.fastq.gz)
## sigmoid_colon (ENCFF153ULW.fastq.gz, ENCFF182OWD.fastq.gz)
## transverse_colon (ENCFF411UIT.fastq.gz, ENCFF992NAN.fastq.gz)
## spleen (ENCFF567ORO.fastq.gz, ENCFF743QDT.fastq.gz)
## gastroesophageal_sphincter (ENCFF250BPC.fastq.gz, ENCFF842DCO.fastq.gz)
## tibial_nerve (ENCFF534AYT.fastq.gz, ENCFF935LBC.fastq.gz)
## esophagus_muscularis_mucosa (ENCFF091UZU.fastq.gz, ENCFF163DLM.fastq.gz)
## omental_fat_pad (ENCFF745PTG.fastq.gz, ENCFF824ZLA.fastq.gz)
## esophagus_squamous_epithelium (ENCFF585TOW.fastq.gz, ENCFF230GLF.fastq.gz)

## Data was processed using a standard RNAseq pipeline including
## [FastQC](https://www.bioinformatics.babraham.ac.uk/projects/fastqc/) for the
## quality control of the raw data, and
## [trimmomatic](http://www.usadellab.org/cms/?page=trimmomatic)
## to remove low quality reads and trim the adapter from the sequences.
## [hisat2](https://ccb.jhu.edu/software/hisat2/index.shtml) was used to align
## reads to grch38 genome.
## [featurecounts](https://rdrr.io/bioc/Rsubread/man/featureCounts.html) was
## used to assign reads to genes using Homo_sapiens.GRCh38.94.gtf.

## Two different pipelines were run in order to remove or not multi-mapping
## reads.
## When multi-mapping was allowed, hisat2 was run with -k 20 parameter (reports
## up to 20 alignments per read), and featurecounts was run with -M parameter
## (multi-mapping reads are counted).

################################################################################
## Data generated without allowing multi-mapping
################################################################################

load("../../../CTdata_extdata/normal_tissues_RNAseq_coldata.rda")
load("../../../CTdata_extdata/normal_tissues_RNAseq_raw_counts.rda")

## TPM normalisation
## Keep only genes present in GTEx database
gene_lengths <-
  read_table("../../../CTdata_extdata/adrenal_gland_featurecounts.tsv",
             skip = 1) %>%
  dplyr::select(Geneid, Length)
x1 <- raw_counts / gene_lengths$Length * 1000
total <- colSums(x1)

TPM_matrix_no_multimapping <- as_tibble(x1, rownames = "Geneid") %>%
  gather(sample, counts, -Geneid) %>%
  left_join(enframe(total) %>%
              dplyr::rename(sample = name, total = value)) %>%
  mutate(TPM = round(counts / total * 1000000, 2)) %>%
  dplyr::select(Geneid, sample, TPM) %>%
  spread(sample, TPM) %>%
  dplyr::rename(ensembl_gene_id = Geneid) %>%
  right_join(as_tibble(rowData(GTEX_data), rownames = "ensembl_gene_id") %>%
               dplyr::select(ensembl_gene_id, external_gene_name)) %>%
  dplyr::select(ensembl_gene_id, external_gene_name, everything())

mat_no_multimapping <- as.matrix(TPM_matrix_no_multimapping[, -c(1:2)])
rownames(mat_no_multimapping) <- TPM_matrix_no_multimapping$ensembl_gene_id

################################################################################
## Data generated when allowing multi-mapping
################################################################################

load(file = "../../../CTdata_extdata/normal_tissues_RNAseq_raw_counts_multiM.rda")

## Normalise in TPM
## Keep only genes present in GTEx database
x1 <- raw_counts_with_MP / gene_lengths$Length * 1000
total <- colSums(x1)

TPM_matrix_with_multimapping <- as_tibble(x1, rownames = "Geneid") %>%
  gather(sample, counts, -Geneid) %>%
  left_join(enframe(total) %>%
              dplyr::rename(sample = name, total = value)) %>%
  mutate(TPM = round(counts / total * 1000000, 2)) %>%
  dplyr::select(Geneid, sample, TPM) %>%
  spread(sample, TPM) %>%
  dplyr::rename(ensembl_gene_id = Geneid) %>%
  right_join(as_tibble(rowData(GTEX_data), rownames = "ensembl_gene_id") %>%
               dplyr::select(ensembl_gene_id, external_gene_name)) %>%
  dplyr::select(ensembl_gene_id, external_gene_name, everything())

mat_with_multimapping <- as.matrix(TPM_matrix_with_multimapping[, -c(1:2)])
rownames(mat_with_multimapping) <- TPM_matrix_with_multimapping$ensembl_gene_id

################################################################################
## Assess testis-specificity of genes flagged as "lowly_expressed" in
## GTEX_category from GTEX_data (when their TPM < 1 in testis)
################################################################################
## Many Cancer-Testis genes belong to gene families from which members
## have identical or nearly identical sequences. This is likely the reason
## why these genes are not detected in GTEx database, as GTEX processing
## pipeline specifies that overlapping intervals between genes are excluded
## from all genes for counting.
## Testis specificity of genes flagged as "lowly_expressed" in GTEX_category
## could however be assessed by comparing expression values obtained by
## counting or not multi-mapped reads in a set of normal tissues.
## Some of these genes are indeed only detected when multimapping reads are
## not discarded.
## Genes flagged as "testis_specific" in `multimapping_analysis` column must be
## detectable in testis (TPM >= 1) when multimapping is allowed, their TPM
## value must have increased when multimapping is allowed (ratio > 5), and
## these genes must also have a TPM value (obtained by allowing multimapping)
## at least 10 times higher in testis than in any other somatic tissue (where
## the maximum expression always has to be below 1 TPM).

ratio_multi_not_multi <- as_tibble(mat_no_multimapping,
                                   rownames = "ensembl_gene_id") %>%
  dplyr::select(ensembl_gene_id, testis) %>%
  dplyr::rename(TPM_testis_no_multi = testis) %>%
  left_join(as_tibble(mat_with_multimapping, rownames = "ensembl_gene_id") %>%
              dplyr::select(ensembl_gene_id, testis) %>%
              dplyr::rename(TPM_testis_when_multi = testis)) %>%
  mutate(ratio = TPM_testis_when_multi / TPM_testis_no_multi)

max_in_somatic <- rowMax(
  mat_with_multimapping[, -which(colnames(mat_with_multimapping) == "testis")])
max_not_testis <- tibble(ensembl_gene_id = rownames(mat_with_multimapping),
                         max_in_somatic = max_in_somatic)

genes_testis_specific_in_multimapping <- ratio_multi_not_multi %>%
  left_join(max_not_testis) %>%
  mutate(ratio_testis_other = TPM_testis_when_multi / max_in_somatic) %>%
  left_join(as_tibble(rowData(GTEX_data), rownames = "ensembl_gene_id")) %>%
  mutate(multimapping_analysis = case_when(
    GTEX_category != "lowly_expressed" ~ "not_analysed",
    GTEX_category == "lowly_expressed" & TPM_testis_when_multi >= 1 &
      ratio >= 5 & ratio_testis_other >= 10 &
      max_in_somatic <= 1 ~ "testis_specific",
    GTEX_category == "lowly_expressed" & TPM_testis_when_multi >= 1 &
      ratio >= 5 & ratio_testis_other >= 10 &
      max_in_somatic > 1 ~ "testis_preferential",
    GTEX_category == "lowly_expressed" &
      (TPM_testis_when_multi < 1 | ratio < 5 | ratio_testis_other < 10) ~
      "not_testis_specific"))
rowdata <-
  tibble(ensembl_gene_id = TPM_matrix_with_multimapping$ensembl_gene_id,
         external_gene_name =
           TPM_matrix_with_multimapping$external_gene_name) %>%
  left_join(genes_testis_specific_in_multimapping %>%
              dplyr::select(ensembl_gene_id, GTEX_category,
                            multimapping_analysis)) %>%
  mutate(lowly_expressed_in_GTEX = case_when(
    GTEX_category == "lowly_expressed" ~ TRUE,
    GTEX_category != "lowly_expressed" ~ FALSE)) %>%
  dplyr::select(ensembl_gene_id, external_gene_name,
                lowly_expressed_in_GTEX, multimapping_analysis)

rowdata$multimapping_analysis[rowdata$multimapping_analysis ==
                                "not_analysed"] <- NA

rowdata <- column_to_rownames(rowdata, "ensembl_gene_id")

################################################################################
## Create normal_tissues_multimapping SE
################################################################################

normal_tissues_multimapping_data <- SummarizedExperiment(
  assays = list(TPM_no_multimapping = mat_no_multimapping,
                TPM_with_multimapping = mat_with_multimapping),
  rowData = rowdata)

save(normal_tissues_multimapping_data,
     file = "../../eh_data/normal_tissues_multimapping_data.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `methylation_in_hESC` dataset goes here

library(GenomicRanges)
library(SummarizedExperiment)
library(Biostrings)
library(tidyverse)
library(liftOver)
library(AnnotationHub)
load("../../eh_data/all_genes.rda")
load("../../../CTdata_extdata/hESC_RNAseq_coldata.rda")


# Download human genome fasta file
# download.file("http://ftp.ensembl.org/pub/release-104/fasta/homo_sapiens/dna/Homo_sapiens.GRCh38.dna.primary_assembly.fa.gz",
#               destfile = "/data/cbio/GENOMES/Homo_sapiens.GRCh38.dna.primary_assembly.fa.gz")
hg <- rtracklayer::import(
  "../../../CTdata_extdata/Homo_sapiens.GRCh38.dna.primary_assembly.fa",
  format = "fasta")

################################################################################
# Create a GRange with all CpG positions located in all genes promoters
################################################################################

## Initiate all_methylation tibble
## Use whole genome => identify all CpGs positions
CpG_positions <- tibble()
chromosomes <- c(1:22, "X", "Y")
for (chr_number in chromosomes) {
  chromosome_ind <- grep(hg@ranges@NAMES,
                         pattern = paste0('dna:chromosome chromosome:GRCh38:',
                                          chr_number, ':'))
  # finds the row corresponding to selected chromosome
  chr_seq <- hg[chromosome_ind][[1]] # gets the sequence of selected chromosome
  chr_CG <- matchPattern("CG", chr_seq)
  # gets the coords of CpG dinucleotides on selected chromosome
  tmp <- as_tibble(as.data.frame(chr_CG@ranges)) %>%
    mutate(chr = paste0("chr", chr_number)) %>%
    mutate(CpG_pos = start) %>%
    dplyr::rename(Cytosine_fw = start, Cytosine_rev = end) %>%
    dplyr::select(chr, CpG_pos, Cytosine_fw, Cytosine_rev)
  CpG_positions <- rbind(CpG_positions, tmp)
}

CpG_positions_gr <- makeGRangesFromDataFrame(CpG_positions,
                                             keep.extra.columns = TRUE,
                                             seqnames.field = "chr",
                                             start.field = "Cytosine_fw",
                                             end.field = "Cytosine_rev")


## Keep only regions around each TSS
all_promoter_regions <- all_genes %>%
  mutate(start = transcription_start_site - 5000) %>%
  mutate(stop = transcription_start_site + 5000) %>%
  mutate(chromosome_name = paste0("chr", chr)) %>%
  mutate(strand = case_when(strand == 1 ~ "+", strand == -1 ~ "-"))

all_list_prom_gr <- makeGRangesFromDataFrame(all_promoter_regions,
                                             keep.extra.columns = TRUE,
                                             seqnames.field = "chromosome_name",
                                             start.field = "start",
                                             end.field = "stop")


prom_CpG_positions_gr <- subsetByOverlaps(CpG_positions_gr, all_list_prom_gr)


################################################################################
## Create a table with methylation values of CpG located in promoters
## in hESC
################################################################################
met_in_hESC <- as_tibble(prom_CpG_positions_gr) %>%
  dplyr::rename(chr = seqnames) %>%
  dplyr::select(chr, CpG_pos)
Encode_cells <- c("H1", "HUES64", "H9")

## WGBS data from embryonic stem cells were downloaded from Encode.
## H1  (ENCFF601NBW.bed.gz)
## H9  (ENCFF975CVU.bed.gz)
## HUES64 (ENCFF770UYJ.bed.gz)


for (cell in Encode_cells) {

  bismark_file <- paste0("../../../CTdata_extdata/", cell, ".bed.gz")
  bismark <- read_tsv(bismark_file, col_types = cols(.default = "?", X1 = 'c'),
                      col_names = FALSE)

  bismark <- bismark %>%
    dplyr::select(X1, X2, X6, X10, X11) %>%
    dplyr::rename(chr = X1, Start = X2, strand = X6,
                  reads = X10, score = X11) %>%
    filter(reads > 1) %>%
    mutate(start = Start + 1) %>%  # change coords to 1-based system
    mutate(CpG_pos = case_when(strand == '+' ~ start,
                               strand == '-' ~ start - 1)) %>%
    dplyr::select(chr, CpG_pos, strand, score)

  # Merge methylation value of fw-score and rev-score
  bismark_merge <- as_tibble(prom_CpG_positions_gr) %>%
    dplyr::rename(chr = seqnames) %>%
    dplyr::select(chr, CpG_pos) %>%
    left_join(bismark %>%
                filter(strand == '+'),
              by = c("chr", "CpG_pos")) %>%
    dplyr::rename(fw_score = score) %>%
    dplyr::select(- strand) %>%
    left_join(bismark %>%
                filter(strand == '-'),
              by = c("chr", "CpG_pos")) %>%
    dplyr::rename(rev_score = score) %>%
    dplyr::select(- strand) %>%
    group_by(chr, CpG_pos) %>%
    dplyr::summarise(score = mean(c(fw_score, rev_score), na.rm = TRUE))

  names(bismark_merge) <- c("chr", "CpG_pos", cell)
  rm(bismark)

  # Add methylation values for the tissue in CpG_methylation tibble
  met_in_hESC <- met_in_hESC %>%
    left_join(bismark_merge, by = c("chr", "CpG_pos"))
  rm(bismark_merge)
}


################################################################################
## Add coldata and save as a Ranged SE
################################################################################

coldata <- as.data.frame(coldata) %>%
  mutate(cell_type = "hESC") %>%
  mutate(genotype = factor(genotype, levels = c("XX", "XY"))) %>%
  mutate(dataset = "Encode") %>%
  mutate(data = "Methylation") %>%
  dplyr::select(-files) %>%
  column_to_rownames("sample")


methylation_hESC_gr <- makeGRangesFromDataFrame(met_in_hESC,
                                                   keep.extra.columns = FALSE,
                                                   seqnames.field = "chr",
                                                   start.field = "CpG_pos",
                                                   end.field = "CpG_pos")

methylation_in_hESC <- SummarizedExperiment(
  assays = as.matrix(met_in_hESC[, -(1:2)]),
  rowRanges = methylation_hESC_gr,
  colData = coldata[colnames(met_in_hESC[, -(1:2)]), ])

save(methylation_in_hESC,
     file = "../../eh_data/methylation_in_hESC.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `CpG_positions_all_prom_hg19` and `all_promoter_regions_hg19`
## intermediate datasets goes here

library(tidyverse)
library(GenomicRanges)
library(liftOver)
library(AnnotationHub)
load("../../eh_data/all_genes.rda")


# Download human genome fasta file

# download.file("http://ftp.ensembl.org/pub/release-73/fasta/homo_sapiens/dna/Homo_sapiens.GRCh37.73.dna.primary_assembly.fa.gz",
#               destfile = "/storage/research/dduv/cbio-lg/cluster/GENOMES/Homo_sapiens.GRCh37.73.dna.primary_assembly.fa.gz")

hg <- rtracklayer::import("../../../CTdata_extdata/Homo_sapiens.GRCh37.73.dna.primary_assembly.fa.gz",
                          format = "fasta")

################################################################################
# Create a Grange with all CpG positions in hg19
################################################################################

## Initiate CT_methylation tibble
## Use whole genome => identify all CpGs positions
CpG_positions <- tibble()
chromosomes <- c(1:22, "X", "Y")
for (chr_number in chromosomes){
  chromosome_ind <- grep(hg@ranges@NAMES,
                         pattern = paste0('dna:chromosome chromosome:GRCh37:',
                                          chr_number,':'))
  # finds the row corresponding to selected chromosome
  chr_seq <- hg[chromosome_ind][[1]] # gets the sequence of selected chromosome
  chr_CG <- Biostrings::matchPattern("CG", chr_seq)
  # gets the coords of CpG dinucleotides on selected chromosome
  tmp <- as_tibble(as.data.frame(chr_CG@ranges))%>%
    mutate(chr = paste0("chr", chr_number)) %>%
    mutate(CpG_pos = start) %>%
    dplyr::rename(Cytosine_fw = start, Cytosine_rev = end) %>%
    dplyr::select(chr, CpG_pos, Cytosine_fw, Cytosine_rev)
  CpG_positions <- rbind(CpG_positions, tmp)
}

CpG_positions_GR <- makeGRangesFromDataFrame(CpG_positions,
                                             keep.extra.columns = TRUE,
                                             seqnames.field = "chr",
                                             start.field = "Cytosine_fw",
                                             end.field = "Cytosine_rev")

################################################################################
# Create a table with all genes TSS in hg19 to lift it to hg19
################################################################################

# download.file("http://hgdownload.cse.ucsc.edu/goldenpath/hg38/liftOver/hg38ToHg19.over.chain.gz",
#               destfile = "../../../CTdata_extdata/hg38ToHg19.over.chain.gz")
# Has to be unziped for next line to work

chain <- rtracklayer::import("../../../CTdata_extdata/hg38ToHg19.over.chain")

all_genes_liftover <- all_genes
all_genes_liftover$chr <- paste0("chr", all_genes_liftover$chr)
all_genes_liftover$strand[all_genes_liftover$strand == 1] <- '+'
all_genes_liftover$strand[all_genes_liftover$strand == -1] <- '-'

all_genes_TSS_liftover_GR <- makeGRangesFromDataFrame(all_genes_liftover,
                                                      keep.extra.columns = TRUE,
                                                      seqnames.field = "chr",
                                                      start.field = "transcription_start_site",
                                                      end.field = "transcription_start_site")

# convert TSS to hg19
all_genes_TSS_liftover <- unlist(liftOver(all_genes_TSS_liftover_GR, chain))

# genes were lost in the liftover procedure: incl 2 CT "FAM230C" and "FLJ36000"
# all_genes$external_gene_name[!all_genes$external_gene_name %in%
#                                all_genes_TSS_liftover$external_gene_name]

liftover_TSS <- tibble(external_gene_name = all_genes_TSS_liftover$external_gene_name,
                       TSS_liftover = all_genes_TSS_liftover@ranges@start)

################################################################################
# Define promoter regions for all genes in hg19
################################################################################

all_genes_hg19 <- all_genes %>%
  left_join(liftover_TSS) %>%
  dplyr::select(ensembl_gene_id, external_gene_name, family, chr, strand,
                transcription_start_site, TSS_liftover, everything())

nt_up <- 1000
nt_down <- 1000

all_promoter_regions_hg19 <- all_genes_hg19 %>%
  mutate(start = case_when(strand == 1 ~ TSS_liftover - nt_up,
                           strand == -1 ~ TSS_liftover - nt_down)) %>%
  mutate(stop = case_when(strand == 1 ~ TSS_liftover + nt_down,
                          strand == -1 ~ TSS_liftover + nt_up)) %>%
  mutate(chromosome_name = paste0("chr", chr)) %>%
  mutate(strand = case_when(strand == 1 ~ "+",
                            strand == -1 ~ "-"))
all_promoter_regions_hg19_GR <- makeGRangesFromDataFrame(all_promoter_regions_hg19 %>%
                                                           filter(!is.na(start)),
                                                         keep.extra.columns = TRUE,
                                                         seqnames.field = "chromosome_name",
                                                         start.field = "start",
                                                         end.field = "stop")
all_promoter_regions_hg19 <- all_promoter_regions_hg19_GR

save(all_promoter_regions_hg19,
     file = "../extdata/all_promoter_regions_hg19.rda",
     compress = "xz",
     compression_level = 9)


################################################################################
# Create a GRange with CpGs in promoters
################################################################################

CpG_positions_all_prom_hg19 <- subsetByOverlaps(CpG_positions_GR,
                                                all_promoter_regions_hg19_GR)
save(CpG_positions_all_prom_hg19,
     file = "../extdata/CpG_positions_all_prom_hg19.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `mean_methylation_in_embryo` dataset goes here

library("tidyverse")
library("GenomicRanges")
library("SummarizedExperiment")

load("../extdata/all_promoter_regions_hg19.rda")
load("../../eh_data/methylation_in_embryo.rda")
load("../../eh_data/all_genes.rda")



################################################################################
# Define promoter regions
################################################################################

## Promoter region is defined as `nt_up` nucleotides upstream TSS
## and `nt_down` nucleotides downstream TSS
nt_up <- 1000
nt_down <- 500

all_promoter_regions <- as_tibble(all_promoter_regions_hg19) %>%
  dplyr::select(external_gene_name, chr, TSS_liftover, strand) %>%
  mutate(start = case_when(strand == "+" ~ TSS_liftover - nt_up,
                           strand == "-" ~ TSS_liftover - nt_down)) %>%
  mutate(stop = case_when(strand == "+" ~ TSS_liftover + nt_down,
                          strand == "-" ~ TSS_liftover + nt_up)) %>%
  mutate(chromosome_name = paste0("chr", chr))

all_prom_GR <- makeGRangesFromDataFrame(all_promoter_regions,
                                        keep.extra.columns = TRUE,
                                        seqnames.field = "chromosome_name",
                                        start.field = "start",
                                        end.field = "stop")

gene_ids <- all_genes %>%
  dplyr::select("ensembl_gene_id", "external_gene_name") %>%
  filter(external_gene_name %in% all_prom_GR$external_gene_name)

all_prom_GR$ensembl_gene_id <- gene_ids$ensembl_gene_id


################################################################################
# Compute mean meth for all promoters
################################################################################

mean_meth <- tibble(cell = colnames(methylation_in_embryo))

for (i in 1:length(all_prom_GR)) {
  print(i)
  tested_gene_GR <- subsetByOverlaps(methylation_in_embryo, all_prom_GR[i])
  mat <- assay(tested_gene_GR)
  tmp <- enframe(colMeans(mat, na.rm = TRUE), name = "cell",
                 value = all_prom_GR[i]$external_gene_name)
  mean_meth <- suppressMessages(left_join(mean_meth, tmp))
}


mat <- t(as.matrix(mean_meth[,-1]))
colnames(mat) <- mean_meth$cell

################################################################################
# Save it as a RangedSE
################################################################################

mean_methylation_in_embryo <-
  SummarizedExperiment(assays = mat ,
                       colData = colData(methylation_in_embryo),
                       rowRanges = all_prom_GR)

save(mean_methylation_in_embryo,
     file = "../../eh_data/mean_methylation_in_embryo.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `mean_methylation_in_hESC` dataset goes here

library(GenomicRanges)
library(tidyverse)
library(SummarizedExperiment)

load("../../eh_data/all_genes.rda")
load("../../eh_data/methylation_in_hESC.rda")
load("../../../CTdata_extdata/hESC_RNAseq_coldata.rda")

## Promoter region is defined as `nt_up` nucleotides upstream TSS
## and `nt_down` nucleotides downstream TSS
nt_up <- 1000
nt_down <- 200


## Calculate mean methylation of each promoter in cell types
## and store CpG number by promoter
prom_mean_met_in_hESC <- tibble(cell = c(colnames(methylation_in_hESC)))

for (gene in all_genes$external_gene_name) {
  print(which(all_genes$external_gene_name == gene))
  TSS <- all_genes %>%
    filter(external_gene_name == gene) %>%
    pull(transcription_start_site)

  chr <- all_genes %>%
    filter(external_gene_name == gene) %>%
    pull(chr)

  strand <- all_genes %>%
    filter(external_gene_name == gene) %>%
    pull(strand)

  if (strand == 1) { # Analyse region at +/- nt_up and nt_down around TSS
    promoter_gr <- GRanges(seqnames = paste0("chr", chr),
                           strand = '+',
                           ranges = IRanges(start = TSS - nt_up,
                                            end = TSS + nt_down))
    promoter_gr$TSS <- TSS
  }

  if (strand == -1) { # Analyse region at +/- nt_up and nt_down around TSS
    promoter_gr <- GRanges(seqnames = paste0("chr", chr),
                           strand = '-',
                           ranges = IRanges(start = TSS - nt_down,
                                            end = TSS + nt_up))
    promoter_gr$TSS <- TSS
  }

  promoter_methylation <- subsetByOverlaps(methylation_in_hESC,
                                           promoter_gr)
  tmp <- enframe(colMeans(assay(promoter_methylation), na.rm = TRUE),
                 name = "cell", value = gene)

  prom_mean_met_in_hESC <- left_join(prom_mean_met_in_hESC, tmp)
}


## Store mean methylation level by cell type by promoter
prom_mean_met_in_hESC <- prom_mean_met_in_hESC %>%
  pivot_longer(names_to = "external_gene_name", values_to = "mean_methylation",
               -cell) %>%
  mutate(mean_methylation = as.numeric(mean_methylation)) %>%
  pivot_wider(names_from = cell, values_from = mean_methylation)

################################################################################
## Add coldata and save as a SE
################################################################################

mat <- prom_mean_met_in_hESC %>%
  dplyr::select(-external_gene_name) %>%
  as.matrix()
rownames(mat) <- prom_mean_met_in_hESC$external_gene_name

coldata <- as.data.frame(coldata) %>%
  mutate(cell_type = "hESC") %>%
  mutate(genotype = factor(genotype, levels = c("XX", "XY"))) %>%
  mutate(dataset = "Encode") %>%
  mutate(data = "Methylation") %>%
  dplyr::select(-files) %>%
  column_to_rownames("sample")

rowdata <- all_genes %>%
  dplyr::select(external_gene_name, ensembl_gene_id) %>%
  column_to_rownames("external_gene_name")

mean_methylation_in_hESC <- SummarizedExperiment(assays = mat,
                                                 colData =
                                                   coldata[colnames(mat), ],
                                                 rowData = rowdata)

save(mean_methylation_in_hESC,
     file = "../../eh_data/mean_methylation_in_hESC.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `CCLE_correlation_matrix` dataset goes here

library("tidyverse")
load("../../eh_data/CCLE_data.rda")
load("../../eh_data/CT_genes.rda")

x <- as_tibble(assay(CCLE_data), rownames = "ensembl_gene_id") %>%
  pivot_longer(names_to = "cell_line", values_to = "TPM", -ensembl_gene_id) %>%
  mutate(TPM = log1p(TPM)) %>%
  pivot_wider(names_from = ensembl_gene_id, values_from = TPM) %>%
  dplyr::select(-cell_line) %>%
  as.matrix()

CCLE_correlation_matrix <- cor(x, method = "pearson")

CCLE_correlation_matrix <- CCLE_correlation_matrix[CT_genes$ensembl_gene_id, ]

save(CCLE_correlation_matrix,
     file = "../../eh_data/CCLE_correlation_matrix.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `oocytes_sce` dataset goes here

library(tidyverse)
library(SingleCellExperiment)
library(scater)
library(biomaRt)

## Data from paper: Decoding dynamic epigenetic landscapes in human oocytes
## using single-cell multi-omics sequencing (Yan et al. Cell Stem Cell 2021)

## `GSE154762_hO_scChaRM_count_matix.txt.gz` was downloaded from GEO (accession:
## GSE154762).

table <- read_table(file = "../../../CTdata_extdata/GSE154762_hO_scChaRM_count_matix.txt.gz",
                    skip = 1, col_names = F)
header <- read_table(file = "../../../CTdata_extdata/GSE154762_hO_scChaRM_count_matix.txt.gz",
                     col_names = F,  n_max = 1)
colnames(table) <- c("gene", header)

metadata <- tibble(cell = colnames(table)[-1],
                   type = gsub("RNA_", "", cell)) %>%
  mutate(type = gsub("_sc.*$", "", type)) %>%
  mutate(type = case_when(type %in% c("GO1", "GO2") ~ "Growing oocytes",
                          type == "FGO" ~ "Fully grown oocytes",
                          type == "MI" ~ "Metaphase I",
                          type == "MII" ~ "Metaphase II",
                          !type %in% c("GO1", "GO2") ~ type)) %>%
  mutate(type = factor(type, levels =
                         c("Growing oocytes", "Fully grown oocytes",
                           "Metaphase I", "Metaphase II", "Granulosa",
                           "Immune", "StromaC1", "StromaC2"))) %>%
  mutate(sex = "F", stage = "meiotic") %>%
  mutate(germcell = ifelse(
    type %in% c("Growing oocytes", "Fully grown oocytes",
                "Metaphase I", "Metaphase II"), TRUE, FALSE))

# Some gene names are not the official ones!
ensembl <- biomaRt::useDataset("hsapiens_gene_ensembl", useMart("ensembl"))
attributes_vector <- c("ensembl_gene_id",
                       "external_gene_name",
                       "external_synonym",
                       "ensembl_transcript_id",
                       "external_transcript_name",
                       "chromosome_name",
                       "transcript_biotype",
                       "transcript_is_canonical")
transcripts_infos <- as_tibble(biomaRt::getBM(attributes = attributes_vector,
                                              mart = ensembl))
canonical_transcripts <- transcripts_infos %>%
  dplyr::filter(transcript_is_canonical == 1) %>%
  dplyr::filter(external_transcript_name != "") %>%
  dplyr::filter(chromosome_name %in% c(1:22, "X", "Y", "MT")) %>%
  dplyr::filter(transcript_biotype == "protein_coding" |
                  transcript_biotype == "lncRNA")



counts_correct_gene_names <- table %>%
  filter(gene %in% canonical_transcripts$external_gene_name)

counts_incorrect_gene_names <- table %>%
  filter(!gene %in% canonical_transcripts$external_gene_name)

# Change incorrect genes names using official ones, when possible
counts_incorrect_gene_names_rescued <- counts_incorrect_gene_names %>%
  left_join(canonical_transcripts %>%
              dplyr::select(ensembl_gene_id, external_gene_name,
                            external_synonym),
            by = c("gene" = "external_synonym")) %>%
  dplyr::select(gene, ensembl_gene_id, external_gene_name, everything()) %>%
  filter(!is.na(external_gene_name)) %>%
  filter(!external_gene_name %in% counts_correct_gene_names$gene) %>%
  filter(!duplicated(external_gene_name)) %>%
  dplyr::select(-gene, -ensembl_gene_id) %>%
  dplyr::rename(gene = external_gene_name)

# Some synonymes have "ORF" instead of "orf" in their names!
# ! Convert genes with "orf" in their names to "ORF" !
# Example: problem with MAJIN gene, called C11orf85 in testis dataset
# and C11ORF85 in canonical_transcripts$external_synonym
counts_incorrect_gene_names_rescued_bis <- counts_incorrect_gene_names %>%
  left_join(canonical_transcripts %>%
              dplyr::select(ensembl_gene_id, external_gene_name,
                            external_synonym) %>%
              mutate(gene = gsub("ORF", x = external_synonym, replace = "orf"))) %>%
  dplyr::select(gene, ensembl_gene_id, external_gene_name, , everything()) %>%
  filter(!is.na(external_gene_name)) %>%
  filter(!external_gene_name %in% counts_correct_gene_names$gene) %>%
  filter(!duplicated(external_gene_name)) %>%
  dplyr::select(-gene, -ensembl_gene_id) %>%
  dplyr::rename(gene = external_gene_name) %>%
  dplyr::select(-external_synonym)

counts <- rbind(counts_correct_gene_names,
                counts_incorrect_gene_names_rescued,
                counts_incorrect_gene_names_rescued_bis)

counts <- rbind(counts_correct_gene_names, counts_incorrect_gene_names)

mat <- as.matrix(counts[, -1])
rownames(mat) <- counts$gene
coldata <- data.frame(metadata[,-1], row.names = metadata$cell)

oocytes_sce <- SingleCellExperiment(assays =
                                    list(counts = mat[, rownames(coldata)]),
                                   colData = coldata)
oocytes_sce <- logNormCounts(oocytes_sce)

save(oocytes_sce, file = "../../eh_data/oocytes_sce.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `embryo_sce_Zhu` dataset goes here

library(tidyverse)
library(biomaRt)
library(SingleCellExperiment)


## Data from Single-Cell RNA-Seq Reveals Lineage and X Chromosome Dynamics in
## Human Preimplantation Embryos (Petropulous et al, 2014)


## Processed data in RPKM was downloaded here
## https://www.ebi.ac.uk/biostudies/files/E-MTAB-3929/rpkm.txt

## Sample metadata was downloaded here
## https://www.ebi.ac.uk/biostudies/files/E-MTAB-3929/E-MTAB-3929.sdrf.txt

counts <- read_tsv("../../../CTdata_extdata/Petropoulos_rpkm.txt")

mat <- as.matrix(counts[,-1])
rownames(mat) <- counts$...1

metadata <- read_tsv("../../../CTdata_extdata/Petropoulos_metadata.txt")
coldata <- as.data.frame(metadata)
rownames(coldata) <- coldata$`Source Name`

coldata$day <- coldata$`Characteristics[developmental stage]`
coldata$day <- gsub(pattern = "embryonic day ", x = coldata$day,
                    replacement = "E")
coldata$stage <- ifelse(coldata$day == 'E3', "Morula", "Blastocyst")
coldata$stage <- factor(coldata$stage, levels = c("Morula", "Blastocyst"))
coldata$individual <- coldata$`Characteristics[individual]`
coldata$lineage <- coldata$`Characteristics[inferred lineage]`
coldata$singleCellWellQuality <- coldata$`Characteristics[single cell well quality]`
colnames(coldata)[1] <- "sample"
coldata <- coldata[, c(1,46:50)]

embryo_sce_Petropoulos <- SingleCellExperiment(assays = mat[, rownames(coldata)],
                                               colData = coldata)


## Determine embryo sex
## Inference of Embryonic sex : Identify Y linked to use for sex determination
## Genes should be highly expressed in some cells, with a clear cutoff in
## approximatively 50% of sample. Determine sex separately for each stage (day)
## as expression levels of Y-linked genes can be quite different at each stage


# Identify Y genes highly expressed in the dataset
# Y-linked genes highly expressed in the dataset and highly variable
# (should be highly expressed in males but not in females)

ensembl <- biomaRt::useDataset("hsapiens_gene_ensembl", useMart("ensembl"))

attributes_vector <-  c("ensembl_gene_id", "external_gene_name",
                        "ensembl_transcript_id", "external_transcript_name",
                        "chromosome_name", "strand", "transcript_start",
                        "transcript_end", "transcription_start_site",
                        "transcript_length", "transcript_tsl",
                        "transcript_gencode_basic", "transcript_appris",
                        "transcript_mane_select", "transcript_biotype",
                        "transcript_is_canonical" )

transcripts_infos <-  as_tibble(biomaRt::getBM(attributes = attributes_vector,
                                               mart = ensembl))

Y_linked <- transcripts_infos %>%
  filter(external_gene_name %in% rownames(embryo_sce_Petropoulos)) %>%
  filter(chromosome_name == "Y") %>%
  pull(external_gene_name) %>%
  unique()

Y_linked <- Y_linked[Y_linked %in% rownames(embryo_sce_Petropoulos)]

# Remove Y linked genes almost not detected in the dataset
x <- tibble(gene = Y_linked,
            detected_in_percent_cells =
              rowSums(assay(embryo_sce_Petropoulos)[Y_linked, ] > 0) /
              ncol(embryo_sce_Petropoulos),
            sumY = rowSums(assay(embryo_sce_Petropoulos)[Y_linked, ]),
            var = rowVars(assay(embryo_sce_Petropoulos)[Y_linked, ])) %>%
  arrange(desc(sumY)) %>%
  filter(detected_in_percent_cells > 0.1)



# Identify genes expressed with a clear cutoff in approximatively 50% of sample
# Genes expressed in much more than 50% of cells could be pseudoautosomal genes
# also detected in females

# Rapid check using RPS4Y1 gene (that seems to be a very good marker)
# Determine sex based on RPS4Y1 gene only and check the levels of
# other Y-linked genes to see if they are also good markers of male embryos

sex_approximation <- as_tibble(assay(embryo_sce_Petropoulos)["RPS4Y1", ],
                               rownames = "sample") %>%
  mutate(sex_approx = case_when(value > 0 ~ "M",
                                value == 0 ~ "F")) %>%
  arrange(value) %>%
  mutate(rank = seq_along(colnames(embryo_sce_Petropoulos)))

bad_markers <- c("SNORA70", "TMSB4Y", "RPS4Y2", "RBMY2FP")

Y_linked_selected <- x %>%
  filter(!gene %in% bad_markers)

# Used 11 genes for sex determination


## E3 embryos

day <- "E3"
sce <- embryo_sce_Petropoulos[, embryo_sce_Petropoulos$day == day]
sce$sumY <- colSums(assay(sce)[Y_linked_selected$gene, ])
ranks <- as_tibble(colData(sce)) %>%
  arrange(sumY) %>%
  mutate(rank = 1:ncol(sce)) %>%
  mutate(sex = case_when(sumY > 100 ~ "M",
                            sumY < 25 ~ "F",
                            sumY < 100 & sumY > 25 ~ NA))

# 2 embryos have conflicting results (E3.2 and E3.3)

# Flag embryos with conflicting sex results
# (i.e an individual where some cells would be flagged as F and other as M)

ambigous <- ranks %>%
  group_by(individual, sex) %>%
  dplyr::count() %>%
  na.omit() %>%
  ungroup() %>%
  filter(duplicated(individual)) %>%
  pull(individual)
ranks <- ranks %>%
  mutate(ambigous = ifelse(individual %in% ambigous, TRUE, FALSE))

# For non ambigous embryo, replace the NA in sex by the value of other cells
# from the same individual
F_individual <- ranks %>%
  filter(!ambigous) %>%
  dplyr::select(individual, sex) %>%
  filter(!is.na(sex)) %>%
  unique() %>%
  filter(sex == "F") %>%
  pull(individual)

M_individual <- ranks %>%
  filter(!ambigous) %>%
  dplyr::select(individual, sex) %>%
  filter(!is.na(sex)) %>%
  unique() %>%
  filter(sex == "M") %>%
  pull(individual)

ranks$sex[ranks$individual %in% F_individual] <- "F"
ranks$sex[ranks$individual %in% M_individual] <- "M"

individual_sex <- ranks

## E4 embryos

day <- "E4"
sce <- embryo_sce_Petropoulos[, embryo_sce_Petropoulos$day == day]
sce$sumY <- colSums(assay(sce)[Y_linked, ])
ranks <- as_tibble(colData(sce)) %>%
  arrange(sumY) %>%
  mutate(rank = 1:ncol(sce)) %>%
  mutate(sex = case_when(sumY > 300 ~ "M",
                            sumY < 100 ~ "F",
                            sumY < 300 & sumY > 100 ~ NA) )

# Flag embryos with conflicting sex results
# (i.e an individual where some cells would be flagged as F and other as M)
ambigous <- ranks %>%
  group_by(individual, sex) %>%
  dplyr::count() %>%
  na.omit() %>% ungroup() %>%
  filter(duplicated(individual)) %>%
  pull(individual)
# No ambiguous

ranks <- ranks %>%
  mutate(ambigous = ifelse(individual %in% ambigous, TRUE, FALSE))

# For non ambigous embryo, replace the NA in sex by the value of other cells
# from the same individual
F_individual <- ranks %>%
  filter(!ambigous) %>%
  dplyr::select(individual, sex) %>%
  filter(!is.na(sex)) %>%
  unique() %>%
  filter(sex == "F") %>%
  pull(individual)

M_individual <- ranks %>%
  filter(!ambigous) %>%
  dplyr::select(individual, sex) %>%
  filter(!is.na(sex)) %>%
  unique() %>%
  filter(sex == "M") %>%
  pull(individual)

ranks$sex[ranks$individual %in% F_individual] <- "F"
ranks$sex[ranks$individual %in% M_individual] <- "M"

individual_sex <- rbind(individual_sex, ranks)


## E5 embryos

day <- "E5"
sce <- embryo_sce_Petropoulos[, embryo_sce_Petropoulos$day == day]
sce$sumY <- colSums(assay(sce)[Y_linked, ])
ranks <- as_tibble(colData(sce)) %>%
  arrange(sumY) %>%
  mutate(rank = 1:ncol(sce)) %>%
  mutate(sex = case_when(sumY > 300 ~ "M",
                            sumY < 100 ~ "F",
                            sumY < 300 & sumY > 100 ~ NA) )

# Flag embryos with conflicting sex results
# (i.e an individual where some cells would be flagged as F and other as M)
ambigous <- ranks %>%
  group_by(individual, sex) %>%
  dplyr::count() %>%
  na.omit() %>% ungroup() %>%
  filter(duplicated(individual)) %>%
  pull(individual)

ranks <- ranks %>%
  mutate(ambigous = ifelse(individual %in% ambigous, TRUE, FALSE))

# For non ambigous embryo, replace the NA in sex by the value of other cells
# from the same individual
F_individual <- ranks %>%
  filter(!ambigous) %>%
  dplyr::select(individual, sex) %>%
  filter(!is.na(sex)) %>%
  unique() %>%
  filter(sex == "F") %>%
  pull(individual)

M_individual <- ranks %>%
  filter(!ambigous) %>%
  dplyr::select(individual, sex) %>%
  filter(!is.na(sex)) %>%
  unique() %>%
  filter(sex == "M") %>%
  pull(individual)

ranks$sex[ranks$individual %in% F_individual] <- "F"
ranks$sex[ranks$individual %in% M_individual] <- "M"

individual_sex <- rbind(individual_sex, ranks)


## E6 embryos

day <- "E6"
sce <- embryo_sce_Petropoulos[, embryo_sce_Petropoulos$day == day]
sce$sumY <- colSums(assay(sce)[Y_linked, ])
ranks <- as_tibble(colData(sce)) %>%
  arrange(sumY) %>%
  mutate(rank = 1:ncol(sce)) %>%
  mutate(sex = case_when(sumY > 400 ~ "M",
                            sumY < 200 ~ "F",
                            sumY < 400 & sumY > 200 ~ NA))

# Flag embryos with conflicting sex results
# (i.e an individual where some cells would be flagged as F and other as M)
ambigous <- ranks %>%
  group_by(individual, sex) %>%
  dplyr::count() %>%
  na.omit() %>% ungroup() %>%
  filter(duplicated(individual)) %>%
  pull(individual)
ranks <- ranks %>%
  mutate(ambigous = ifelse(individual %in% ambigous, TRUE, FALSE))

# For non ambigous embryo, replace the NA in sex by the value of other cells
# from the same individual
F_individual <- ranks %>%
  filter(!ambigous) %>%
  dplyr::select(individual, sex) %>%
  filter(!is.na(sex)) %>%
  unique() %>%
  filter(sex == "F") %>%
  pull(individual)

M_individual <- ranks %>%
  filter(!ambigous) %>%
  dplyr::select(individual, sex) %>%
  filter(!is.na(sex)) %>%
  unique() %>%
  filter(sex == "M") %>%
  pull(individual)

ranks$sex[ranks$individual %in% F_individual] <- "F"
ranks$sex[ranks$individual %in% M_individual] <- "M"

individual_sex <- rbind(individual_sex, ranks)

## E7 embryos

day <- "E7"
sce <- embryo_sce_Petropoulos[, embryo_sce_Petropoulos$day == day]
sce$sumY <- colSums(assay(sce)[Y_linked, ])
ranks <- as_tibble(colData(sce)) %>%
  arrange(sumY) %>%
  mutate(rank = 1:ncol(sce)) %>%
  mutate(sex = case_when(sumY > 400 ~ "M",
                            sumY < 200 ~ "F",
                            sumY < 400 & sumY > 200 ~ NA))

# Flag embryos with conflicting sex results
# (i.e an individual where some cells would be flagged as F and other as M)
ambigous <- ranks %>%
  group_by(individual, sex) %>%
  dplyr::count() %>%
  na.omit() %>% ungroup() %>%
  filter(duplicated(individual)) %>%
  pull(individual)
ranks <- ranks %>%
  mutate(ambigous = ifelse(individual %in% ambigous, TRUE, FALSE))

# For non ambigous embryo, replace the NA in sex by the value of other cells
# from the same individual
F_individual <- ranks %>%
  filter(!ambigous) %>%
  dplyr::select(individual, sex) %>%
  filter(!is.na(sex)) %>%
  unique() %>%
  filter(sex == "F") %>%
  pull(individual)

M_individual <- ranks %>%
  filter(!ambigous) %>%
  dplyr::select(individual, sex) %>%
  filter(!is.na(sex)) %>%
  unique() %>%
  filter(sex == "M") %>%
  pull(individual)

ranks$sex[ranks$individual %in% F_individual] <- "F"
ranks$sex[ranks$individual %in% M_individual] <- "M"

individual_sex <- rbind(individual_sex, ranks)


## Summary of sexs

# summarise sex info in a table,
# flag individuals with conflicting sex determination
cell_sex <- individual_sex %>%
  dplyr::select(sample, individual, sex, ambigous)

coldata <- merge(colData(embryo_sce_Petropoulos), cell_sex)
rownames(coldata) <- coldata$sample
coldata <- coldata[rownames(colData(embryo_sce_Petropoulos)),]
colData(embryo_sce_Petropoulos) <- coldata


### ChrX ratios

X_linked <- transcripts_infos %>%
  filter(external_gene_name %in% rownames(embryo_sce_Petropoulos)) %>%
  filter(chromosome_name == "X") %>%
  pull(external_gene_name) %>%
  unique()

autosomal_genes <- transcripts_infos %>%
  filter(external_gene_name %in% rownames(embryo_sce_Petropoulos)) %>%
  filter(chromosome_name %in% c(1:22)) %>%
  pull(external_gene_name) %>%
  unique()

sce <- embryo_sce_Petropoulos

RPKM_sum_by_chr <- tibble(sample = colnames(sce),
                          chrY_RPKM_sum = colSums(assay(sce)[Y_linked,]),
                          chrX_RPKM_sum = colSums(assay(sce)[X_linked,]),
                          autosomal_RPKM_sum = colSums(assay(sce)[autosomal_genes,]),
                          chrY_RPKM_mean = colMeans(assay(sce)[Y_linked,]),
                          chrX_RPKM_mean = colMeans(assay(sce)[X_linked,]),
                          autosomal_RPKM_mean = colMeans(assay(sce)[autosomal_genes,])) %>%
  mutate(ratio_X_A = chrX_RPKM_mean / autosomal_RPKM_mean) %>%
  mutate(ratio_Y_A = chrY_RPKM_mean / autosomal_RPKM_mean) %>%
  left_join(as_tibble(colData(sce)))

RPKM_sum_by_chr$sex <- factor(RPKM_sum_by_chr$sex, levels = c("F", "M"))

ordered_samples <- RPKM_sum_by_chr %>%
  arrange(sex, day) %>%
  pull(sample)

# "E5.early.31" sample flagged as Xo (Turner) in Petropoulos
# "E6.15" sample flagged as embryo with biallelic expression of many X_linked
# genes in Petropoulos

bad_embryos <- c("E5.early.31", "E6.15")
embryo_sce_Petropoulos <-
  embryo_sce_Petropoulos[, !embryo_sce_Petropoulos$individual %in% bad_embryos]

## Complete colData
embryo_sce_Petropoulos$genotype <- embryo_sce_Petropoulos$sex
embryo_sce_Petropoulos$genotype[!is.na(embryo_sce_Petropoulos$genotype) &
                           embryo_sce_Petropoulos$sex == "F"] <- "XX"
embryo_sce_Petropoulos$genotype[!is.na(embryo_sce_Petropoulos$genotype) &
                           embryo_sce_Petropoulos$genotype == "M"] <- "XY"
embryo_sce_Petropoulos$day_stage[embryo_sce_Petropoulos$day == "E3"]  <-
  "Morula E3"
embryo_sce_Petropoulos$day_stage[embryo_sce_Petropoulos$day == "E4"] <-
  "Blastocyst E4"
embryo_sce_Petropoulos$day_stage[embryo_sce_Petropoulos$day == "E5"] <-
  "Blastocyst E5"
embryo_sce_Petropoulos$day_stage[embryo_sce_Petropoulos$day == "E6"] <-
  "Blastocyst E6"
embryo_sce_Petropoulos$day_stage[embryo_sce_Petropoulos$day == "E7"] <-
  "Blastocyst E7"
embryo_sce_Petropoulos$day_stage <- factor(embryo_sce_Petropoulos$day_stage,
                                    levels = c("Morula E3", "Blastocyst E4",
                                               "Blastocyst E5", "Blastocyst E6",
                                               "Blastocyst E7"))

save(embryo_sce_Petropoulos, file = "../../eh_data/embryo_sce_Petropoulos.rda",
     compress = "xz",
     compression_level = 9)

## code to prepare `GTEX_data` dataset goes here

library(tidyverse)
library(SummarizedExperiment)
library(BiocFileCache)
library(biomaRt)

bfc <- BiocFileCache(cache = "../../../CTdata_extdata/BiocFileCache",
                     ask = FALSE)

if (length(bfcquery(bfc, "GTEX")$rid) == 0) {
  url <- "https://storage.googleapis.com/gtex_analysis_v8/rna_seq_data/GTEx_Analysis_2017-06-05_v8_RNASeQCv1.1.9_gene_median_tpm.gct.gz"
  bfcadd(bfc, "GTEX", fpath = url)
}

GTEX_data <- as_tibble(read.table(bfc[[bfcquery(bfc, "GTEX")$rid]],
                                  skip = 2, header = TRUE, sep = "\t"))

##########################################################################
## Clean and simplify GTEX data
##########################################################################

## Add external_gene_name to GTEX database based on ensembl_gene_id
## (Gene named given in `Description` column is not always external_gene_name)
## ! external_gene_names are sometimes associated to several ensembl_gene_id !
## To keep the more relevant external_gene_names, select the ones associated
## to canonical transcripts
ensembl <- biomaRt::useDataset("hsapiens_gene_ensembl", useMart("ensembl"))
attributes_vector <- c("ensembl_gene_id",
                       "external_gene_name",
                       "ensembl_transcript_id",
                       "external_transcript_name",
                       "chromosome_name",
                       "transcript_biotype",
                       "transcript_is_canonical")
transcripts_infos <- as_tibble(biomaRt::getBM(attributes = attributes_vector,
                                              mart = ensembl))
canonical_transcripts <- transcripts_infos %>%
  dplyr::filter(transcript_is_canonical == 1) %>%
  dplyr::filter(external_transcript_name != "") %>%
  dplyr::filter(chromosome_name %in% c(1:22, "X", "Y", "MT")) %>%
  # no transcripts on assembly patches
  dplyr::filter(transcript_biotype == "protein_coding" |
                  transcript_biotype == "lncRNA")

GTEX_data <- GTEX_data %>%
  dplyr::select(-Description) %>%
  dplyr::rename(ensembl_gene_id = Name) %>%
  dplyr::mutate(ensembl_gene_id = sub(pattern = ".\\d+$",
                                      x = ensembl_gene_id,
                                      replacement = '')) %>%
  left_join(canonical_transcripts %>%
              dplyr::select(ensembl_gene_id, external_gene_name)) %>%
  dplyr::filter(!is.na(external_gene_name))

## Clean tissue names
## Pool same categories of tissues and calculate mean of TPM in pooled tissues
GTEX_data <- GTEX_data %>%
  dplyr::rename("Small Intestine...Terminal Ileum" =
                  "Small.Intestine...Terminal.Ileum") %>%
  dplyr::rename("Salivary Gland" = "Minor.Salivary.Gland") %>%
  dplyr::rename("Adrenal Gland" = "Adrenal.Gland") %>%
  dplyr::rename("Blood" = "Whole.Blood") %>%
  dplyr::rename("Fallopian Tube" = "Fallopian.Tube") %>%
  dplyr::rename("Fibroblasts" = "Cells...Cultured.fibroblasts") %>%
  dplyr::rename("Lymphocytes_EBV" = "Cells...EBV.transformed.lymphocytes") %>%
  pivot_longer(names_to = "tissue", values_to = "tpm",
               -c(ensembl_gene_id, external_gene_name)) %>%
  dplyr::mutate(tissue = sub(pattern = "\\.\\.\\..*$",
                             x = tissue, replacement = '')) %>%
  dplyr::group_by(ensembl_gene_id, tissue) %>%
  dplyr::mutate(TPM = mean(tpm)) %>%
  dplyr::select(-tpm) %>%
  unique() %>%
  pivot_wider(names_from = tissue, values_from = TPM)

ordered_tissues <- sort(colnames(GTEX_data)[-c(1:2)])
GTEX_data <- GTEX_data %>%
  dplyr::select("ensembl_gene_id", "external_gene_name",
                all_of(ordered_tissues))

##########################################################################
## Evaluate maximum TPM in somatic tissues
## Evaluate quantile 75% of TPM in somatic tissues
## Calculate ratio_testis_somatic
## (defined as expression in testis / max_TPM_somatic)
##########################################################################

GTEX_data <- GTEX_data %>%
  dplyr::select("ensembl_gene_id", "external_gene_name", "Testis",
                "Ovary", everything()) %>%
  rowwise() %>%
  dplyr::mutate(max_TPM_somatic = max(c_across(c(Adipose:Vagina)))) %>%
  dplyr::mutate(q75_TPM_somatic = quantile(c_across(c(Adipose:Vagina)),
                                           0.75)) %>%
  dplyr::mutate(ratio_testis_somatic = Testis / max_TPM_somatic) %>%
  ungroup()

## Tag genes that are not detected in GTEx database
## (or genes very lowly expressed in all tissues)
lowly_expressed <- GTEX_data %>%
  dplyr::filter(Testis < 1 & max_TPM_somatic < 1 & Ovary < 1) %>%
  pull(external_gene_name)

## Tag testis_specific genes
testis_specific <- GTEX_data %>%
  dplyr::filter(!external_gene_name %in% lowly_expressed) %>%
  dplyr::filter(Testis >= 1) %>%
  dplyr::filter(max_TPM_somatic < 0.5) %>%
  dplyr::filter(ratio_testis_somatic >= 10) %>%
  pull(external_gene_name)

## Tag testis_preferential genes
## Compare to testis-specific genes, testis-preferential genes can have
## an expression level in a somatic tissue > 0.5 but this should
## only occur in a minority of somatic tissues (filter en q75_TPM_somatic)
testis_preferential <- GTEX_data %>%
  dplyr::filter(!external_gene_name %in% lowly_expressed) %>%
  dplyr::filter(!external_gene_name %in% testis_specific)  %>%
  dplyr::filter(Testis >= 1) %>%
  dplyr::filter(ratio_testis_somatic >= 10) %>%
  dplyr::filter(q75_TPM_somatic < 0.5) %>%
  pull(external_gene_name)

## Add GTEX_category column summarizing the category
## assigned to each gene using GTEx database.
GTEX_data <- GTEX_data %>%
  mutate(GTEX_category = case_when(
    external_gene_name %in% lowly_expressed ~ "lowly_expressed",
    external_gene_name %in% testis_specific ~ "testis_specific",
    external_gene_name %in% testis_preferential ~ "testis_preferential"))
GTEX_data[is.na(GTEX_data$GTEX_category), "GTEX_category"] <- "other"

Gtex_mat <- as.matrix(GTEX_data %>%
                        dplyr::select(-c(ensembl_gene_id, external_gene_name,
                                         max_TPM_somatic, q75_TPM_somatic,
                                         ratio_testis_somatic,
                                         GTEX_category)))
rownames(Gtex_mat) <- GTEX_data$ensembl_gene_id
rowdata <- as.data.frame(GTEX_data %>%
                           dplyr::select(c(ensembl_gene_id, external_gene_name,
                                           GTEX_category, q75_TPM_somatic,
                                           max_TPM_somatic,
                                           ratio_testis_somatic)))
rowdata <- column_to_rownames(rowdata, "ensembl_gene_id")
GTEX_data <- SummarizedExperiment(assays = list(TPM = Gtex_mat),
                                  rowData = rowdata)

save(GTEX_data, file = "../../eh_data/GTEX_data.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `methylation_in_embryo` dataset goes here

library("tidyverse")
library("GenomicRanges")
library("data.table")
library("SummarizedExperiment")

load("../extdata/CpG_positions_all_prom_hg19.rda")


## Data from Single Cell DNA Methylome Sequencing of Human Preimplantation
## Embryos  (Zhu et al. 2018)
## 500 scWGBS files were downloaded from GEO (accession: GSE81233).
## These .bed files have been subsetted to only contain CpG methylation.


################################################################################
# Manage sample metadata to create a coldata
################################################################################

## We are using two files : information from their supplemental file and
## metadata from the downloading (with file names).

metadata <- read_tsv("../../../CTdata_extdata/Zhu_metadata")

##  Add file names to metadata
coldata <-
  tibble(sample =
           list.files("../../../CTdata_extdata/GSE81233_subsetted_data/",
                      pattern = "*.gz")) %>%
  mutate(Accession = gsub("_.*$", x = sample, replace = '')) %>%
  left_join(metadata) %>%
  mutate(Sample_Name = gsub("GSM\\w*_", x = sample, replace = '')) %>%
  mutate(Sample_Name = gsub(".CpGmet.bed.gz", x = Sample_Name, replace = '')) %>%
  dplyr::select(sample, Sample_Name, everything())

# In metadata GSM2773562-GSM2773565 are referred as "Mor09-Q" (source name)
# While the name of the files contain "Mor09-W" rather than "Mor09-Q"
# Confusing => Removing samples
coldata <- coldata[!coldata$sample %in%
                     grep('Mor09-W', x = coldata$sample, value = TRUE), ]

# Vilus files were not in metadata, adding the info manually
coldata$bulk_or_single_cell[coldata$Sample_Name %in%
                              c("9W-PBAT-villus-1", "9W-PBAT-villus-2")] <- "bulk cells"
coldata$cell_type[coldata$Sample_Name %in%
                    c("9W-PBAT-villus-1", "9W-PBAT-villus-2")] <- "Villus"
coldata$source_name[coldata$Sample_Name %in%
                      c("9W-PBAT-villus-1", "9W-PBAT-villus-2")] <- "Villus"


##  Add metadata from Supplemental Table and modify to join to coldata
suppl <- readxl::read_xlsx(
  "../../../CTdata_extdata/41588_2017_7_MOESM3_ESM.xlsx", sheet = 1)

suppl$Sample_Name[suppl$Sample_Name == "Villus_9W_rep1"] <- "9W-PBAT-villus-1"
suppl$Sample_Name[suppl$Sample_Name == "Villus_9W_rep2"] <- "9W-PBAT-villus-2"
suppl$Sample_Name[suppl$Sample_Name == "Villus_11W_rep1"] <- "11W-PBAT-villus-1"
suppl$Sample_Name[suppl$Sample_Name == "Villus_11W_rep2"]<- "11W-PBAT-villus-2"
suppl$Sample_Name[suppl$Sample_Name == "Heart_7W_rep1"] <- "7W-PBAT-heart-1"
suppl$Sample_Name[suppl$Sample_Name == "Heart_7W_rep2"] <- "7W-PBAT-heart-2"
suppl$Sample_Name[suppl$Sample_Name == "Heart_11W_rep1"] <- "11W-PBAT-heart-1"
suppl$Sample_Name[suppl$Sample_Name == "Heart_11W_rep2"] <- "11W-PBAT-heart-2"

coldata <- coldata %>%
  left_join(suppl)

# Problem with a sample and the others are duplicated : remove
coldata <- coldata %>%
  filter(!sample %in% c("GSM2773698_Te05-W-b99.CpGmet.bed.gz",
                        "GSM2986409_scBS-O-bst-4.CpGmet.bed.gz",
                        "GSM2986393_Mor08-Q-s167.CpGmet.bed.gz",
                        "GSM2986394_Mor08-Q-s168.CpGmet.bed.gz"))



## Complete coldata when NA, standardize or adding info

coldata$Stage[coldata$Sample_Name %in% c("scBS-Sp12", "scBS-Sp14")] <- "Sperm"
coldata$Stage[coldata$Sample_Name %in% c("scBS-Morula-3bulk",
                                         "scBS-Morula-5bulk")] <- "Morula"

coldata$`Single Cell or Bulk cell` <- coldata$bulk_or_single_cell
coldata$stage_level <- coldata$Stage

coldata <- coldata %>%
  dplyr::rename(low_quality = "Low Quality (True or False)")

# Add timing to stage
coldata$stage_level[coldata$`Developmental Time` %in%
                      c("early zygotic stage (10-11h after ICSI)")] <- "PN-early"
coldata$stage_level[coldata$`Developmental Time` %in%
                      c("mid- zygotic stage (22-23h after ICSI)")] <- "PN-mid"
coldata$stage_level[coldata$`Developmental Time` %in%
                      c("late zygotic stage (25h or even later after ICSI)")] <- "PN-late"
coldata$stage_level[coldata$cell_type %in% c("Heart")] <- "Heart"
coldata$stage_level[coldata$cell_type %in% c("Villus")] <- "Villus"

# Simplify
coldata$Stage[coldata$Stage %in% c("Blastocyst (ICM)", "Blastocyst (TE)",
                                   "Blastocyst (Mixed)")] <- "Blastocyst"
coldata$Stage[coldata$Stage %in% "PN"] <- "Zygote"

# Add info when missing stage
coldata$Stage[is.na(coldata$Stage) & coldata$cell_type == "ICM"] <- "Blastocyst"

# Fill NA
coldata$`Developmental Time`[coldata$cell_type == "Sperm"] <- "Sperm"
coldata$`Developmental Time`[coldata$Stage == "Blastocyst"] <- "Blastocyst"
coldata$`Developmental Time`[coldata$Stage == "Morula"] <- "Morula"
coldata$`Genotype of the embryo`[coldata$source_name == "Icm10-Q"] <- "XX"
coldata$stage_level[coldata$source_name == "Icm10-Q"] <- "Blastocyst (ICM)"

# Order using factors
coldata$Stage <- factor(coldata$Stage, levels = c("GV Oocyte", "MII Oocyte",
                                                  "Sperm", "Zygote", "2-cell",
                                                  "4-cell", "8-cell", "Morula",
                                                  "Blastocyst",
                                                  "Post-implantation"))

coldata$stage_level <- factor(coldata$stage_level, levels =
                                 c("GV Oocyte", "MII Oocyte", "Sperm",
                                   "PN-early", "PN-mid" , "PN-late", "2-cell",
                                   "4-cell", "8-cell", "Morula",
                                   "Blastocyst (Mixed)", "Blastocyst (ICM)",
                                   "Blastocyst (TE)", "Heart", "Villus"))



# 'Sample_name' is not consistent
coldata$individual <- gsub("-\\w*$", x= coldata$Sample_Name, '')
coldata$individual[coldata$Sample_Name == "scBS-Morula-3bulk"] <- "scBS-Morula-3"
coldata$individual[coldata$Sample_Name == "scBS-Morula-5bulk"] <- "scBS-Morula-5"

# Fill NA
coldata$`Genotype of the embryo`[coldata$individual == "scBS-E-PN11"]<- "XY"
coldata$`Genotype of the embryo`[coldata$individual == "scBS-E-PN12"] <- "XX"
coldata$`Genotype of the embryo`[coldata$individual == "scBS-E-PN8"] <- "XX"
coldata$`Genotype of the embryo`[coldata$individual == "scBS-E-PN9"]<- "XY"
coldata$`Genotype of the embryo`[coldata$individual == "scBS-2C-2"] <- NA
coldata$`Genotype of the embryo`[coldata$individual == "scBS-hSP"] <- NA
coldata$`Genotype of the embryo`[coldata$individual == "scBS-Morula-3"] <- "XY"


################################################################################
# Extract methylation from CpG located in all promoters from each file
################################################################################

samples <- unique(coldata$Sample_Name)

# Create all position to keep all CpG even if NA
methylation_values <- tibble(chr =
                               as.vector(CpG_positions_all_prom_hg19@seqnames),
                             CpG_pos =
                               CpG_positions_all_prom_hg19@ranges@start)

setDTthreads(percent = 90) # to maximise cpu usage

for (sample_id in samples) {

  print(which(coldata$Sample_Name == sample_id))

  met_file <- paste0("../../../CTdata_extdata/GSE81233_subsetted_data/",
                     filter(coldata, Sample_Name == sample_id)$sample)

  met <- as_tibble(fread(met_file)) %>%
    dplyr::rename(chromosome_name = '#Chr', strand = Chain, start = Pos) %>%
    mutate(stop = start) %>%
    dplyr::select(chromosome_name, strand, start, stop, Met, UnMet)

  met_GR <- makeGRangesFromDataFrame(met,
                                     keep.extra.columns = TRUE,
                                     seqnames.field = "chromosome_name",
                                     start.field = "start",
                                     end.field = "stop")

  rm(met)

  # Keep CpG from promoters
  tmp <- mergeByOverlaps(CpG_positions_all_prom_hg19, met_GR)
  rm(met_GR)

  # Calculate mean met by CpG position (merge + and - values)
  tmp_met <- as_tibble(tmp) %>%
    dplyr::select(CpG_positions_all_prom_hg19.seqnames,
                  CpG_pos, Met, UnMet) %>%
    dplyr::rename(chr = CpG_positions_all_prom_hg19.seqnames) %>%
    group_by(chr, CpG_pos) %>%
    dplyr::summarize(met = sum(Met), unmet = sum(UnMet)) %>%
    mutate(methylation = round(met / (met + unmet) * 100, 1)) %>%
    dplyr::select(chr, CpG_pos, methylation) %>%
    ungroup()
  rm(tmp)

  names(tmp_met) <- c("chr", "CpG_pos", sample_id)

  methylation_values <- full_join(methylation_values, tmp_met)
  rm(tmp_met)
  gc()
}

rm(sample_id)


################################################################################
# Save as a RangedSE
################################################################################

methylation_values_GR <- makeGRangesFromDataFrame(methylation_values %>%
                                                    dplyr::select(chr,
                                                                  CpG_pos) %>%
                                                    dplyr::rename(start =
                                                                    CpG_pos) %>%
                                                    mutate(stop = start + 1),
                                                  keep.extra.columns = FALSE,
                                                  seqnames.field = "chr",
                                                  start.field = "start",
                                                  end.field = "stop")

coldata <- dplyr::select(as.data.frame(coldata), -command)
rownames(coldata) <- coldata$Sample_Name


methylation_in_embryo <- SummarizedExperiment(assays = methylation_values[, coldata$Sample_Name],
                                              rowRanges = methylation_values_GR,
                                              colData = coldata)

save(methylation_in_embryo, file = "../../eh_data/methylation_in_embryo.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `mean_methylation_in_tissues` dataset goes here

library(GenomicRanges)
library(tidyverse)
library(SummarizedExperiment)

load("../../../CTdata_extdata/all_genes_prelim.rda")
load("../../eh_data/methylation_in_tissues.rda")

## Promoter region is defined as `nt_up` nucleotides upstream TSS
## and `nt_down` nucleotides downstream TSS
nt_up <- 1000
nt_down <- 200

## Calculate mean methylation of each promoter in tissues
## and store CpG number by promoter
prom_mean_met_in_tissues <- tibble(tissue =
                                     c(colnames(methylation_in_tissues),
                                       "CpG_number"))

for (gene in all_genes_prelim$external_gene_name) {
  TSS <- all_genes_prelim %>%
    filter(external_gene_name == gene) %>%
    pull(transcription_start_site)

  chr <- all_genes_prelim %>%
    filter(external_gene_name == gene) %>%
    pull(chromosome_name)

  strand <- all_genes_prelim %>%
    filter(external_gene_name == gene) %>%
    pull(strand)

  if (strand == 1) { # Analyse region at +/- nt_up and nt_down around TSS
    promoter_gr <- GRanges(seqnames = paste0("chr", chr),
                           strand = '+',
                           ranges = IRanges(start = TSS - nt_up,
                                            end = TSS + nt_down))
    promoter_gr$TSS <- TSS
  }

  if (strand == -1) { # Analyse region at +/- nt_up and nt_down around TSS
    promoter_gr <- GRanges(seqnames = paste0("chr", chr),
                           strand = '-',
                           ranges = IRanges(start = TSS - nt_down,
                                            end = TSS + nt_up))
    promoter_gr$TSS <- TSS
  }

  promoter_methylation <- subsetByOverlaps(methylation_in_tissues,
                                           promoter_gr)
  tmp <- enframe(colMeans(assay(promoter_methylation), na.rm = TRUE),
                 name = "tissue", value = gene)
  # Store the number of CpG in the promoter region
  tmp <- rbind(tmp, c("CpG_number", dim(promoter_methylation)[1]))
  prom_mean_met_in_tissues <- left_join(prom_mean_met_in_tissues, tmp)
}

## Store CpG number by promoter
CT_CpG_number <- prom_mean_met_in_tissues %>%
  filter(tissue == "CpG_number") %>%
  pivot_longer(names_to = "external_gene_name", values_to = "CpG_number",
               -tissue) %>%
  dplyr::select(-tissue) %>%
  mutate(CpG_number = as.integer(CpG_number))

## Store mean methylation level by tissue by promoter
prom_mean_met_in_tissues <- prom_mean_met_in_tissues %>%
  filter(tissue != "CpG_number") %>%
  pivot_longer(names_to = "external_gene_name", values_to = "mean_methylation",
               -tissue) %>%
  mutate(mean_methylation = as.numeric(mean_methylation)) %>%
  pivot_wider(names_from = tissue, values_from = mean_methylation)
mat <- prom_mean_met_in_tissues %>%
  dplyr::select(-external_gene_name) %>%
  as.matrix()
rownames(mat) <- prom_mean_met_in_tissues$external_gene_name

## Calculate CpG densities and ratios of methylation in somatic tissues vs sperm
methylation_analysis <- tibble(
  external_gene_name = prom_mean_met_in_tissues$external_gene_name,
  somatic_met_level = prom_mean_met_in_tissues %>%
    dplyr::select(-c(external_gene_name, placenta, testis, sperm)) %>%
    dplyr::rowwise() %>%
    rowMeans(na.rm = TRUE),
  sperm_met_level = prom_mean_met_in_tissues %>%
    dplyr::select(sperm) %>%
    pull(sperm))

## CT Genes controlled by methylation should have somatic_methylation == TRUE
## and sperm_methylation == FALSE
methylation_analysis <- methylation_analysis %>%
  left_join(all_genes_prelim %>%
              dplyr::select(external_gene_name, ensembl_gene_id)) %>%
  mutate(ratio_somatic_sperm = somatic_met_level / sperm_met_level) %>%
  left_join(CT_CpG_number) %>%
  mutate(CpG_density = CpG_number / (nt_up + nt_down) * 100) %>%
  mutate(CpG_promoter = case_when(CpG_density < 2 ~ "low",
                                  CpG_density >= 2 &
                                    CpG_density < 4 ~ "intermediate",
                                  CpG_density >= 4 ~ "high")) %>%
  mutate(somatic_methylation =
           case_when(somatic_met_level < 50 ~ FALSE,
                     somatic_met_level >= 50 ~ TRUE)) %>%
  mutate(germline_methylation =
           case_when(ratio_somatic_sperm > 2 ~ FALSE,
                     ratio_somatic_sperm <= 2 ~ TRUE)) %>%
  column_to_rownames("external_gene_name") %>%
  dplyr::select(ensembl_gene_id, CpG_density,
                CpG_promoter, somatic_met_level, sperm_met_level,
                somatic_methylation, germline_methylation)

mean_methylation_in_tissues <-
  SummarizedExperiment(assays = mat,
                       rowData = methylation_analysis)

save(mean_methylation_in_tissues,
     file = "../../eh_data/mean_methylation_in_tissues.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `DAC_treated_cells` dataset goes here

library(tidyverse)
library(DESeq2)
load("../../eh_data/GTEX_data.rda")
genes_in_gtex <- rownames(GTEX_data)

## RNAseq data from cells treated or not with 5-aza downloaded from SRA
## SRR3326020/SRR3326021	IMR5-75	CTL
## SRR3326022/SRR3326023	IMR5-75	DAC
## SRR9108737/SRR9108738	HCT116	CTL
## SRR9108739/SRR9108740	HCT116	DAC
## SRR1618781/SRR1618782	HEK293T	CTL
## SRR1618783/SRR1618784	HEK293T	DAC
## SRR3362409/SRR3362410	HMLER	DAC
## SRR3362411/SRR3362412	HMLER	CTL
## SRR12105788/SRR12105789	NCH612	CTL
## SRR12105790/SRR12105791	NCH612	DAC
## SRR12105792/SRR12105793	NCH1681	CTL
## SRR12105794/SRR12105795	NCH1681	DAC
## SRR12105780/SRR12105781	TS603	CTL
## SRR12105782/SRR12105783	TS603	DAC
## SRR5363797/SRR5363798	B2-1	CTL
## SRR5363799/SRR5363800	B2-1	DAC

## Data was processed using a standard RNAseq pipeline including
## [FastQC](https://www.bioinformatics.babraham.ac.uk/projects/fastqc/) for the
## quality control of the raw data, and
## [trimmomatic](http://www.usadellab.org/cms/?page=trimmomatic)
## to remove low quality reads and trim the adapter from the sequences.
## [hisat2](https://ccb.jhu.edu/software/hisat2/index.shtml) was used to align
## reads to grch38 genome.
## [featurecounts](https://rdrr.io/bioc/Rsubread/man/featureCounts.html) was
## used to assign reads to genes using Homo_sapiens.GRCh38.105.gtf.

load("../../../CTdata_extdata/DAC_coldata.rda")
load("../../../CTdata_extdata/DAC_raw_counts.rda")

dds <- DESeqDataSetFromMatrix(countData = raw_counts,
                              colData = coldata,
                              design = ~ 1)
dds <- DESeq2::estimateSizeFactors(dds)
normalised_counts <- counts(dds, normalize = TRUE)
log1p_transformed <- log1p(counts(dds, normalize = TRUE))

## DESeq2 analysis
## Compare DAC treated cells to control cells separately each cell line
## to identify genes induced by DAC in at least one cell line.

padj_thr <- 0.1
logFC_thr <- 2

## Define an expression threshold above which a gene will be considered as
## already activated in the cell line => Tag cells in which it makes no sense
## to test the activation upon DAC treatment
thr <- 15

cell_line <- unique(coldata$cell)[1]
coldata_by_cell_line <- coldata[coldata$cell == cell_line, ]
dds <- DESeqDataSetFromMatrix(
  countData = raw_counts[, coldata_by_cell_line$sample],
  colData = coldata_by_cell_line,
  design = ~ treatment)
dds <- DESeq(dds)

res <- results(dds, name = "treatment_DAC_vs_CTL",
               independentFiltering = FALSE,
               altHypothesis = "greater")

means_in_CTL <- enframe(rowMeans(counts(dds[, dds$treatment == "CTL"],
                                        normalize = TRUE)),
                        name = "ensembl_gene_id", value = "mean_in_CTL")

res_all <- as_tibble(res, rownames = "ensembl_gene_id") %>%
  right_join(as_tibble(rowData(GTEX_data), rownames = "ensembl_gene_id") %>%
               dplyr::select(ensembl_gene_id, external_gene_name)) %>%
  dplyr::select(ensembl_gene_id, external_gene_name, log2FoldChange,
                pvalue, padj) %>%
  mutate(log2FoldChange = round(log2FoldChange, 2)) %>%
  left_join(means_in_CTL) %>%
  mutate(expressed_in_CTL = ifelse(mean_in_CTL > thr, TRUE, FALSE)) %>%
  mutate(sign = case_when((!expressed_in_CTL & !is.na(log2FoldChange) &
                             log2FoldChange >= logFC_thr &
                             !is.na(padj) & padj <= padj_thr) ~ 1,
                          (is.na(log2FoldChange) | log2FoldChange < logFC_thr |
                             is.na(padj) | padj > padj_thr) ~ 0))

names(res_all) <- c("ensembl_gene_id", "external_gene_name",
                    paste0("logFC_", cell_line),
                    paste0("pval_", cell_line),
                    paste0("padj_", cell_line),
                    paste0("mean_CTL_", cell_line),
                    paste0("expressed_in_CTL_", cell_line),
                    paste0("sign_", cell_line))

for(cell_line in unique(coldata$cell)[-1]) {

  coldata_by_cell_line <- coldata[coldata$cell == cell_line, ]
  dds <- DESeqDataSetFromMatrix(
    countData = raw_counts[, coldata_by_cell_line$sample],
    colData = coldata_by_cell_line,
    design = ~ treatment)
  dds <- DESeq(dds)

  res <- results(dds, name = "treatment_DAC_vs_CTL",
                 independentFiltering = FALSE,
                 altHypothesis = "greater")

  means_in_CTL <- enframe(rowMeans(counts(dds[, dds$treatment == "CTL"],
                                          normalize = TRUE)),
                          name = "ensembl_gene_id", value = "mean_in_CTL")

  res <- as_tibble(res, rownames = "ensembl_gene_id") %>%
    right_join(as_tibble(rowData(GTEX_data), rownames = "ensembl_gene_id") %>%
                 dplyr::select(ensembl_gene_id, external_gene_name)) %>%
    dplyr::select(ensembl_gene_id, external_gene_name, log2FoldChange,
                  pvalue, padj) %>%
    mutate(log2FoldChange = round(log2FoldChange, 2)) %>%
    left_join(means_in_CTL) %>%
    mutate(expressed_in_CTL = ifelse(mean_in_CTL > thr, TRUE, FALSE)) %>%
    mutate(sign = case_when((!expressed_in_CTL & !is.na(log2FoldChange) &
                               log2FoldChange >= logFC_thr &
                               !is.na(padj) & padj <= padj_thr) ~ 1,
                            (is.na(log2FoldChange) |
                               log2FoldChange < logFC_thr |
                               is.na(padj) | padj > padj_thr) ~ 0))

  names(res) <- c("ensembl_gene_id", "external_gene_name",
                  paste0("logFC_", cell_line),
                  paste0("pval_", cell_line),
                  paste0("padj_", cell_line),
                  paste0("mean_CTL_", cell_line),
                  paste0("expressed_in_CTL_", cell_line),
                  paste0("sign_", cell_line))

  res_all <- left_join(res_all, res)
}



## Evaluate the number de cell lines already expressing the genes
res_all$expressed_in_n_CTLs <- res_all %>%
  dplyr::select(starts_with("expressed_in_CTL")) %>%
  rowSums(na.rm = TRUE)

## Tag genes significantly induced in at least one cell line
res_all$sign <- res_all %>%
  dplyr::select(starts_with("sign")) %>%
  rowSums(na.rm = TRUE)

## Induction cannot be evaluate if genes are already expressed in more
## than 7 out of 8 cell lines
res_all <- res_all %>%
  mutate(induced = case_when(expressed_in_n_CTLs == 8 ~ NA,
                             expressed_in_n_CTLs < 8 & sign >= 1 ~ TRUE,
                             expressed_in_n_CTLs < 8 & sign < 1 ~ FALSE)) %>%
  dplyr::select(-sign)

res_all <- as.data.frame(res_all)
res_all <- column_to_rownames(res_all, "ensembl_gene_id")

## Save as a SE
DAC_treated_cells <- SummarizedExperiment(
  assays = list(counts = normalised_counts[genes_in_gtex, coldata$sample],
                log1p = log1p_transformed[genes_in_gtex, coldata$sample]),
  colData = coldata[, -1],
  rowData = res_all[genes_in_gtex, ])

save(DAC_treated_cells, file = "../../eh_data/DAC_treated_cells.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `HPA_cell_type_specificity` dataset goes here

library("tidyverse")
library("SummarizedExperiment")
load("../../eh_data/GTEX_data.rda")

# Data from the Human Protein Atlas (version 23.0) in tab-separated format
# https://www.proteinatlas.org/download/proteinatlas.tsv.zip

proteinatlas <- read_tsv("../../../CTdata_extdata/proteinatlas.tsv")


# Use the column `RNA single cell type specific nTPM` to flag gene
# as "not_testis_specific" genes when they are specific of a somatic cell type
HPA_single_cell_specificities <-
  proteinatlas$`RNA single cell type specific nTPM`[
    !is.na(proteinatlas$`RNA single cell type specific nTPM`)]

HPA_single_cell_specificities_list <- strsplit(
  HPA_single_cell_specificities, split = ";")
names(HPA_single_cell_specificities_list) <- proteinatlas[
  !is.na(proteinatlas$`RNA single cell type specific nTPM`),]$Gene

detected_specificities <- unique(gsub(
  pattern = ": .*", x = unlist(strsplit(
    HPA_single_cell_specificities, split = ";")), ''))

germ_cell_types <- c("Spermatocytes", "Spermatogonia", "Early spermatids",
                     "Late spermatids", "Oocytes")

accepted_cell_types <- c("Spermatocytes", "Spermatogonia", "Early spermatids",
                         "Late spermatids", "Oocytes", "Syncytiotrophoblasts",
                         "Cytotrophoblasts", "Extravillous trophoblasts")

somatic_cell_types <- detected_specificities[!detected_specificities %in%
                                               accepted_cell_types]


x <- unlist(strsplit(HPA_single_cell_specificities_list[[1]], split = ";"))
cells <- gsub(pattern = ":.*$", x = x, replacement = '')
values <- gsub(pattern = "^.*: ", x = x, replacement = '')
max_som <- tibble(cell_type = cells,
                  nTPM = as.numeric(values)) %>%
  arrange(desc(nTPM)) %>%
  filter(cell_type %in% somatic_cell_types) %>%
  head(1) %>%
  pull(nTPM)
max_germ <- tibble(cell_type = cells,
                   nTPM = as.numeric(values)) %>%
  arrange(desc(nTPM)) %>%
  filter(cell_type %in% germ_cell_types) %>%
  head(1) %>%
  pull(nTPM)
HPA_nTPM <- tibble(external_gene_name =
                     names(HPA_single_cell_specificities_list[1]),
       max_HPA_somatic = ifelse(length(max_som) > 0, max_som, 0),
       max_HPA_germcell = ifelse(length(max_germ) > 0, max_germ, 0))

for (i in seq_along(HPA_single_cell_specificities_list)[-1]) {
  x <- unlist(strsplit(HPA_single_cell_specificities_list[[i]], split = ";"))
  cells <- gsub(pattern = ":.*$", x = x, replacement = '')
  values <- gsub(pattern = "^.*: ", x = x, replacement = '')
  max_som <- tibble(cell_type = cells,
                    nTPM = as.numeric(values)) %>%
    arrange(desc(nTPM)) %>%
    filter(cell_type %in% somatic_cell_types) %>%
    head(1) %>%
    pull(nTPM)
  max_germ <- tibble(cell_type = cells,
                     nTPM = as.numeric(values)) %>%
    arrange(desc(nTPM)) %>%
    filter(cell_type %in% germ_cell_types) %>%
    head(1) %>%
    pull(nTPM)
  tmp <- tibble(external_gene_name =
                  names(HPA_single_cell_specificities_list[i]),
                max_HPA_somatic = ifelse(length(max_som) > 0, max_som, 0),
                max_HPA_germcell = ifelse(length(max_germ) > 0, max_germ, 0))
  HPA_nTPM <- rbind(HPA_nTPM, tmp)
}

HPA_nTPM <- HPA_nTPM[!duplicated(HPA_nTPM$external_gene_name),]

HPA_cell_type_specificities <- tibble(
  ensembl_gene_id = rownames(GTEX_data),
  external_gene_name = rowData(GTEX_data)$external_gene_name) %>%
  left_join(
    proteinatlas %>%
      dplyr::rename(ensembl_gene_id = Ensembl) %>%
      dplyr::rename(HPA_scRNAseq_celltype_specific_nTPM =
                      `RNA single cell type specific nTPM`) %>%
      dplyr::select(ensembl_gene_id, HPA_scRNAseq_celltype_specific_nTPM)) %>%
  left_join(HPA_nTPM) %>%
  mutate(not_detected_in_somatic_HPA = case_when(
    max_HPA_somatic == 0 ~ TRUE,
    max_HPA_somatic > 0 ~ FALSE)) %>%
  mutate(HPA_ratio_germ_som = max_HPA_germcell / max_HPA_somatic)

save(HPA_cell_type_specificities,
     file = "../../eh_data/HPA_cell_type_specificities.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `methylation_in_FGC` dataset goes here

library("tidyverse")
library("GenomicRanges")
library("data.table")
library("SummarizedExperiment")

load("../extdata/CpG_positions_all_prom_hg19.rda")


## Data from Dissecting the epigenomic dynamics of human fetal germ cell
## development at single-cell resolution (Li et al. 2021)
## 461 scWGBS files were downloaded from GEO (accession: GSE107714).


################################################################################
# Manage sample metadata
################################################################################

files <- list.files("../../../CTdata_extdata/GSE107714/", pattern = "txt.gz")
coldata <- tibble(files = files,
                  sample = gsub("GSM\\d*_", '', files)) %>%
  mutate(type = gsub('_\\d*W.*', '', sample)) %>%
  mutate(type = gsub('\\w_', '', type)) %>%
  mutate(sample = gsub(".methylation_calling.txt.gz", '', sample)) %>%
  mutate(sex = gsub('_FGC.*', '', sample)) %>%
  mutate(sex = gsub('_Soma.*', '', sex)) %>%
  mutate(time_week = gsub('W.*', '', sample)) %>%
  mutate(time_week = gsub('.*_', '', time_week)) %>%
  mutate(time_week = as.numeric(time_week)) %>%
  mutate(individual = gsub('.*W_', '', sample)) %>%
  mutate(individual = gsub('_.*', '', individual)) %>%
  mutate(cell = gsub('.*sc', 'sc', sample)) %>%
  mutate(group = paste0(sex, '_', type, '_', time_week, 'W')) %>%
  mutate(group = factor(group,
                        levels = c("F_FGC_8W", "F_FGC_9W", "F_FGC_10W",
                                   "F_FGC_17W", "F_FGC_21W", "M_FGC_6W",
                                   "M_FGC_7W", "M_FGC_17W", "M_FGC_21W",
                                   "M_FGC_24W", "F_Soma_8W", "F_Soma_9W",
                                   "F_Soma_17W", "F_Soma_21W", "M_Soma_6W",
                                   "M_Soma_7W", "M_Soma_17W", "M_Soma_21W"))) %>%
  mutate(sex_time = paste0(sex, '_', time_week, "_", type)) %>%
  mutate(sex_time = factor(sex_time,
                           levels = c("F_8_FGC", "F_9_FGC", "F_10_FGC",
                                      "F_17_FGC", "F_21_FGC", "M_6_FGC",
                                      "M_7_FGC", "M_17_FGC", "M_21_FGC",
                                      "M_24_FGC", "M_7_Soma", "F_8_Soma"))) %>%
  mutate(sex_type = paste0(sex, "_", type)) %>%
  mutate(sex_type = factor(sex_type,
                           levels = c("F_FGC", "M_FGC", "F_Soma", "M_Soma")))


metadata <- readxl::read_xlsx("../../../CTdata_extdata/GSE107714/41422_2020_401_MOESM8_ESM.xlsx")
names(metadata)[1] <- "sample"

coldata <- coldata %>%
  left_join(metadata) %>%
  dplyr::select(- Gender)

coldata <- coldata %>%
  filter(`Pass Quality Control (True or False)`) %>%
  mutate(cellType = case_when(`Cell Type` == "FGC2" &
                                sex == "M" ~ "M_mitotic_FGC",
                              `Cell Type` == "FGC3" &
                                sex == "M"~ "M_mitotic_arrested_FGC",
                              `Cell Type` == "FGC1" &
                                sex == "M" ~ "M_FGC",
                              `Cell Type` == "FGC1" &
                                sex == "F" ~ "F_FGC",
                              `Cell Type` == "FGC2" &
                                sex == "F" ~ "F_mitotic_FGC",
                              `Cell Type` == "FGC3" &
                                sex == "F" ~ "F_meiotic_FGC",
                              `Cell Type` == "FGC4" &
                                sex == "F"~ "F_oogenesis_FGC",
                              `Cell Type` == "Soma" &
                                sex == "F" ~ "F_soma",
                              `Cell Type` == "Soma" &
                                sex == "M" ~ "M_soma")) %>%
  mutate(cellType = factor(cellType,
                           levels = c("F_FGC", "F_meiotic_FGC",
                                      "F_oogenesis_FGC", "M_mitotic_FGC",
                                      "M_mitotic_arrested_FGC", "F_soma",
                                      "M_soma")))



################################################################################
# Extract methylation from CpG located in all promoters from each file
################################################################################

# We don't need to keep all soma samples, juste 1 male and 1 female is enough

keep <-
  coldata[c(grep("FGC", coldata$group),
            which(coldata$group %in% c("F_Soma_8W", "M_Soma_7W"))), ]

samples <- unique(keep$sample)

# Create all position to keep all CpG even if NA
methylation_values <- tibble(chr =
                               as.vector(CpG_positions_all_prom_hg19@seqnames),
                             CpG_pos =
                               CpG_positions_all_prom_hg19@ranges@start)

setDTthreads(percent = 90) # to maximise cpu usage

for (sample_id in samples) {

  print(which(keep$sample == sample_id))

  met_file <- paste0("../../../CTdata_extdata/GSE107714/",
                     filter(coldata, sample == sample_id)$files)

  met <- as_tibble(fread(met_file)) %>%
    filter(Type == "CpG") %>%
    dplyr::rename(chromosome_name = '#Chr', strand = Chain, start = Pos) %>%
    mutate(stop = start) %>%
    dplyr::select(chromosome_name, strand, start, stop, Met, UnMet)

  met_GR <- makeGRangesFromDataFrame(met,
                                     keep.extra.columns = TRUE,
                                     seqnames.field = "chromosome_name",
                                     start.field = "start",
                                     end.field = "stop")

  rm(met)

  # Keep CpG from promoters
  tmp <- mergeByOverlaps(CpG_positions_all_prom_hg19, met_GR)
  rm(met_GR)

  # Calculate mean met by CpG position (merge + and - values)
  tmp_met <- as_tibble(tmp) %>%
    dplyr::select(CpG_positions_all_prom_hg19.seqnames,
                  CpG_pos, Met, UnMet) %>%
    dplyr::rename(chr = CpG_positions_all_prom_hg19.seqnames) %>%
    group_by(chr, CpG_pos) %>%
    dplyr::summarize(met = sum(Met), unmet = sum(UnMet)) %>%
    mutate(methylation = round(met / (met + unmet) * 100, 1)) %>%
    dplyr::select(chr, CpG_pos, methylation) %>%
    ungroup()
  rm(tmp)

  names(tmp_met) <- c("chr", "CpG_pos", sample_id)

  methylation_values <- full_join(methylation_values, tmp_met)
  rm(tmp_met)
  gc()
}


################################################################################
# Save as a RangedSE
################################################################################

methylation_values_GR <- makeGRangesFromDataFrame(methylation_values %>%
                                                    dplyr::select(chr,
                                                                  CpG_pos) %>%
                                                    dplyr::rename(start =
                                                                    CpG_pos) %>%
                                                    mutate(stop = start + 1),
                                                  keep.extra.columns = FALSE,
                                                  seqnames.field = "chr",
                                                  start.field = "start",
                                                  end.field = "stop")

coldata <- as.data.frame(coldata)
rownames(coldata) <- coldata$sample

coldata <- coldata[coldata$sample %in% names(methylation_values), ]

methylation_in_FGC <- SummarizedExperiment(assays = methylation_values[, coldata$sample],
                                           rowRanges = methylation_values_GR,
                                           colData = coldata)

save(methylation_in_FGC, file = "../../eh_data/methylation_in_FGC.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `embryo_sce_Zhu` dataset goes here

library(tidyverse)
library(biomaRt)
library(SingleCellExperiment)


## Data from Single Cell DNA Methylome Sequencing of Human Preimplantation
## Embryos (Zhu et al. 2018)
## 50 FPKM files were downloaded from GEO (accession: GSE81233).


# FPKM expression values import
files <- list.files("../../../CTdata_extdata/GSE81233_RAW/", full.names = TRUE )
count_data <- read_tsv(files[1]) %>%
  dplyr::select(gene_id, FPKM)
sample <- gsub(".genes.fpkm_tracking.gz",
               x = gsub('.*_Icm', x = files[1], 'Icm'), '')

# Some genes have several expression values corresponding to several isoforms
# Remove duplicated and keep the max FPKM per gene
count_data <- count_data %>%
  group_by(gene_id) %>%
  summarize(max_FPKM = max(FPKM))
names(count_data) <- c("gene", sample)

for (file in files[-1]){
  tmp <- read_tsv(file) %>%
    dplyr::select(gene_id, FPKM)
  sample <- gsub(".genes.fpkm_tracking.gz",
                 x = gsub('.*_Icm', x = file, 'Icm'), '')
  tmp <- tmp %>%
    group_by(gene_id) %>%
    summarize(max_FPKM = max(FPKM))
  names(tmp) <- c("gene", sample)
  count_data <- dplyr::left_join(count_data, tmp)
}


coldata <- tibble(sample = colnames(count_data[,-1])) %>%
  mutate(embryo = gsub(x = sample, pattern = "-\\w*$", ""))

## Determine gender of blastocysts

# identify Y-linked genes highly expressed
ensembl <- biomaRt::useDataset("hsapiens_gene_ensembl", useMart("ensembl"))

attributes_vector <- c("ensembl_gene_id", "external_gene_name",
                        "ensembl_transcript_id", "external_transcript_name",
                        "chromosome_name", "strand", "transcript_start",
                        "transcript_end", "transcription_start_site",
                        "transcript_length", "transcript_tsl",
                        "transcript_gencode_basic", "transcript_appris",
                        "transcript_mane_select", "transcript_biotype",
                        "transcript_is_canonical" )

transcripts_infos <- as_tibble(biomaRt::getBM(attributes = attributes_vector,
                                               mart = ensembl))
Y_linked <- transcripts_infos %>%
  filter(external_gene_name %in% count_data$gene) %>%
  filter(chromosome_name == "Y") %>%
  pull(external_gene_name) %>%
  unique()

# Y-linked genes  expressed in the dataset
mat <- as.matrix(count_data[,-1])
rownames(mat) <- count_data$gene
Y_linked_expressed <- Y_linked[Y_linked %in% rownames(mat)[rowSums(mat) > 10]]

# After analysis, RPS4Y1 seems to be the best gene to determine gender
# If the mean expression of RPS4Y1 is higher than 50 FPKM, it's a male sample

embryo_gender <- count_data %>%
  filter(gene %in% c("RPS4Y1")) %>%
  pivot_longer(names_to = "sample", values_to = "FPKM", -gene) %>%
  left_join(coldata) %>%
  group_by(embryo) %>%
  summarize(mean_RPS4Y1 = mean(FPKM)) %>%
  mutate(sex = ifelse(mean_RPS4Y1 > 50, "M", "F")) %>%
  dplyr::select(embryo, sex)

coldata <- coldata %>%
  left_join(embryo_gender) %>%
  mutate(genotype = ifelse(sex == "M", "XY", "XX")) %>%
  mutate(stage = "blastocyst")

embryo_sce_Zhu <- SingleCellExperiment(assays = mat[, coldata$sample],
                                       colData = coldata)

save(embryo_sce_Zhu, file = "../../eh_data/embryo_sce_Zhu.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `all_genes` and `CT_genes` dataset goes here

library("tidyverse")
library("SummarizedExperiment")

load("../../../CTdata_extdata/all_genes_prelim.rda")
load(file = "../../eh_data/mean_methylation_in_tissues.rda")
load(file = "../../eh_data/DAC_treated_cells_multimapping.rda")

################################################################################
## Add DAC_induced column specifying if genes are induced by
## 5-Aza-2′-Deoxycytidine
################################################################################
induced <- as_tibble(rowData(DAC_treated_cells_multimapping),
                     rownames = "ensembl_gene_id") %>%
  filter(induced) %>%
  pull(external_gene_name)

not_induced <- as_tibble(rowData(DAC_treated_cells_multimapping),
                         rownames = "ensembl_gene_id") %>%
  filter(!induced) %>%
  pull(external_gene_name)

unclear <- as_tibble(rowData(DAC_treated_cells_multimapping),
                     rownames = "ensembl_gene_id") %>%
  filter(is.na(induced)) %>%
  pull(external_gene_name)

all_genes <- all_genes_prelim %>%
  mutate(DAC_induced = case_when(external_gene_name %in% induced ~ TRUE,
                                 external_gene_name %in% not_induced ~ FALSE,
                                 external_gene_name %in% unclear ~ NA))


################################################################################
## Add CpG densities and promoter methylation analysis in normal tissues
################################################################################
all_genes <- all_genes %>%
  left_join(as_tibble(rowData(mean_methylation_in_tissues)))

################################################################################
## Based on DAC induction and on methylation levels in normal tissues
## (if available).For some genes, methylation analysis was not possible due
## to multimapping issues. In this case, genes are still considered as regulated
## by methylation if they show a strong activation in cells treated with
## 5-Aza-2′-Deoxycytidine.
################################################################################

all_genes <- all_genes %>%
  mutate(regulated_by_methylation =
           case_when((somatic_methylation | is.na(somatic_methylation)) &
                       DAC_induced ~ TRUE,
                     !somatic_methylation ~ FALSE,
                     !DAC_induced ~ FALSE,
                     is.na(DAC_induced) ~ NA))

################################################################################
## Add X_linked information
################################################################################

all_genes <- all_genes %>%
  mutate(X_linked = ifelse(chromosome_name == "X", TRUE, FALSE))

################################################################################
## Flag genes as "oncogenic" or "tumor suppressor" using
## [Cancermine](http://bionlp.bcgsc.ca/cancermine/), a literature-mined database
## of drivers, oncogenes and tumor suppressors in cancer.
################################################################################
if (!file.exists("../../../CTdata_extdata/cancermine_collated.tsv")) {
  download.file(url = "https://zenodo.org/record/7537824/files/cancermine_collated.tsv?download=1",
                destfile = "../extdata/cancermine_collated.tsv")
}
cancermine <- read_tsv("../extdata/cancermine_collated.tsv")
oncogenes <- cancermine %>%
  filter(role == "Oncogene") %>%
  pull(gene_normalized)
TS <- cancermine %>%
  filter(role == "Tumor_Suppressor") %>%
  pull(gene_normalized)
all_genes <- all_genes %>%
  mutate(oncogene = case_when(external_gene_name %in% oncogenes ~
                                "oncogene")) %>%
  mutate(tumor_suppressor = case_when(external_gene_name %in% TS ~
                                        "tumor_suppressor"))

################################################################################
# Reorder the final table
################################################################################
all_genes <- all_genes %>%
  dplyr::rename(chr = chromosome_name) %>%
  dplyr::select("ensembl_gene_id", "external_gene_name", "CT_gene_type",
                "testis_specificity", "regulated_by_methylation", "X_linked",
                "chr", "strand", "transcript_start", "transcript_end",
                "transcription_start_site", everything())

save(all_genes, file = "../../eh_data/all_genes.rda",
     compress = "xz",
     compression_level = 9)

CT_genes <- all_genes %>%
  filter(CT_gene_type != "other") %>%
  arrange(desc(CT_gene_type))

save(CT_genes, file = "../../eh_data/CT_genes.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `TCGA_CT_methylation` dataset goes here

library("TCGAbiolinks")
library("tidyverse")
library("SummarizedExperiment")
library("GenomicRanges")
library("BiocFileCache")
library("org.Hs.eg.db")

load("../../../CTdata_extdata/all_genes_prelim.rda")

bfc <- BiocFileCache(cache = "../../../CTdata_extdata/BiocFileCache",
                     ask = FALSE)

for(tumor_code in c("SKCM", "LUAD", "LUSC", "COAD", "ESCA", "BRCA", "HNSC")) {
  rname <- paste0("TCGA_", tumor_code, "_methylation")

  if(length(bfcquery(bfc, rname)$rid) == 0) {

    savepath <- bfcnew(bfc, rname, ext=".RData")

    # Query data
    query_gene_counts_harmonized <-
      GDCquery(project = paste0("TCGA-", tumor_code),
               data.category = "DNA Methylation",
               data.type = "Methylation Beta Value",
               platform = "Illumina Human Methylation 450",
               legacy = FALSE)

    # Download files
    GDCdownload(query_gene_counts_harmonized, method = "api",
                directory = paste0("./tmp/TCGA_", tumor_code, "_methylation"),
                files.per.chunk = 10)

    # Create a Summarized-Experiment object
    GDCprepare(query_gene_counts_harmonized,
               directory = paste0("./tmp/TCGA_", tumor_code, "_methylation"),
               save = TRUE,
               save.filename = savepath,
               remove.files.prepared = FALSE)
  }
}

## Promoter region is defined as `nt_up` nucleotides upstream TSS
## and `nt_down` nucleotides downstream TSS
nt_up <- 1000
nt_down <- 200

promoter_gr <- makeGRangesFromDataFrame(
  all_genes %>%
    dplyr::select(ensembl_gene_id, external_gene_name, external_transcript_name,
                  chromosome_name, strand, transcription_start_site) %>%
    mutate(chromosome_name = paste0("chr", chromosome_name)) %>%
    mutate(strand = if_else(strand == 1, '+', '-')) %>%
    mutate(start = case_when(strand == '+' ~ transcription_start_site - nt_up,
                             strand == '-' ~
                               transcription_start_site - nt_down)) %>%
    mutate(stop = case_when(strand == '+' ~ transcription_start_site + nt_down,
                            strand == '-' ~ transcription_start_site + nt_up)),
  keep.extra.columns = TRUE,
  seqnames.field = "chromosome_name",
  start.field = "start",
  end.field = "stop")

## SKCM_methylation
load(bfc[[bfcquery(bfc, "TCGA_SKCM_methylation")$rid]])
SKCM_methylation <- subsetByOverlaps(data, promoter_gr)

## LUAD_methylation
load(bfc[[bfcquery(bfc, "TCGA_LUAD_methylation")$rid]])
LUAD_methylation <- subsetByOverlaps(data, promoter_gr)

## LUSC_methylation
load(bfc[[bfcquery(bfc, "TCGA_LUSC_methylation")$rid]])
LUSC_methylation <- subsetByOverlaps(data, promoter_gr)

## COAD_methylation
load(bfc[[bfcquery(bfc, "TCGA_COAD_methylation")$rid]])
COAD_methylation <- subsetByOverlaps(data, promoter_gr)

## ESCA_methylation
load(bfc[[bfcquery(bfc, "TCGA_ESCA_methylation")$rid]])
ESCA_methylation <- subsetByOverlaps(data, promoter_gr)

## BRCA_methylation
load(bfc[[bfcquery(bfc, "TCGA_BRCA_methylation")$rid]])
BRCA_methylation <- subsetByOverlaps(data, promoter_gr)

## HNSC_methylation
load(bfc[[bfcquery(bfc, "TCGA_HNSC_methylation")$rid]])
HNSC_methylation <- subsetByOverlaps(data, promoter_gr)

met <- cbind(assay(SKCM_methylation), assay(LUAD_methylation),
             assay(LUSC_methylation), assay(COAD_methylation),
             assay(ESCA_methylation), assay(BRCA_methylation),
             assay(HNSC_methylation))

colData(SKCM_methylation)$sample <- substr(colData(SKCM_methylation)$samples,
                                           1, 16)
colData(SKCM_methylation)$project_id <- "TCGA-SKCM"
colData(LUAD_methylation)$sample <- substr(colData(LUAD_methylation)$samples,
                                           1, 16)
colData(LUAD_methylation)$project_id <- "TCGA-LUAD"
colData(LUSC_methylation)$sample <- substr(colData(LUSC_methylation)$samples,
                                           1, 16)
colData(LUSC_methylation)$project_id <- "TCGA-LUSC"
colData(COAD_methylation)$sample <- substr(colData(COAD_methylation)$samples,
                                           1, 16)
colData(COAD_methylation)$project_id <- "TCGA-COAD"
colData(ESCA_methylation)$sample <- substr(colData(ESCA_methylation)$samples,
                                           1, 16)
colData(ESCA_methylation)$project_id <- "TCGA-ESCA"
colData(BRCA_methylation)$sample <- substr(colData(BRCA_methylation)$samples,
                                           1, 16)
colData(BRCA_methylation)$project_id <- "TCGA-BRCA"
colData(HNSC_methylation)$sample <- substr(colData(HNSC_methylation)$samples,
                                           1, 16)
colData(HNSC_methylation)$project_id <- "TCGA-HNSC"

coldata <- rbind(colData(SKCM_methylation),
                 colData(LUAD_methylation),
                 colData(LUSC_methylation),
                 colData(COAD_methylation),
                 colData(ESCA_methylation),
                 colData(BRCA_methylation),
                 colData(HNSC_methylation))

TCGA_methylation <-
  SummarizedExperiment(assays = list(methylation = met),
                       colData = coldata,
                       rowRanges = rowRanges(SKCM_methylation))

save(TCGA_methylation, file = "../../eh_data/TCGA_methylation.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `CCLE_data` dataset goes here

library(tidyverse)
library(SummarizedExperiment)
library(BiocFileCache)
library(biomaRt)

load("../../eh_data/GTEX_data.rda")

bfc <- BiocFileCache(cache = "../../../CTdata_extdata/BiocFileCache",
                     ask = FALSE)

if (length(bfcquery(bfc, "CCLE_data")$rid) == 0) {
  url <- "https://ndownloader.figshare.com/files/34989922"
  bfcadd(bfc, "CCLE_data", fpath = url)
}

if (length(bfcquery(bfc, "CCLE_cell_metadata")$rid) == 0) {
  url <- "https://ndownloader.figshare.com/files/35020903"
  bfcadd(bfc, "CCLE_cell_metadata", fpath = url)
}

CCLE_full_data <- read_csv(bfc[[bfcquery(bfc, "CCLE_data")$rid]])
names(CCLE_full_data)[1] <- "DepMap_ID"
CCLE_metadata <- read_csv(bfc[[bfcquery(bfc, "CCLE_cell_metadata")$rid]])

## Select tumor cell lines and clean "primary_disease" category
coldata <- CCLE_metadata %>%
  filter(DepMap_ID %in% CCLE_full_data$DepMap_ID) %>%
  filter(primary_disease != "Unknown") %>%
  filter(primary_disease != "Fibroblast") %>%
  filter(primary_disease != "Engineered") %>%
  filter(primary_disease != "Non-Cancerous") %>%
  mutate(type = sub(pattern = " Cancer", x = primary_disease,
                    replacement = '')) %>%
  mutate(type = sub(pattern = "Colon/", x = type, replacement = '')) %>%
  mutate(type = sub(pattern = "Endometrial/", x = type, replacement = '')) %>%
  mutate(type = gsub(pattern = " ", x = type, replacement = '_')) %>%
  filter(!is.na(stripped_cell_line_name)) %>%
  as.data.frame()

## Keep cancer types with more than 30 cell lines
tumor_types <- coldata %>%
  dplyr::group_by(type) %>%
  dplyr::summarize(n = n()) %>%
  filter(n >= 30) %>%
  pull(type)

coldata <- coldata[coldata$type %in% tumor_types, ]
rownames(coldata) <- coldata$stripped_cell_line_name

## Reformat CCLE data keeping only genes present in GTEx data
TPM <- CCLE_full_data %>%
  pivot_longer(names_to = "gene", values_to = "expression", -DepMap_ID) %>%
  mutate(ensembl_gene_id = str_extract(gene, "ENSG\\d{11}")) %>%
  dplyr::select(-gene) %>%
  filter(DepMap_ID %in% coldata$DepMap_ID) %>%
  filter(ensembl_gene_id %in% rownames(GTEX_data)) %>%
  left_join(as_tibble(rowData(GTEX_data), rownames = "ensembl_gene_id") %>%
              dplyr::select(ensembl_gene_id, external_gene_name)) %>%
  left_join(coldata %>%
              dplyr::select(DepMap_ID, stripped_cell_line_name)) %>%
  dplyr::select(-DepMap_ID) %>%
  pivot_wider(names_from = stripped_cell_line_name, values_from = expression)

TPM_mat <- TPM %>%
  dplyr::select(-ensembl_gene_id, -external_gene_name) %>%
  as.matrix()
rownames(TPM_mat) <- TPM$ensembl_gene_id

## Values are in log2(TPM + 1), convert to TPM
TPM_mat <- 2^(TPM_mat) - 1

# Estimate frequencies of cell lines expressing each gene
# Gene are considered as "activated" if TPM >= TPM_thr
TPM_thr <- 1
activation_frequencies <- tibble(ensembl_gene_id = rownames(TPM_mat)) %>%
  left_join(as_tibble(rowData(GTEX_data), rownames = "ensembl_gene_id") %>%
              dplyr::select(ensembl_gene_id, external_gene_name))
binary <- ifelse(TPM_mat >= TPM_thr, 1, 0)
tmp <- rowSums(binary) / ncol(binary) * 100
tmp <- enframe(tmp, name = "ensembl_gene_id",
               value = "percent_of_positive_CCLE_cell_lines")
activation_frequencies <- left_join(activation_frequencies, tmp)

# Estimate the percent of cell line in which the genes
# are not expressed (TPM <= TPM_low_thr)
TPM_low_thr <- 0.5
binary <- ifelse(TPM_mat <= TPM_low_thr, 1, 0)
tmp <- rowSums(binary) / ncol(binary) * 100
repression_frequencies <- enframe(tmp, name = "ensembl_gene_id",
                                  value = "percent_of_negative_CCLE_cell_lines")

# Max expression (TPM) in a cell line
max_TPM <- tibble(ensembl_gene_id = rownames(TPM_mat),
                  max_TPM_in_CCLE = rowMax(TPM_mat))

rowdata <- left_join(activation_frequencies, repression_frequencies) %>%
  left_join(max_TPM) %>%
  mutate(percent_of_positive_CCLE_cell_lines =
           round(percent_of_positive_CCLE_cell_lines, 1)) %>%
  mutate(percent_of_negative_CCLE_cell_lines =
           round(percent_of_negative_CCLE_cell_lines, 1)) %>%
  mutate(CCLE_category =
           case_when(is.na(percent_of_positive_CCLE_cell_lines) ~ "not_in_CCLE",
                     percent_of_negative_CCLE_cell_lines < 20 ~ "leaky",
                     percent_of_negative_CCLE_cell_lines >= 20 &
                       percent_of_positive_CCLE_cell_lines >= 1 &
                       max_TPM_in_CCLE >= 5 ~ "activated",
                     percent_of_negative_CCLE_cell_lines >= 20 &
                       percent_of_positive_CCLE_cell_lines < 1 ~ "not_activated",
                     percent_of_negative_CCLE_cell_lines >= 20 &
                       percent_of_positive_CCLE_cell_lines >= 1 &
                       max_TPM_in_CCLE < 5 ~ "lowly_activated")) %>%
  column_to_rownames("ensembl_gene_id")

CCLE_data <- SummarizedExperiment(assays = list(TPM = TPM_mat),
                                  rowData = rowdata,
                                  colData = coldata[colnames(TPM_mat), ])

save(CCLE_data, file = "../../eh_data/CCLE_data.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `scRNAseq_HPA` dataset goes here

library("tidyverse")
library("SummarizedExperiment")
library("SingleCellExperiment")

## scRNAseq from normal tissues downloaded from the Human Protein Atlas:
## - rna_single_cell_type.tsv downloaded directly from
## https://www.proteinatlas.org/about/download
## - The cell types group associated to each cell type were copied manually from
## https://www.proteinatlas.org/humanproteome/single+cell+type

data <- read_tsv("../../../CTdata_extdata/rna_single_cell_type.tsv")
data <- data %>%
  dplyr::rename(ensembl_gene_id = Gene, external_gene_name = "Gene name") %>%
  pivot_wider(names_from = "Cell type", values_from = "nTPM")
mat <- as.matrix(data[, -(1:2)])
rownames(mat) <- data$ensembl_gene_id
colnames(mat) <- str_to_sentence(colnames(mat))

rowdata <- data.frame("external_gene_name" = data$external_gene_name)
rownames(rowdata) <- data$ensembl_gene_id

cell_types <- c("Adipocyte_cells", "Blood_immune_cells", "Endocrine_cells",
                "Endothelial_cells", "Germ_cells", "Glandular_cells",
                "Glial_cells", "Mesenchymal_cells", "Pigment_cells",
                "Specialized_epithelial_cells", "Trophoblast_cells")

cell_types_by_group <- read_tsv(paste0("../../../CTdata_extdata/",
                                       cell_types[1]), col_select = 1,
                                col_names = c("Cell_type")) %>%
  mutate(group = cell_types[1])

for (cell in cell_types[-1]){
  tmp <- read_tsv(paste0("../../../CTdata_extdata/", cell), col_select = 1,
                  col_names = c("Cell_type")) %>%
    mutate(group = cell)
  cell_types_by_group <- rbind(cell_types_by_group, tmp)
}
cell_types_by_group$Cell_type <- str_to_sentence(cell_types_by_group$Cell_type)

# Rm "Hofbauer cells" (placental cells => confusing)
cell_types_by_group <- cell_types_by_group %>%
  filter(Cell_type != "Hofbauer cells")

scRNAseq_HPA <- SingleCellExperiment(assays = list(TPM = mat[, cell_types_by_group$Cell_type]),
                                     colData = cell_types_by_group,
                                     rowData = rowdata)

not_somatic_group <- c("Germ_cells", "Trophoblast_cells")
somatic_groups <- unique(cell_types_by_group$group[
  !cell_types_by_group$group %in% not_somatic_group])

##########################################################################
## Add 3 columns to the rowData:
## - `values_in_somatics` giving the maximum expression value found in a
## somatic cell type
## - `max_in_germcells_group` giving the maximum expression value found in
## a germ cell type
## - `Higher_in_somatic_cell_type` column, specifying if a somatic cell type
## was found to express the gene at a higher level than any germ cell type
##########################################################################

values_in_somatics <- as_tibble(assay(scRNAseq_HPA),
                                rownames = "ensembl_gene_id") %>%
  pivot_longer(names_to = "Cell_type", values_to = "counts",
               -ensembl_gene_id) %>%
  left_join(as_tibble(colData(scRNAseq_HPA))) %>%
  filter(group %in% somatic_groups) %>%
  group_by(ensembl_gene_id, group) %>%
  summarise(max_TPM_in_a_somatic_cell_type = max(counts)) %>%
  filter(max_TPM_in_a_somatic_cell_type == max(max_TPM_in_a_somatic_cell_type)) %>%
  dplyr::select(-group) %>%
  unique()

values_in_germCells <- as_tibble(assay(scRNAseq_HPA),
                                 rownames = "ensembl_gene_id") %>%
  pivot_longer(names_to = "Cell_type", values_to = "counts",
               -ensembl_gene_id) %>%
  left_join(as_tibble(colData(scRNAseq_HPA))) %>%
  filter(group == "Germ_cells") %>%
  group_by(ensembl_gene_id) %>%
  summarise(max_in_germcells_group = max(counts)) %>%
  unique()

rowdata <- as_tibble(rowData(scRNAseq_HPA), rownames = "ensembl_gene_id") %>%
  left_join(values_in_somatics) %>%
  left_join(values_in_germCells) %>%
  mutate(Higher_in_somatic_cell_type =
           case_when((max_TPM_in_a_somatic_cell_type > 0 |
                        max_in_germcells_group > 0) &
                       max_TPM_in_a_somatic_cell_type > max_in_germcells_group
                     ~ TRUE,
                     (max_TPM_in_a_somatic_cell_type > 0 |
                        max_in_germcells_group > 0) &
                       max_TPM_in_a_somatic_cell_type <= max_in_germcells_group
                     ~ FALSE,
                     (max_TPM_in_a_somatic_cell_type == 0 &
                        max_in_germcells_group == 0) ~ NA)) %>%
  as.data.frame()

rownames(rowdata) <- rowdata$ensembl_gene_id
rowData(scRNAseq_HPA) <- rowdata[, -1]

save(scRNAseq_HPA, file = "../../eh_data/scRNAseq_HPA.rda",
     compress = "xz",
     compression_level = 9)

## Code to prepare `all_genes_prelim` dataset goes here

library("tidyverse")
library("SummarizedExperiment")
library("biomaRt")

load(file = "../../eh_data/GTEX_data.rda")
load(file = "../../eh_data/CCLE_data.rda")
load(file = "../../eh_data/normal_tissues_multimapping_data.rda")
load(file = "../../eh_data/HPA_cell_type_specificities.rda")
load(file = "../../eh_data/DAC_treated_cells_multimapping.rda")
load(file = "../../eh_data/TCGA_TPM.rda")

################################################################################
## Start from rowData(GTEX), summarizing the tissue specificity category
## assigned to each gene using GTEx database
################################################################################
all_genes_prelim <- as_tibble(rowData(GTEX_data), rownames = "ensembl_gene_id")
all_genes_prelim$TPM_testis <- assay(GTEX_data)[, "Testis"]


################################################################################
## Add multimapping_analysis column from normal_tissues_multimapping_data,
## assessing testis-specificity of genes flagged as "lowly_expressed" in
## GTEX_category from GTEX_data (when their TPM < 1 in testis)
################################################################################
all_genes_prelim <- all_genes_prelim %>%
  left_join(as_tibble(rowData(normal_tissues_multimapping_data),
                      rownames = "ensembl_gene_id"))


################################################################################
## Add HPA_cell_type_specificity (based on data from the Human Protein Atlas) to
## add cell type specificities and flag genes expressed in a somatic cell type
################################################################################
all_genes_prelim <- all_genes_prelim %>%
  left_join(HPA_cell_type_specificities)


################################################################################
## Add info from rowData(CCLE_data), summarising the analysis of CCLE
## database. In CCLE_category, genes are tagged as "activated" when
## at least 20 % of cell lines are negative (TPM <= 0.5)
## and at least 1% of cell line is highly positive (TPM >= 1)
## and and expressed at TPM > 5 in at least one cell line
## (to avoid leaky genes)
################################################################################
all_genes_prelim <- all_genes_prelim %>%
  left_join(as_tibble(rowData(CCLE_data), rownames = "ensembl_gene_id"))
all_genes_prelim[is.na(all_genes_prelim$CCLE_category),
                 "CCLE_category"] <- "not_in_CCLE"


################################################################################
## Add info from rowData(TCGA_TPM), summarizing the analysis of TCGA
## tumor samples. In TCGA_category, genes are tagged as "activated" when
## at least 20 % of tumors are negative (TPM <= 0.5), at least 1% of tumors
## are positive (TPM >= 1) and expressed at TPM > 5 in at least one tumor
## (to avoid leaky genes). Genes that were flagged as testis-specific in
## `multimapping analysis` are flagged as "mulimapping_issue" in TCGA_category,
## as most of them  are not detected in TCGA database
## (we cannot filter on their expression in TCGA dataset).
################################################################################
all_genes_prelim <- all_genes_prelim %>%
  left_join(as_tibble(rowData(TCGA_TPM), rownames = "ensembl_gene_id") %>%
              dplyr::select(ensembl_gene_id, external_gene_name,
                            percent_pos_tum, percent_neg_tum, max_TPM_in_TCGA,
                            max_q75_in_NT, TCGA_category))

all_genes_prelim[all_genes_prelim$lowly_expressed_in_GTEX == TRUE ,
                 "TCGA_category"] <- "multimapping_issue"

################################################################################
## Add testis_specificity summarizing testis-specificity analysis from
## GTEX, multimapping, HPA_cell_type_specificities, CCLE and TCGA categories
## Testis-specific genes must be:
## - classified as "testis-specific" in GTEX or multimappig analysis
## - must not be detected in any somatic cell type (in HPA scRNAseq analysis)
## - can not be classified as "leaky" in CLLE and TCGA categories
## - can not be detected (TPM > 0.5) in more than 75% of normal peritumoral
## tissues from a TCGA tumor type
## Testis_preferential genes must be:
## - classified as "testis_preferential" in GTEX or multimappig analysis
## - or initially classified as "testis-specific" in GTEX or multimappig
## analysis but downgraded to "testis_preferential because they were detected
## in a somatic cell type (in HPA scRNAseq analysis)
## - can be detected in some somatic cell type but the level has to be at
## least 10 times lower than the level detected in a germ cell type
## (in HPA scRNAseq analysis)
## - must not be classified as "leaky" in CLLE and TCGA categories
################################################################################

all_genes_prelim <- all_genes_prelim %>%
  mutate(testis_specificity = case_when(
    (GTEX_category == "testis_specific" |
       multimapping_analysis == "testis_specific") &
      (is.na(not_detected_in_somatic_HPA) | not_detected_in_somatic_HPA) &
      CCLE_category != "leaky" &
      TCGA_category != "leaky" &
      (TCGA_category == "multimapping_issue" |
         max_q75_in_NT < 0.5) ~ 'testis_specific',
    # Downgrade TS to TP based on HPA (if detected in somatic cell type but only
    # if it is detected at a level lower than 10 times than in a germ cell type)
    (GTEX_category == "testis_specific" |
       multimapping_analysis == "testis_specific") &
      !not_detected_in_somatic_HPA &
      HPA_ratio_germ_som >= 10 &
      CCLE_category != "leaky" &
      TCGA_category != "leaky" ~ 'testis_preferential',
    (GTEX_category == "testis_preferential" |
       multimapping_analysis == "testis_preferential") &
      (is.na(HPA_ratio_germ_som) | HPA_ratio_germ_som >= 10) &
      CCLE_category != "leaky" &
      TCGA_category != "leaky"  ~ "testis_preferential"))

all_genes_prelim$testis_specificity[
  is.na(all_genes_prelim$testis_specificity)] <- "not_testis_specific"

################################################################################
## create CT_gene_type column, specifiying if a gene is
## - a "Cancer testis gene" (CT_gene): testis-specific genes activated in CCLE
## cell lines and TCGA tumor samples.
## - or a "Cancer testis-preferential gene" (CTP_gene) (testis-preferential
## genes activated in CCLE cell lines and TCGA tumor samples).
################################################################################
all_genes_prelim <- all_genes_prelim %>%
  mutate(CT_gene_type = case_when(
    testis_specificity == "testis_specific" & CCLE_category == "activated" &
      (TCGA_category == "multimapping_issue" | TCGA_category == "activated")
    ~ "CT_gene",
    testis_specificity == "testis_preferential" & CCLE_category == "activated" &
      (TCGA_category == "multimapping_issue" | TCGA_category == "activated")
    ~ "CTP_gene"))

all_genes_prelim$CT_gene_type[is.na(all_genes_prelim$CT_gene_type)] <- "other"


################################################################################
## Associate each gene to its most biologically relevant transcript,
## selecting the canonical transcript from ensembl database.
## Add the TSS coordinates
################################################################################
ensembl <- biomaRt::useDataset("hsapiens_gene_ensembl", useMart("ensembl"))
attributes_vector <- c("ensembl_gene_id",
                       "external_gene_name",
                       "ensembl_transcript_id",
                       "external_transcript_name",
                       "chromosome_name",
                       "strand",
                       "transcript_start",
                       "transcript_end",
                       "transcription_start_site",
                       "transcript_length",
                       "transcript_biotype",
                       "transcript_is_canonical")
transcripts_infos <- as_tibble(biomaRt::getBM(attributes = attributes_vector,
                                              mart = ensembl))
canonical_transcripts <- transcripts_infos %>%
  filter(transcript_is_canonical == 1) %>%
  filter(chromosome_name %in% c(1:22, "X", "Y", "MT")) %>%
  filter(transcript_biotype == "protein_coding" |
           transcript_biotype == "lncRNA")

all_genes_prelim <- all_genes_prelim %>%
  left_join(canonical_transcripts %>%
              dplyr::select(ensembl_gene_id,
                            external_transcript_name, ensembl_transcript_id,
                            chromosome_name, strand, transcript_start,
                            transcript_end, transcription_start_site,
                            transcript_length, transcript_biotype))

## Rm the few duplicated external genes (with more than one canonical
## transcript)
all_genes_prelim <- all_genes_prelim %>%
  filter(!duplicated(external_gene_name))


################################################################################
## Check the backbone of all selected CT genes by visualising RNA-seq reads
## from a testis sample using the Genome Integrative Viewer (IGV).
## The aim was initially to identify precisely the transcription start site of
## each gene, but unexpectedly we observed that for some genes, the reads were
## not properly aligned on exons, but were instead spread across a wide genomic
## region spanning the genes. These genes, flagged as "unclear" in IGV_backbone
## column, were removed from the CT_gene category
## as their expression values in GTEX, TCGA and CCLE might reflect a poorly
## defined transcription in these regions and are hence likely unreliable.
################################################################################

all_genes_prelim$IGV_backbone <- NA
all_genes_prelim[all_genes_prelim$external_gene_name == "MBD3L2",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "NKX2-4",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "FOXR2",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "PSG3",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "DMP1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "ZNF679",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "OR8G5",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "VRTN",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "MBD3L5",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "SPANXN1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "ROR1-AS1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01344",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "SMYD3-AS1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01913",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "KIAA2012-AS1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01980",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01811",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "IGF2BP2-AS1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02020",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "SNHG27",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02492",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02434",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02113",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02522",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "SIM1-AS1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC00326",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "ST7-OT4",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01517",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC00867",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02742",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "DLG2-AS2",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02378",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "MRPS35-DT",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02156",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC00392",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02293",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "G2E3-AS1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC00221",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02152",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02184",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01925",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01895",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01029",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "ZBTB46-AS1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01203",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "FAM197Y7",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "FAM197Y6",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC00112",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "ARHGAP29-AS1",
                 "IGV_backbone"] <- "unclear"


all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01804",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "DLX2-DT",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02050",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01208",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01019",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02211",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02109",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02531",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "FIBCD1-AS1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02646",
                 "IGV_backbone"] <- "unclear"

all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02700",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02327",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01583",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "TP53TG3D",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "SMIM47",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "KRTAP20-4",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC01665",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "XKR3",
                 "IGV_backbone"] <- "unclear"





################################################################################
## idem but for CTP_genes
################################################################################
all_genes_prelim[all_genes_prelim$external_gene_name == "IL5",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "MYCNOS",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LEF1-AS1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02367",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC02076",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC00664",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "UMODL1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "P2RX3",
                 "IGV_backbone"] <- "unclear"

all_genes_prelim[all_genes_prelim$external_gene_name == "GS1-24F4.2",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "USP2-AS1",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LINC00943",
                 "IGV_backbone"] <- "unclear"
all_genes_prelim[all_genes_prelim$external_gene_name == "LKAAEAR1",
                 "IGV_backbone"] <- "unclear"

all_genes_prelim[!is.na(all_genes_prelim$IGV_backbone) &
                   all_genes_prelim$IGV_backbone == "unclear",
                 "CT_gene_type"] <- "other"

################################################################################
## Add gene family column
################################################################################

all_genes_prelim$family <- NA
all_genes_prelim[grep(pattern = "MAGE", x = all_genes_prelim$external_gene_name,
                      value = FALSE), "family"] <- "MAGE"
all_genes_prelim[grep(pattern = "CT45A",
                      x = all_genes_prelim$external_gene_name,
                      value = FALSE), "family"] <- "CT45A"
all_genes_prelim[grep(pattern = "CTAG", x = all_genes_prelim$external_gene_name,
                      value = FALSE), "family"] <- "CTAG"
all_genes_prelim[grep(pattern = "GAGE", x = all_genes_prelim$external_gene_name,
                      value = FALSE), "family"] <- "GAGE"
all_genes_prelim[grep(pattern = "XAGE", x = all_genes_prelim$external_gene_name,
                      value = FALSE), "family"] <- "GAGE"
all_genes_prelim[grep(pattern = "PAGE", x = all_genes_prelim$external_gene_name,
                      value = FALSE), "family"] <- "PAGE"
all_genes_prelim[grep(pattern = "SPANX",
                      x = all_genes_prelim$external_gene_name,
                      value = FALSE), "family"] <- "SPANX"
all_genes_prelim[grep(pattern = "SSX", x = all_genes_prelim$external_gene_name,
                      value = FALSE), "family"] <- "SSX"
all_genes_prelim[grep(pattern = "VCX", x = all_genes_prelim$external_gene_name,
                      value = FALSE), "family"] <- "VCX"
all_genes_prelim[grep(pattern = "TSPY", x = all_genes_prelim$external_gene_name,
                      value = FALSE), "family"] <- "TSPY"
all_genes_prelim[grep(pattern = "RBMY", x = all_genes_prelim$external_gene_name,
                      value = FALSE), "family"] <- "RBMY"

save(all_genes_prelim, file = "../extdata/all_genes_prelim.rda",
     compress = "xz",
     compression_level = 9)

## BiocManager::install("AzureStor")
library("AzureStor")

sas <- "taken_comes_here"
url <- "https://bioconductorhubs.blob.core.windows.net"
ep <- storage_endpoint(url, sas = sas)
container <- storage_container(ep, "staginghub")



## ------------------------------------------
## 2023-07-10

src <- c("/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/CT_methylation_in_tissues.rda",
  "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/CT_mean_methylation_in_tissues.rda",
  "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/TCGA_CT_methylation.rda",
  "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/CT_genes.rda",
  "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/CCLE_correlation_matrix.rda",
  "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/testis_sce.rda",
  "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/scRNAseq_HPA.rda")

dest <- c("CTdata/eh_data/v2/CT_methylation_in_tissues.rda",
         "CTdata/eh_data/v2/CT_mean_methylation_in_tissues.rda",
         "CTdata/eh_data/v2/TCGA_CT_methylation.rda",
         "CTdata/eh_data/v2/CT_genes.rda",
         "CTdata/eh_data/v2/CCLE_correlation_matrix.rda",
         "CTdata/eh_data/testis_sce.rda",
         "CTdata/eh_data/scRNAseq_HPA.rda")

storage_multiupload(container, src = src, dest = dest)

## ------------------------------------------
## 2023-10-11

src <- "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/CT_methylation_in_tissues.rda"
dest <- "CTdata/eh_data/v3/CT_methylation_in_tissues.rda"

storage_multiupload(container, src = src, dest = dest)

## ------------------------------------------
## 2024-08/09

src <- c("/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/CCLE_data.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/DAC_treated_cells_multimapping.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/DAC_treated_cells.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/GTEX_data.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/normal_tissues_multimapping_data.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/scRNAseq_HPA.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/TCGA_TPM.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/testis_sce.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/CT_genes.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/CCLE_correlation_matrix.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/all_genes.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/FGC_sce.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/HPA_cell_type_specificities.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/mean_methylation_in_tissues.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/methylation_in_tissues.rda",
        "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/oocytes_sce.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/TCGA_methylation.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/embryo_sce_Zhu.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/embryo_sce_Petropoulos.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/hESC_data.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/methylation_in_hESC.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/mean_methylation_in_hESC.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/methylation_in_FGC.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/mean_methylation_in_FGC.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/methylation_in_embryo.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/mean_methylation_in_embryo.rda")

dest <- c("CTdata/eh_data/v2/CCLE_data.rda",
          "CTdata/eh_data/v2/DAC_treated_cells_multimapping.rda",
          "CTdata/eh_data/v2/DAC_treated_cells.rda",
          "CTdata/eh_data/v2/GTEX_data.rda",
          "CTdata/eh_data/v2/normal_tissues_multimapping_data.rda",
          "CTdata/eh_data/v2/scRNAseq_HPA.rda",
          "CTdata/eh_data/v2/TCGA_TPM.rda",
          "CTdata/eh_data/v2/testis_sce.rda",
          "CTdata/eh_data/v3/CT_genes.rda",
          "CTdata/eh_data/v3/CCLE_correlation_matrix.rda",
          "CTdata/eh_data/all_genes.rda",
          "CTdata/eh_data/FGC_sce.rda",
          "CTdata/eh_data/HPA_cell_type_specificities.rda",
          "CTdata/eh_data/mean_methylation_in_tissues.rda",
          "CTdata/eh_data/methylation_in_tissues.rda",
          "CTdata/eh_data/oocytes_sce.rda",
          "CTdata/eh_data/TCGA_methylation.rda",
          "CTdata/eh_data/embryo_sce_Zhu.rda",
          "CTdata/eh_data/embryo_sce_Petropoulos.rda",
          "CTdata/eh_data/hESC_data.rda",
          "CTdata/eh_data/methylation_in_hESC.rda",
          "CTdata/eh_data/mean_methylation_in_hESC.rda",
          "CTdata/eh_data/methylation_in_FGC.rda",
          "CTdata/eh_data/mean_methylation_in_FGC.rda",
          "CTdata/eh_data/methylation_in_embryo.rda",
          "CTdata/eh_data/mean_methylation_in_embryo.rda")

# Deprecated CT_methylation_in_tissues.rda, CT_mean_methylation_in_tissues.rda,
# TCGA_CT_methylation.rda

storage_multiupload(container, src = src, dest = dest)

## ------------------------------------------
## 2024-10

src <- c("/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/mean_methylation_in_FGC.rda",
         "/storage/research/dduv/cbio-lg/cluster/Packages/CTdata/eh_data/mean_methylation_in_embryo.rda")

dest <- c("CTdata/eh_data/mean_methylation_in_FGC.rda",
          "CTdata/eh_data/mean_methylation_in_embryo.rda")

storage_multiupload(container, src = src, dest = dest)

## Code to prepare `testis_sce` dataset goes here

library(tidyverse)
library(SingleCellExperiment)
library(scater)
library(biomaRt)

## Data from The adult human testis transcriptional cell atlas (Guo et al. 2018)
## `GSE112013_Combined_UMI_table.txt.gz` was downloaded from GEO (accession:
## GSE112013). `TableS1` (cell metadata) comes from the paper's supplemental data.

## ! `TableS1` could only be downoaded as a pdf file!
## => Copied the pdf content and pasted it in data/Guo_et_al_TableS1 text file.
command <- "cat ../../../CTdata_extdata/Guo_et_al_TableS1 | tr ' ' '\n' > ../../../CTdata_extdata/Guo_et_al_TableS1_tmp"
system(command)

tableS1 <- read_table(file = "../../../CTdata_extdata/Guo_et_al_TableS1_tmp",
                      col_names = FALSE, skip = 5)

CellID <- vector()
nGene <- vector()
nUMI <- vector()
Final_clusters <- vector()

for (i in seq(1, nrow(tableS1), by = 4)) {
  CellID <- c(CellID, tableS1$X1[i])
  nGene <- c(nGene, tableS1$X1[i+1])
  nUMI <- c(nUMI, tableS1$X1[i+2])
  Final_clusters <- c(Final_clusters, tableS1$X1[i+3])
}

metadata <- tibble(CellID = CellID,
                   nGene = nGene,
                   nUMI = nUMI,
                   clusters = Final_clusters) %>%
  mutate(type = case_when(clusters == 1 ~ "SSC",
                          clusters == 2 ~ "Spermatogonia",
                          clusters == 3 ~ "Early_spermatocyte",
                          clusters == 4 ~ "Late_spermatocyte",
                          clusters == 5 ~ "Round_spermatid",
                          clusters == 6 ~ "Elongated_spermatid",
                          clusters == 7 ~ "Sperm1",
                          clusters == 8 ~ "Sperm2",
                          clusters == 9 ~ "Macrophage",
                          clusters == 10 ~ "Endothelial",
                          clusters == 11 ~ "Myoid",
                          clusters == 12 ~ "Sertoli",
                          clusters == 13 ~ "Leydig")) %>%
  mutate(Donor = sub(pattern = "-\\w*-\\d$", x = CellID, replacement = ''))

metadata$type <- factor(metadata$type,
                        levels = c("SSC", "Spermatogonia", "Early_spermatocyte",
                                   "Late_spermatocyte", "Round_spermatid",
                                   "Elongated_spermatid", "Sperm1", "Sperm2",
                                   "Macrophage", "Endothelial", "Myoid",
                                   "Sertoli", "Leydig"))

metadata$clusters <- as.factor(metadata$clusters)

counts <- read_tsv(file =
                     "../../../CTdata_extdata/GSE112013_Combined_UMI_table.txt")

# Some gene names are not the official ones!
ensembl <- biomaRt::useDataset("hsapiens_gene_ensembl", useMart("ensembl"))

attributes_vector <- c("ensembl_gene_id",
                       "external_gene_name",
                       "external_synonym",
                       "ensembl_transcript_id",
                       "external_transcript_name",
                       "chromosome_name",
                       "transcript_biotype",
                       "transcript_is_canonical")
transcripts_infos <- as_tibble(biomaRt::getBM(attributes = attributes_vector,
                                              mart = ensembl))
canonical_transcripts <- transcripts_infos %>%
  dplyr::filter(transcript_is_canonical == 1) %>%
  dplyr::filter(external_transcript_name != "") %>%
  dplyr::filter(chromosome_name %in% c(1:22, "X", "Y", "MT")) %>%
  dplyr::filter(transcript_biotype == "protein_coding" |
                  transcript_biotype == "lncRNA")

counts_correct_gene_names <- counts %>%
  filter(Gene %in% canonical_transcripts$external_gene_name)

counts_incorrect_gene_names <- counts %>%
  filter(!Gene %in% canonical_transcripts$external_gene_name)

# Change incorrect genes names using official ones, when possible
counts_incorrect_gene_names_rescued <- counts_incorrect_gene_names %>%
  left_join(canonical_transcripts %>%
              dplyr::select(ensembl_gene_id, external_gene_name,
                            external_synonym),
            by = c("Gene" = "external_synonym")) %>%
  dplyr::select(Gene, ensembl_gene_id, external_gene_name, everything()) %>%
  filter(!is.na(external_gene_name)) %>%
  filter(!external_gene_name %in% counts_correct_gene_names$Gene) %>%
  filter(!duplicated(external_gene_name)) %>%
  dplyr::select(-Gene, -ensembl_gene_id) %>%
  dplyr::rename(Gene = external_gene_name)

# Some synonymes have "ORF" instead of "orf" in their names!
# ! Convert genes with "orf" in their names to "ORF" !
# Example: problem with MAJIN gene, called C11orf85 in testis dataset
# and C11ORF85 in canonical_transcripts$external_synonym
counts_incorrect_gene_names_rescued_bis <- counts_incorrect_gene_names %>%
  left_join(canonical_transcripts %>%
              dplyr::select(ensembl_gene_id, external_gene_name,
                            external_synonym) %>%
              mutate(Gene = gsub("ORF", x = external_synonym, replace = "orf"))) %>%
  dplyr::select(Gene, ensembl_gene_id, external_gene_name, , everything()) %>%
  filter(!is.na(external_gene_name)) %>%
  filter(!external_gene_name %in% counts_correct_gene_names$Gene) %>%
  filter(!duplicated(external_gene_name)) %>%
  dplyr::select(-Gene, -ensembl_gene_id) %>%
  dplyr::rename(Gene = external_gene_name) %>%
  dplyr::select(-external_synonym)

counts <- rbind(counts_correct_gene_names,
                counts_incorrect_gene_names_rescued,
                counts_incorrect_gene_names_rescued_bis)



mat <- as.matrix(counts[, -1])
rownames(mat) <- counts$Gene
coldata <- data.frame(metadata[, -1], row.names = metadata$CellID)

testis_sce <- SingleCellExperiment(assays =
                                     list(counts = mat[, rownames(coldata)]),
                                   colData = coldata)
testis_sce <- logNormCounts(testis_sce)

##########################################################################
## Add 3 columns to the rowData:
## - `percent_pos_testis_germcells` giving the percent of testis germ cells
## in which the genes are detected (count > 0)
## - `percent_pos_testis_somatic` giving the percent of testis somatic cells
## in which the genes are detected (count > 0)
## - `testis_cell_type` column, specifying the testis cell-type showing
## the highest mean expression of each gene.
## Genes must be detected (count > 0) in at least 1% of the cells within
## a specific testis cell-type to be assigned to it.
##########################################################################

germ_cells <- c("SSC", "Spermatogonia", "Early_spermatocyte",
                "Late_spermatocyte","Round_spermatid", "Elongated_spermatid",
                "Sperm1", "Sperm2")
somatic_cells <- c("Macrophage", "Endothelial", "Myoid", "Sertoli", "Leydig")
n_germ_cells <- dim(testis_sce[, testis_sce$type %in% germ_cells])[2]
n_somatic_cells <- dim(testis_sce[, testis_sce$type %in% somatic_cells])[2]

percent_pos_germcells <- as_tibble(logcounts(testis_sce),
                                   rownames = "external_gene_name") %>%
  pivot_longer(names_to = "CellID", values_to = "logCounts",
               -external_gene_name) %>%
  left_join(as_tibble(colData(testis_sce), rownames = "CellID") %>%
              dplyr::select(CellID, type)) %>%
  filter(type %in% germ_cells) %>%
  group_by(external_gene_name, logCounts > 0) %>%
  summarize(n = n()) %>%
  filter(`logCounts > 0`) %>%
  mutate(n_germ_cells = n_germ_cells,
         percent_pos_testis_germcells = n / n_germ_cells * 100)

percent_pos_somatic <- as_tibble(logcounts(testis_sce),
                                 rownames = "external_gene_name") %>%
  pivot_longer(names_to = "CellID", values_to = "logCounts",
               -external_gene_name) %>%
  left_join(as_tibble(colData(testis_sce), rownames = "CellID") %>%
              dplyr::select(CellID, type)) %>%
  filter(type %in% somatic_cells) %>%
  group_by(external_gene_name, logCounts > 0) %>%
  summarize(n = n()) %>%
  filter(`logCounts > 0`) %>%
  mutate(n_germ_cells = n_somatic_cells,
         percent_pos_testis_somatic = n / n_germ_cells * 100)
### test begin
mean_exp_per_type <-as_tibble(logcounts(testis_sce),
                              rownames = "external_gene_name") %>%
  pivot_longer(names_to = "CellID", values_to = "logCounts",
               -external_gene_name) %>%
  left_join(as_tibble(colData(testis_sce), rownames = "CellID") %>%
              dplyr::select(CellID, type)) %>%
  group_by(external_gene_name, type) %>%
  summarise(mean_exp = mean(logCounts))


n_pos_cell_per_type <- as_tibble(logcounts(testis_sce),
                                 rownames = "external_gene_name") %>%
  pivot_longer(names_to = "CellID", values_to = "logCounts",
               -external_gene_name) %>%
  left_join(as_tibble(colData(testis_sce), rownames = "CellID") %>%
              dplyr::select(CellID, type)) %>%
  group_by(external_gene_name, type, logCounts > 0) %>%
  summarize(n_pos = n()) %>%
  filter(`logCounts > 0`)

testis_cell_type <- mean_exp_per_type %>%
  left_join(n_pos_cell_per_type %>%
              dplyr::select(-`logCounts > 0`)) %>%
  left_join(enframe(table(testis_sce$type), name = "type",
                    value = "n_cells")) %>%
  mutate(n_cells = as.vector(n_cells), percent_pos = n_pos / n_cells * 100) %>%
  filter(percent_pos > 1) %>%
  filter(mean_exp == max(mean_exp)) %>%
  dplyr::rename(testis_cell_type = type) %>%
  dplyr::select(external_gene_name, testis_cell_type) %>%
  unique()

rowData(testis_sce) <- tibble(external_gene_name = rownames(testis_sce)) %>%
  left_join(percent_pos_germcells %>%
              dplyr::select(external_gene_name,
                            percent_pos_testis_germcells)) %>%
  left_join(percent_pos_somatic %>%
              dplyr::select(external_gene_name,
                            percent_pos_testis_somatic)) %>%
  left_join(testis_cell_type)

save(testis_sce, file = "../../eh_data/testis_sce.rda",
     compress = "xz",
     compression_level = 9)

##' A short function that returns the default CTdata tags and, if
##' provided, additional data-specific tags.
##'
##' @param x An optional `character()` containing specific tags.
##'
##' @return
##'
##' A `character` containing the default tags and optional
##' data-specific tags. If `x` is missing or is of length 0, the
##' default tags are returned. Otherwise, a vector of length equal to
##' `length(x)` is returned.
##'
##' @examples
##'
##' CTdata:::makeTags() ## only default tags
##'
##' CTdata:::makeTags(character()) ## only default tags
##'
##' CTdata:::makeTags("myTag") ## one additional tag
##'
##' CTdata:::makeTags(c("myTag", "myOtherTag")) ## two additional tag
makeTags <- function(x) {
    defaultTags <- c("ExperimentHub", "ExperimentData",
                      "ReproducibleResearch", "RepositoryData",
                     "Homo_sapiens_Data")
    defaultTags <- paste(defaultTags, collapse = ":")
    if (missing(x) || !length(x))
        return(defaultTags)
    vapply(x, function(.x) paste(c(defaultTags, .x), collapse = ":"),
           USE.NAMES = FALSE, "")
}

test_that("makeTags() works", {
    makeTags <- CTdata:::makeTags
    res0 <- c("ExperimentHub", "ExperimentData",
              "ReproducibleResearch", "RepositoryData",
              "Homo_sapiens_Data")
    res0 <- paste0(res0, collapse = ":")
    expect_identical(makeTags(), res0)
    res1 <- paste0(c(res0, "Tag1"), collapse = ":")
    expect_identical(makeTags("Tag1"), res1)
    res2 <- c(res1,
              paste0(c(res0, "Tag2"), collapse = ":"))
    expect_identical(makeTags(c("Tag1", "Tag2")), res2)
})

##' @title All CTdata datasets
##'
##' @description
##'
##' This is the companion Package for `CTexploreR` containing omics
##' data to select and characterise CT genes.
##'
##' Data come from public databases and include expression and
##' methylation values of genes in normal and tumor samples as well as
##' in tumor cell lines, and expression in cells treated with a
##' demethylating agent is also available.
##'
##' The [CTdata()] function returns a `data.frame` with all the
##' annotated datasets provided in the package. For details on these
##' individual datasets, refer to their respective manual pages.
##'
##' See the vignette and the respective manuals pages for more details
##' about the package and the data themselves.
##'
##' @return A `data.frame` describing the data available in
##'     `CTdata`.
##'
##' @author Laurent Gatto
##'
##' @export
##'
##' @importFrom utils read.csv
##'
##' @examples
##'
##' CTdata()
CTdata <- function() {
   fl <- system.file("extdata", "metadata.csv", package = "CTdata")
   read.csv(fl, stringsAsFactors = FALSE)
}

#' Genes expression in GTEX
#'
#' @description
#'
#' Gene expression data in normal tissues from GTEx database.
#'
#' @format
#'
#' A `SummarizedExperiment` object with 24504 rows and 32 columns
#'
#' - Rows correspond to genes (ensembl_gene_id as rownames)
#' - Columns correspond to tissues
#' - Expression data from the assay are TPM values
#'
#' @details
#'
#' The rowData contains
#'
#' - A column named `GTEX_category`, specifying the tissue specificity
#'   category ("testis_specific", "testis-preferential",
#'   "lowly_expressed" or "other") assigned to each gene using
#'   expression values in testis and in somatic tissues, has been
#'   added to the rowData. "testis_specific" genes are expressed
#'   exclusively in testis (expression in testis >= 1 TPM, highest
#'   expression in somatic tissues < 0.5 TPM, and expressed at least
#'   10x more in testis than in any somatic
#'   tissue). "testis-preferential" genes are genes expressed in
#'   testis but also in a few somatic tissues (expression in testis >=
#'   1 TPM, and allowed in a minority of somatic tissues
#'   (q75_TPM_somatic < 0.5) and expressed at least 10x more in testis than in
#'   any somatic tissue). "lowly_expressed" genes are genes undetectable in GTEX
#'   database probably due to multi-mapping issues (expression in all
#'   GTEX tissues < 1 TPM).
#'
#' - A column named `q75_TPM_somatic` giving the quantile 75% of TPM
#'   in a somatic tissue.
#' - A column named `max_TPM_somatic` giving the maximum expression
#'   level found in a somatic tissue.
#' - A column named `ratio_testis_somatic` giving the ratio between the TPM
#'   in testis and the max TPM in a somatic tissue
#'
#' @source
#'
#' Downloaded from
#' https://storage.googleapis.com/gtex_analysis_v8/rna_seq_data/GTEx_Analysis_2017-06-05_v8_RNASeQCv1.1.9_gene_median_tpm.gct.gz.
#' Some categories of tissues were pooled (mean expression values are
#' given in pooled tissues) (see `scripts/make_GTEX_data.R` for
#' details).
#'
#' @name GTEX_data
#'
#' @docType data
NULL

#' Testis scRNAseq data
#'
#' @description
#'
#' Testis single cell RNAseq data from
#' `The adult human testis transcriptional cell atlas` (Guo et al. 2018)
#'
#' @format
#'
#' A `SingleCellExperiment` object with 20891 rows and 6490 columns
#'
#' - Rows correspond to genes (gene names as rownames)
#' - Columns correspond to testis cells
#'
#' @details
#'
#' Description of the colData:
#'
#' - Column `nGene` gives the number of distinct genes detected per cell.
#'
#' - Column `nUMI` gives the total UMI number per cell.
#'
#' - Column `clusters` gives cluster number defined in the Guo's paper.
#'
#' - Column `type` gives the testis cell type associated to the cluster number.
#'
#' - Column `Donor` gives the Donor origin of the cells.
#'
#' Description of the rowData:
#'
#' - Column `percent_pos_testis_germcells` gives the percent of testis germ cells
#'   in wich the genes are detected (count > 0) (based on testis scRNAseq data).
#'
#' - Column `percent_pos_testis_somatic` gives the percent of testis somatic cells
#'   in wich the genes are detected (count > 0) (based on testis scRNAseq data).
#'
#' - Column`testis_cell_type` specifies the testis cell-type showing the highest
#'  mean expression of each gene (based on testis scRNAseq data).
#'
#' The rowData contains the `testis_cell_type` column, specifying the testis
#' cell-type showing the highest mean expression of each gene.
#'
#' @source
#'
#' The count matrix `GSE112013_Combined_UMI_table.txt.gz` was downloaded from
#' GEO (accession: GSE112013). Metadata correspond to `TableS1` from the paper's
#' supplemental data. The data were converted in a SingleCellExperiment
#' (see `scripts/13_make_testis_sce.R` for details).
#'
#' @name testis_sce
#'
#' @docType data
NULL

#' Gene expression in human cell types
#'
#' @description
#'
#' Gene expression profiles in different human cell types based on scRNAseq data
#' obtained from the Human Protein Atlas (https://www.proteinatlas.org)
#'
#' @format
#'
#' A `SingleCellExperiment` object with 20082 rows and 66 columns
#'
#' - Rows correspond to genes (ensembl gene id as rownames)
#' - Columns correspond to cell types
#' - Expression values correspond to transcripts per million protein coding genes
#' (pTPM)
#'
#' @details
#'
#' Description of the colData:
#'
#' - Column `Cell_type` gives cell type.
#'
#' - Column `group` gives the cell type group (defined in the Human Protein Atlas).
#'
#' Description of the rowData:
#'
#' - Column `max_TPM_in_a_somatic_cell_type` gives the maximum expression value
#' found in a somatic cell type
#'
#' - Column `max_in_germcells_group` gives the maximum expression value found
#' in a germ cell type
#'
#' - Column `Higher_in_somatic_cell_type` specifies if a somatic cell type
## was found to express the gene at a higher level than any germ cell type
#'
#' @source
#'
#' Gene expression values in cell types, based on multiple scRNAseq datasets
#' obtained from the Human Protein Atlas
#' (https://www.proteinatlas.org/about/download)
#' The data were converted in a SummarizedExperiment
#' (see `scripts/14_make_scRNAseq_HPA.R` for details).
#'
#' @name scRNAseq_HPA
#'
#' @docType data
NULL

#' Genes expression data in CCLE
#'
#' @description
#'
#' Gene expression data in cancer cell lines from CCLE
#'
#' @format
#'
#' A `SummarizedExperiment` object with 24473 rows and 1229 columns
#'
#' - Rows correspond to genes (ensembl_gene_id)
#' - Columns correspond to CCLE cell lines
#' - Expression data from the assay are TPM values
#' - Cell lines metadata are stored in colData
#'
#' @details
#'
#' The rowData contains
#'
#' - A column `percent_of_positive_CCLE_cell_lines` that gives the
#'   percentage of CCLE cell lines (all cell lines combined)
#'   expressing the gene (TPM >= 1).
#'
#' - A column `percent_of_negative_CCLE_cell_lines` that gives the
#'   percent of CCLE cell lines (all cell lines combined) in which
#'   genes are repressed (TPM < 0.5)
#'
#' - A column `max_TPM_in_CCLE` that gives the maximal expression (in
#'   TPM) found in all cell lines.
#'
#' - A column `CCLE_category` gives the category ("activated",
#'   "not_activated", "leaky") assigned to each gene.  "activated"
#'   category corresponds to genes expressed (TPM >= 1) in at
#'   least 1% of cell lines, repressed (TPM <= 0.5) in at least 20% of
#'   cell lines with a maximal expression higher than 5 TPM.
#'   "not_activated" category corresponds to genes
#'   repressed (TPM <= 0.5) in at least 20% of cell lines but
#'   expressed (TPM >= 1) less than 1%.  "leaky" category
#'   corresponds to genes repressed (TPM <= 0.5) in less than 20% of
#'   cell lines. "lowly_expressed" corresponds to genes repressed (TPM <= 0.5)
#'   in at least 20%, expressed (TPM >= 1) in more than 1 % of cell lines, with
#'   a maximum expression lower than 5 TPM.
#'
#'
#' @source
#'
#' TPM values downloaded using depmap bioconductor package (see
#' `scripts/make_CCLE_data.R` for details).
#'
#' @name CCLE_data
#'
#' @docType data
NULL

#' Gene expression values in normal tissues
#'
#' @description
#'
#' Gene expression values (TPM) in a set of normal tissues obtained by
#' counting or not multi-mapped reads. Many CT genes belong to gene
#' families from which members have identical or nearly identical
#' sequences.  Some CT can only be detected in RNAseq data in which
#' multimapping reads are not discarded.
#'
#' @format
#'
#' A `SummarizedExperiment` object with 24504 rows and 18 columns
#'
#' - Rows correspond to genes (ensembl_gene_id)
#'
#' - Columns correspond to normal tissues.
#'
#' - First assay, `TPM_no_multimapping`, gives TPM expression values
#'   obtained when discarding multimapped reads.
#'
#' - Second assay, `TPM_with_multimapping`, gives TPM expression
#'   values obtained by counting multimapped reads.
#'
#' @details
#'
#' A column named `multimapping_analysis` has been added to the
#' rowData. It summarizes the testis specificity analysis of genes
#' flagged as "lowly_expressed" in GTEX_data. Genes are considered
#' "testis_specific" when, with multimapping allowed, they are
#' detectable in testis (TPM >= 1), their TPM value has increased
#' compared to without multimapping (ratio > 5), and their TPM value
#' is at least 10 times higher in testis than in any other somatic
#' tissue (where the maximum expression always has to be below 1 TPM).
#' Genes are considered "testis_preferential" when, with multimapping allowed,
#' they are detectable in testis (TPM >= 1), their TPM value has increased
#' compared to without multimapping (ratio > 5), and their TPM value
#' is at least 10 times higher in testis than in any other somatic
#' tissue (where the maximum expression is above 1 TPM).
#'
#' @source
#'
#' RNAseq fastq files were downloaded from Encode database (see
#' `scripts/make_normal_tissues_multimapping.R` for details).
#'
#' @name normal_tissues_multimapping_data
#'
#' @docType data
NULL


#' DE genes with/without demethylating agent
#'
#' @description
#'
#' Gene expression values in a set of cell lines treated or not with
#' 5-Aza-2'-Deoxycytidine (DAC), a demethylating agent.
#'
#' @format
#'
#' A `SummarizedExperiment` object with 24516 rows and 32 columns
#'
#' - Rows correspond to genes (ensembl_gene_id).
#'
#' - Columns correspond to samples.
#'
#' - Expression data correspond to counts that have been normalised
#'   (by DESeq2 method) and log-transformed (log1p).
#'
#' - The colData contains the SRA references of the fastq files that
#'   were downloaded, and informations about the cell lines and the
#'   DAC treatment.
#'
#' - The rowData contains the results of a differential expression
#'   evaluating the DAC treatment effect. For each each cell line, the
#'   log2FC between treated and control cells is given, as well as the
#'   p-adjusted value. The column `induced` flags genes significantly
#'   induced (log2FoldChange >= 2 and padj <= 0.1) in at least one
#'   cell line. The threshold is not too stringent as DAC is expected to induce
#'   low expression levels (demethylation doesn't necessarily occurs in
#'   all treated cells...).
#'   When all cells lines already express the gene before DAC treatment, no
#'   assessment of induction was done.
#'
#' @details
#'
#' Differential expression analysis was done using DESeq2_1.36.0,
#' using as `design = ~ treatment` (see
#' `scripts/make_DAC_treated_cells.R` for details).
#'
#' @source RNAseq
#'
#' fastq files were downloaded from Encode database.  SRA reference of
#' samples are stored in the colData.
#'
#' @name DAC_treated_cells
#'
#' @docType data
NULL

#' DE genes treated or not with a demethylating agent
#'
#' @description
#'
#' Gene expression values in a set of cell lines treated or not with
#' 5-Aza-2'-Deoxycytidine (DAC), a demethylating agent.  Many CT genes
#' belong to gene families from which members have identical or nearly
#' identical sequences. Some CT can only be detected in RNAseq data in
#' which multimapping reads are not discarded.
#'
#' @format
#'
#' A `SummarizedExperiment` object with 24516 rows and 32 columns
#'
#' - Rows correspond to genes (ensembl_gene_id).
#'
#' - Columns correspond to samples.
#'
#' - Expression data correspond to counts that have been normalised
#'   (by DESeq2 method) and log-transformed (log1p).
#'
#' - The colData contains the SRA references of the fastq files that
#'   were downloaded, and informations about the cell lines and the
#'   DAC treatment.
#'
#' - The rowData contains the results of a differential expression
#'   evaluating the DAC treatment effect. For each each cell line, the
#'   log2FC between treated and control cells is given, as well as the
#'   p-adjusted value. The column `induced` flags genes significantly
#'   induced (log2FoldChange >= 2 and padj <= 0.1) in at least one
#'   cell line. The threshold is not too stringent as DAC is expected to induce
#'   low expression levels (demethylation doesn't necessarily occurs in
#'   all treated cells...).
#'   When all cells lines already express the gene before DAC treatment, no
#'   assessment of induction was done.
#'
#' @details
#'
#' Differential expression analysis was done using DESeq2_1.36.0,
#' using as `design = ~ treatment` (see
#' `scripts/make_DAC_treated_cells_multimapping.R` for details).
#'
#' @source
#'
#' RNAseq fastq files were downloaded from Encode database.  SRA
#' reference of samples are stored in the colData.
#'
#' @name DAC_treated_cells_multimapping
#'
#' @docType data
NULL

#' Methylation of CpGs within all genes promoters
#'
#' @description
#'
#' Methylation values of CpGs located within all genes
#' promoters in a set of normal tissues.
#'
#' @format
#'
#' A `RangedSummarizedExperiment` object with 4280327 rows and 14 columns
#'
#' - Rows correspond to CpGs (located within all genes promoters (TSS +- 5000
#' nt))
#'
#' - Columns correspond to normal tissues
#'
#' - Methylation values from WGBS data
#'
#' - rowRanges correspond to CpG positions
#'
#' @source
#'
#' WGBS methylation data was downloaded from Encode and from GEO
#' databases (see `scripts/make_methylation_in_tissues.R` for
#' details).
#'
#' @name methylation_in_tissues
#'
#' @docType data
NULL


#' All genes' promoters mean methylation
#'
#' @description
#'
#' Mean methylation values of all CpGs located within all genes
#' promoters in a set of normal tissues
#'
#' @format
#'
#' A `SummarizedExperiment` object with 24502 rows and 14 columns
#'
#' - Rows correspond to all genes (gene names as rownames)
#'
#' - Mean methylation levels in normal tissues are stored in columns
#'
#' - CpG densities and results of methylation analysis are stored in
#'   rowData
#'
#' @details
#'
#' The rowData contains:
#'
#' - A column named `CpG_density`, gives the density of CpG within
#'   each promoter (number of CpG / promoter length * 100).
#'
#' - A column `CpG_promoter` that classifies the promoters according
#'   to their CpG densities: "low" (CpG_density < 2), "intermediate"
#'   (CpG_density >= 2 & CpG_density < 4), and "high" (CpG_density >=
#'   4).
#'
#' - A column `somatic_met_level` that gives the mean methylation
#'   level of each promoter in somatic tissues.
#'
#' - A column `sperm_met_level` that gives the methylation level of
#'   each promoter in sperm.
#'
#' - A column `somatic_methylation` indicates if the promoter's mean
#'   methylation level in somatic tissues is higher than 50%.
#'
#' - A column `germline_methylation`indicates if the promoter is
#'   methylated in germline, based on the ratio with somatic tissues
#'   (FALSE if somatic_met_level is at least twice higher than
#'   germline_met_level).
#'
#' @source
#'
#' WGBS methylation data was downloaded from Encode and from GEO
#' databases. Mean methylation levels are evaluated using methylation
#' values of CpGs located in promoter region (defined as 1000 nt
#' upstream TSS and 200 nt downstream TSS) (see
#' `scripts/make_mean_methylation_in_tissues.R` for details).
#'
#' @name mean_methylation_in_tissues
#'
#' @docType data
NULL

#' Gene expression in TCGA samples
#'
#' @description
#'
#' Gene expression data in TCGA samples (tumor and peritumoral
#' samples).
#'
#' @format
#'
#' A `SummarizedExperiment` object with 24497 rows and 4141 columns
#'
#' - Rows correspond to genes (ensembl_gene_id)
#'
#' - Columns correspond to samples
#'
#' - Expression data from the assay are TPM values
#'
#' - Clinical information are stored in colData
#'
#' - Genes information are stored in rowData
#'
#' @details
#'
#' - The colData contains clinical data from TCGA as well as global
#'   hypomethylation levels obtained from paper *DNA methylation loss
#'   promotes immune evasion of tumours with high mutation and copy
#'   number load* from Jang et al., Nature Commun 2019 that were added
#'   (see `inst/scripts/make_TCGA_TPM.R` for details).
#'
#' - The rowData contains genes information and, for each gene, the
#'   percentage of tumors that are positive (TPM >= 1), and the
#'   percentage of tumors that are negative (TPM < 0.5). In column
#'   `TCGA_category`, genes are labelled as "activated" when the
#'   percentage of positive tumors is > 1, with a maximal expression higher than
#'   5 TPM, and when at least 20% of tumors are negative. Genes are labelled as
#'   "not_activated" when the percentage of positive tumors is lower than 1.
#'   Genes are labelled as "leaky" when less than 20% of tumors are negative.
#'   Genes are labelled as "lowly_expressed" when repressed (TPM <= 0.5)
#'   in at least 20%, expressed (TPM >= 1) in more than 1 % of cell lines, with
#'   a maximum expression lower than 5 TPM.
#'
#' @source
#'
#' SKCM, LUAD, LUSC, COAD, ESCA, BRCA and HNSC expression data were
#' downloaded with TCGAbiolinks (see `scripts/make_TCGA_TPM.R`
#' for details).
#'
#' @name TCGA_TPM
#'
#' @docType data
NULL

#' Methylation of all genes promoters in TCGA samples
#'
#' @description
#'
#' Methylation values of probes located within all genes
#' promoters in samples from TCGA (tumor and peritumoral samples)
#'
#' @format
#'
#' A `RangedSummarizedExperiment` object with 79445 rows and 3423
#' columns
#'
#' - Rows correspond to Infinium 450k probes
#'
#' - Columns correspond to samples
#'
#' - Methylation data from the assay are Beta values
#'
#' - Clinical information are stored in colData
#'
#' - Probe information (hg38 coordinates) are stored in rowRanges
#'
#' @source
#'
#' SKCM, LUAD, LUSC, COAD, ESCA, BRCA and HNSC methylation data were
#' downloaded with TCGAbiolinks and subsetted to select probes located
#' in CT genes promoter regions (see
#' `scripts/make_TCGA_methylation.R` for details).
#'
#' @name TCGA_methylation
#'
#' @docType data
NULL

#' CT genes description table
#'
#' @description
#'
#' Cancer-Testis (CT) genes description
#'
#' @format
#'
#' A `tibble` object with 280 rows and 47 columns.
#'
#' - Rows correspond to CT genes
#'
#' - Columns give CT genes characteristics
#'
#' @details
#'
#' When the promoter is mentionned, it has been determined as 1000 nt
#' upstream TSS and 200 nt downstream TSS.
#'
#' CT_genes characteristics column:
#'
#' - Column `CT_gene_type` indicates if the gene is a CT specific gene
#'  ("CT_gene" : testis_specific in `testis_specificity`) and activated in
#'  "TCGA_category" and "CCLE_category) or CT preferential gene ("CTP_gene" :
#'  testis_preferential in `testis_specificity`) and activated in"TCGA_category"
#'   and "CCLE_category").
#'
#' - Column `testis_specificity` gives the testis-specificity of genes
#'   assigned to each gene using `GTEX_category` and `multimapping_analysis`
#'   ("testis_specific" or "testis_preferential"). Genes were assigned
#'   "testis-preferential" if testis-specific in these categories but not testis
#'   specific in `HPA_category` or leaky in `CCLE_category` or `TCGA_category`.
#'
#' - Column `regulated_by_methylation` indicates if the gene is
#'   regulated by methylation (`TRUE`) based on DAC induction (has to
#'   be TRUE) and on promoter methylation level in normal somatic tissues
#'   (when available, has to be methylated in somatic tissues).
#'
#' - Column `X_linked` indicates if the gene is on the chromosome X
#'   (TRUE) or not (FALSE).
#'
#' - Columns `chr`, `strand` and `transcription_start_site` give the
#'   genomic location.
#'
#' - Column `GTEX_category` gives the category ("testis_specific",
#'   "testis_preferential" or "lowly_expressed") assigned to each gene
#'   using GTEx database (see `?GTEX_data` for details).
#'
#'  - Column `q75_TPM_somatic` gives the q75 expression level found
#'   in a somatic tissue (using GTEx database).
#'
#' - Column `max_TPM_somatic` gives the maximum expression level found
#'   in a somatic tissue (using GTEx database).
#'
#' - Column `ratio_testis_somatic` gives the ratio between expression in testis
#'   and the highest expression found in a somatic tissue (using GTEx database).
#'
#' - Column `TPM_testis` gives the gene expression level in testis
#'   (using GTEx database).
#'
#' - Column `lowly_expressed_in_GTEX` indicates if the gene is lowly
#'   expressed in GTEX database and thus needed to be analysed with
#'   multimapping allowed.
#'
#' - Column `multimapping_analysis` informs if the gene (flagged as
#'   "lowly_expressed" in GTEX_data) was found to be testis-specific
#'   when multi-mapped reads were counted for gene expression in
#'   normal tissues ("not_analysed" or "testis_specific") (see
#'   `?normal_tissues_multimapping_data` for details).
#'
#' - Column `HPA_RNA_single_cell_type_specific_nTPM` specifies the cell types in
#'   which genes were detected in the HPA single cell data (see
#'   `?HPA_cell_type_specificity` for details).
#'
#' - Column `max_HPA_germcell` specifies if the maximum expression value in a
#' germ cell type. (see  `?HPA_cell_type_specificity` for details).
#'
#' - Column `max_HPA_somatic` specifies if the maximum expression value in a
#' somatic cell type. (see  `?HPA_cell_type_specificity` for details).
#'
##' - Column `not_detected_in_somatic_HPA` specifies if the gene is detected or
#' not in a somatic cell type. (see  `?HPA_cell_type_specificity` for details).
#'
#' - Column `HPA_ratio_germ_som` gives the ratio between `max_HPA_germcell` and
#' `max_HPA_somatic` columns.

#'
#' - Column `percent_of_positive_CCLE_cell_lines` gives the percentage
#'   of CCLE cancer cell lines in which genes are expressed (genes
#'   were considered as expressed if TPM >= 1).
#'
#' - Column `percent_of_negative_CCLE_cell_lines` gives the percentage
#'   of CCLE cancer cell lines in which genes are repressed (TPM <=
#'   0.5).
#'
#' - Column `max_TPM_in_CCLE` gives the highest expression level of
#'   genes in CCLE cell lines.
#'
#' - Column `CCLE_category` gives the category assigned to each gene
#'   using CCLE data. "Activated" category corresponds to genes
#'   expressed in at least 1% of cell lines (TPM >= 1) and repressed in
#'   at least 20% of cell lines.
#'
#' - Column `percent_pos_tum` gives the percentage of TCGA cancer
#'   samples in which genes are expressed (genes were considered as
#'   expressed if TPM >= 1).
#'
#' - Column `percent_neg_tum` gives the percentage of TCGA cancer samples in
#'   which genes are repressed (TPM <= 0.5).
#'
#' - Column `max_TPM_in_TCGA` gives the highest expression level of
#'   genes in TCGA cancer sample.
#'
#' - Column `max_q75_in_NT` gives the maximum q75 expression in normal
#'   peritumoral tissues from TCGA.
#'
#' - Column `TCGA_category` gives the category assigned to each gene
#'   using TCGA data. "activated" category corresponds to genes
#'   expressed in at least 1% of tumors (TPM >= 1) and repressed in at
#'   least 20% of samples.  "multimapping_issue" corresponds to genes
#'   that need multi-mapping to be allowed in order to be analysed
#'   properly.
#'
#' - Columns `external_transcript_name`, `ensembl_transcript_id`, and
#'   `transcript_biotype` give the references and informations about
#'   the most biologically relevant transcript associated to each
#'   gene.
#'
#' - Column `IGV_backbone` indicates if a gene has been removed from CT genes
#'   as RNA-Seq reads were not properly aligned on exons, but were instead
#'   spread across a wide genomic region spanning the genes.
#'
#' - Column `family` gives the gene family name.
#'
#' - Column `DAC_induced` summarises the results (`TRUE` or `FALSE`)
#'   of a differential expression evaluating gene induction upon DAC
#'   treatment in a series of cell lines.
#'
#' - Column named `CpG_density`, gives the density of CpG within each
#'   promoter (number of CpG / promoter length * 100).
#'
#' - Column `CpG_promoter` classifies the promoters according to their
#'   CpG densities: "low" (CpG_density < 2), "intermediate"
#'   (CpG_density >= 2 & CpG_density < 4), and "high" (CpG_density >=
#'   4).
#'
#' - Column `somatic_met_level` that gives the mean methylation level
#'   of each promoter in somatic tissues.
#'
#' - Column `sperm_met_level` that gives the methylation level of each
#'   promoter in sperm.
#'
#' - Column `somatic_methylation` indicates if the promoter's mean
#'   methylation level in somatic tissues is higher than 50%.
#'
#' - Column `germline_methylation`indicates if the promoter is
#'   methylated in germline, based on the ratio with somatic tissues
#'   (`FALSE` if somatic_met_level is at least twice higher than
#'   `germline_met_level`).
#'
#' - Columns `oncogene` and `tumor_suppressor` informs if oncogenic
#'   and tumor-suppressor functions have been associated to genes
#'   (source: [Cancermine](http://bionlp.bcgsc.ca/cancermine/)).
#'
#' @source
#'
#' See `scripts/make_all_genes_prelim.R` and
#' `scripts/make_all_genes_and_CT_genes.R`for details on how this list of
#' curated CT genes was created.
#'
#' @name CT_genes
#'
#' @docType data
NULL

#' All genes genes description table
#'
#' @description
#'
#' All genes description, according to the analysis done for CT genes
#'
#' @format
#'
#' A `tibble` object with 24488 rows and 47 columns.
#'
#' - Rows correspond to genes
#'
#' - Columns give genes characteristics
#'
#' @details
#'
#' When the promoter is mentionned, it has been determined as 1000 nt
#' upstream TSS and 200 nt downstream TSS.
#'
#' CT_genes characteristics column:
#'
#' - Column `CT_gene_type` indicates if the gene is a CT specific gene
#'  ("CT_gene" : testis_specific in `testis_specificity`) and activated in
#'  "TCGA_category" and "CCLE_category) or CT preferential gene ("CTP_gene" :
#'  testis_preferential in `testis_specificity`) and activated in"TCGA_category"
#'   and "CCLE_category").
#'
#' - Column `testis_specificity` gives the testis-specificity of genes
#'   assigned to each gene using `GTEX_category` and `multimapping_analysis`
#'   ("testis_specific" or "testis_preferential"). Genes were assigned
#'   "testis-preferential" if testis-specific in these categories but not testis
#'   specific in `HPA_category` or leaky in `CCLE_category` or `TCGA_category`.
#'
#' - Column `regulated_by_methylation` indicates if the gene is
#'   regulated by methylation (`TRUE`) based on DAC induction (has to
#'   be TRUE) and on promoter methylation level in normal somatic tissues
#'   (when available, has to be methylated in somatic tissues).
#'
#' - Column `X_linked` indicates if the gene is on the chromosome X
#'   (TRUE) or not (FALSE).
#'
#' - Columns `chr`, `strand` and `transcription_start_site` give the
#'   genomic location.
#'
#' - Column `GTEX_category` gives the category ("testis_specific",
#'   "testis_preferential" or "lowly_expressed") assigned to each gene
#'   using GTEx database (see `?GTEX_data` for details).
#'
#'  - Column `q75_TPM_somatic` gives the q75 expression level found
#'   in a somatic tissue (using GTEx database).
#'
#' - Column `max_TPM_somatic` gives the maximum expression level found
#'   in a somatic tissue (using GTEx database).
#'
#' - Column `ratio_testis_somatic` gives the ratio between expression in testis
#'   and the highest expression found in a somatic tissue (using GTEx database).
#'
#' - Column `TPM_testis` gives the gene expression level in testis
#'   (using GTEx database).
#'
#' - Column `lowly_expressed_in_GTEX` indicates if the gene is lowly
#'   expressed in GTEX database and thus needed to be analysed with
#'   multimapping allowed.
#'
#' - Column `multimapping_analysis` informs if the gene (flagged as
#'   "lowly_expressed" in GTEX_data) was found to be testis-specific
#'   when multi-mapped reads were counted for gene expression in
#'   normal tissues ("not_analysed" or "testis_specific") (see
#'   `?normal_tissues_multimapping_data` for details).
#'
#' - Column `HPA_RNA_single_cell_type_specific_nTPM` specifies the cell types in
#'   which genes were detected in the HPA single cell data (see
#'   `?HPA_cell_type_specificity` for details).
#'
#' - Column `max_HPA_germcell` specifies if the maximum expression value in a
#' germ cell type. (see  `?HPA_cell_type_specificity` for details).
#'
#' - Column `max_HPA_somatic` specifies if the maximum expression value in a
#' somatic cell type. (see  `?HPA_cell_type_specificity` for details).
#'
##' - Column `not_detected_in_somatic_HPA` specifies if the gene is detected or
#' not in a somatic cell type. (see  `?HPA_cell_type_specificity` for details).
#'
#' - Column `HPA_ratio_germ_som` gives the ratio between `max_HPA_germcell` and
#' `max_HPA_somatic` columns.

#'
#' - Column `percent_of_positive_CCLE_cell_lines` gives the percentage
#'   of CCLE cancer cell lines in which genes are expressed (genes
#'   were considered as expressed if TPM >= 1).
#'
#' - Column `percent_of_negative_CCLE_cell_lines` gives the percentage
#'   of CCLE cancer cell lines in which genes are repressed (TPM <=
#'   0.5).
#'
#' - Column `max_TPM_in_CCLE` gives the highest expression level of
#'   genes in CCLE cell lines.
#'
#' - Column `CCLE_category` gives the category assigned to each gene
#'   using CCLE data. "Activated" category corresponds to genes
#'   expressed in at least 1% of cell lines (TPM >= 1) and repressed in
#'   at least 20% of cell lines.
#'
#' - Column `percent_pos_tum` gives the percentage of TCGA cancer
#'   samples in which genes are expressed (genes were considered as
#'   expressed if TPM >= 1).
#'
#' - Column `percent_neg_tum` gives the percentage of TCGA cancer samples in
#'   which genes are repressed (TPM <= 0.5).
#'
#' - Column `max_TPM_in_TCGA` gives the highest expression level of
#'   genes in TCGA cancer sample.
#'
#' - Column `max_q75_in_NT` gives the maximum q75 expression in normal
#'   peritumoral tissues from TCGA.
#'
#' - Column `TCGA_category` gives the category assigned to each gene
#'   using TCGA data. "activated" category corresponds to genes
#'   expressed in at least 1% of tumors (TPM >= 1) and repressed in at
#'   least 20% of samples.  "multimapping_issue" corresponds to genes
#'   that need multi-mapping to be allowed in order to be analysed
#'   properly.
#'
#' - Columns `external_transcript_name`, `ensembl_transcript_id`, and
#'   `transcript_biotype` give the references and informations about
#'   the most biologically relevant transcript associated to each
#'   gene.
#'
#' - Column `IGV_backbone` indicates if a gene has been removed from CT genes
#'   as RNA-Seq reads were not properly aligned on exons, but were instead
#'   spread across a wide genomic region spanning the genes.
#'
#' - Column `family` gives the gene family name.
#'
#' - Column `DAC_induced` summarises the results (`TRUE` or `FALSE`)
#'   of a differential expression evaluating gene induction upon DAC
#'   treatment in a series of cell lines.
#'
#' - Column named `CpG_density`, gives the density of CpG within each
#'   promoter (number of CpG / promoter length * 100).
#'
#' - Column `CpG_promoter` classifies the promoters according to their
#'   CpG densities: "low" (CpG_density < 2), "intermediate"
#'   (CpG_density >= 2 & CpG_density < 4), and "high" (CpG_density >=
#'   4).
#'
#' - Column `somatic_met_level` that gives the mean methylation level
#'   of each promoter in somatic tissues.
#'
#' - Column `sperm_met_level` that gives the methylation level of each
#'   promoter in sperm.
#'
#' - Column `somatic_methylation` indicates if the promoter's mean
#'   methylation level in somatic tissues is higher than 50%.
#'
#' - Column `germline_methylation`indicates if the promoter is
#'   methylated in germline, based on the ratio with somatic tissues
#'   (`FALSE` if somatic_met_level is at least twice higher than
#'   `germline_met_level`).
#'
#' - Columns `oncogene` and `tumor_suppressor` informs if oncogenic
#'   and tumor-suppressor functions have been associated to genes
#'   (source: [Cancermine](http://bionlp.bcgsc.ca/cancermine/)).
#' @source
#'
#' See `scripts/make_all_genes_prelim.R` and
#' `scripts/make_all_genes_and_CT_genes.R` for details on how this list of genes
#'  was created.
#'
#' @name all_genes
#'
#' @docType data
NULL

#' Gene correlations in CCLE cancer cell lines
#'
#' @description
#'
#' Correlation coefficients between Cancer-Testis genes and all genes
#' found on the CCLE database.
#'
#' @format
#'
#' A `matrix` object with 238 rows and 24483 columns.
#'
#' - Rows correspond to CT genes
#'
#' - Columns correspond to all genes from CCLE database
#'
#' @details
#'
#' Correlation coefficients (Pearson) between CT genes and all other
#' genes are given in the matrix. These correlation coefficients were
#' calculated using log transformed expression values from `CCLE_data`
#' (all cell lines).
#'
#' @source
#'
#' See `scripts/make_CCLE_correlation_matrix.R` for details.
#'
#' @name CCLE_correlation_matrix
#'
#' @docType data
NULL

#' Fetal gonad scRNAseq
#'
#' @description
#'
#' Human fetal gonad single cell RNAseq data from
#' `Single-cell roadmap of human gonadal development`
#' (Garcia-Alonso, Nature 2022)
#'
#' @format
#'
#' A `SingleCellExperiment` object with 22489 rows and 10850 columns
#'
#' - Rows correspond to genes (gene names as rownames)
#' - Columns correspond to cells
#'
#' @details
#'
#' Description of the colData:
#'
#' - Column `type` gives the gender and the cell type.
#'
#' - Column `stage` specifies if the cell type is "pre-meiotic" or "meiotic".
#'
#' - Column `germcell` is set to TRUE when the cell type is a germ cell.
#'
#' @source
#'
#' ee58527e-e1e4-465d-8dc8-800ee40f14f2.rds file dowloaded from
#' https://cellxgene.cziscience.com/collections/661a402a-2a5a-4c71-9b05-b346c57bc451Data.
#' The data were converted in a SingleCellExperiment
#' (see `scripts/make_FGC_sce.R` for details).
#'
#' @name FGC_sce
#'
#' @docType data
NULL

#' Oocytes scRNAseq
#'
#' @description
#'
#' Human oocytes single cell RNAseq data from
#' `Decoding dynamic epigenetic landscapes in human oocytes using single-cell
#' multi-omics sequencing` (Yan et al. Cell Stem Cell 2021)
#'
#' @format
#'
#' A `SingleCellExperiment` object with 26500 rows and 899 columns
#'
#' - Rows correspond to genes(gene names as rownames)
#'
#' - Columns correspond to cells
#'
#' @details
#'
#' Description of the colData:
#'
#' - Column `type` gives the cell type.
#'
#' - Column `stage` specifies if the cell type is "pre-meiotic" or "meiotic".
#'
#' - Column `germcell` is set to TRUE when the cell type is a germ cell.
#'
#' @source
#'
#' GSE154762_hO_scChaRM_count_matix.txt.gz` was downloaded from GEO
#' (accession: GSE154762). The data were converted in a SingleCellExperiment
#' (see `scripts/make_oocytes_sce.R` for details).
#'
#' @name oocytes_sce
#'
#' @docType data
NULL

#' Cell type specificities (from HPA)
#'
#' @description
#'
#' Cell type specificities based on scRNAseq data from the
#' Human Protein Atlas (https://www.proteinatlas.org)
#'
#' @format
#'
#' A `tibble` object with 24504 rows and 7 columns.
#'
#' - Rows correspond to genes (ensembl_gene_id)
#'
#' - Columns give genes cell type specificities
#'
#' @details
#'
#'
#' - Column `HPA_scRNAseq_celltype_specific_nTPM` gives the cell types in
#' which genes were detected (corresponds to column
#' `RNA single cell type specific nTPM` of proteinatlas.tsv file.
#'
#' - Column `max_HPA_germcell` specifies if the maximum expression value in a
#' germ cell type
#'
#' - Column `max_HPA_somatic` specifies if the maximum expression value in a
#' somatic cell type
#'
#' - Column `not_detected_in_somatic_HPA` specifies if the gene is detected or
#' not in a somatic cell type. Genes are flagged as
#' `TRUE` if the `max_HPA_somatic` value is equal to 0, and `FALSE` if
#' `max_HPA_somatic` value is > 0. `NA` is set when the original table from HPA
#' had no values for that gene.
#'
#' - Column `HPA_ratio_germ_som` gives the ratio between `max_HPA_germcell` and
#' `max_HPA_somatic` columns.

#' @source
#' `proteinatlas.tsv` was downloaded from the Human Protein Atlas
#' (https://www.proteinatlas.org)
#' See `scripts/make_HPA_cell_type_specificities.R` for details.
#'
#' @name HPA_cell_type_specificities
#'
#' @docType data
NULL

#' Embryo scRNAseq
#'
#' @description
#'
#' Human embryo single cell RNAseq data in FPKM from
#' `Single Cell DNA Methylome Sequencing of Human Preimplantation
#' Embryos` (Zhu et al. 2018)
#'
#' @format
#'
#' A `SingleCellExperiment` object with 26255 rows and 50 columns
#'
#' - Rows correspond to genes (gene names as rownames)
#'
#' - Columns correspond to cells
#'
#' @details
#'
#' Description of the colData:
#'
#' - Column `embryo` gives the embryo the cell is coming from.
#'
#' - Column `stage` specifies the stage of the early embryo.
#'
#' - Column `sex` is the sex inference made using the expression of RPS4Y1. If
#' mean expression of RPS4Y1 is higher than 50 FPKM, the sample is male.
#'
#' @source
#'
#' 50 FPKM files were downloaded from GEO
#' (accession: GSE81233). The data were converted in a SingleCellExperiment
#' (see `scripts/make_embryo_sce_Zhu.R` for details).
#'
#' @name embryo_sce_Zhu
#'
#' @docType data
NULL

#' Embryo scRNAseq
#'
#' @description
#'
#' Human embryo single cell RNAseq data in RPKM from
#' `Single-Cell RNA-Seq Reveals Lineage and X Chromosome Dynamics in
#' Human Preimplantation Embryos` (Petropulous et al, 2014)
#'
#' @format
#'
#' A `SingleCellExperiment` object with 26178 rows and 1481 columns
#'
#' - Rows correspond to genes (gene names as rownames)
#'
#' - Columns correspond to cells
#'
#' @details
#'
#' Description of the colData:
#'
#' - Column `individual` gives the sample the cell is coming from.
#'
#' - Column `stage` specifies the stage of the early embryo.
#'
#' - Column `sex` is the sex inference made using the expression of 11
#' Y-linked genes, made for each day individually.
#'
#' - Column `ambigous` indicates if the inference of the embryo's sex was
#' ambigous due to some cells expression of the Y-linked genes.
#'
#' @source
#'
#' RPKM and metadata files were downloaded from
#' https://www.ebi.ac.uk/biostudies/files/E-MTAB-3929/
#' The data were converted in a SingleCellExperiment
#' (see `scripts/make_embryo_sce_Petropoulos.R` for details).
#'
#' @name embryo_sce_Petropoulos
#'
#' @docType data
NULL

#' Genes expression in hESC
#'
#' @description
#'
#' Gene expression data in human embryonic stem cells
#'
#' @format
#'
#' A `SummarizedExperiment` object with 24488 rows and 4 columns
#'
#' - Rows correspond to genes (ensembl_gene_id as rownames)
#' - Columns correspond to hESC types
#' - Expression data from the assay are TPM values
#'
#' @details
#'
#' The colData contains
#'
#' - Column `genotype` gives the sexual genotype of the cells
#'
#' @source
#'
#' RNAseq fastq files were downloaded from Encode databas (see
#' `scripts/make_hESC_data.R` for details).
#'
#' @name hESC_data
#'
#' @docType data
NULL

#' Methylation of CpGs within all genes promoters in hESC
#'
#' @description
#'
#' Methylation values of CpGs located within all genes
#' promoters in human embryonic stem cells.
#'
#' @format
#'
#' A `RangedSummarizedExperiment` object with 4280098 rows and 3 columns
#'
#' - Rows correspond to CpGs (located within all genes promoters (TSS +- 5000
#' nt))
#'
#' - Columns correspond to hESC
#'
#' - Methylation values from WGBS data
#'
#' - rowRanges correspond to CpG positions
#'
#' @source
#'
#' WGBS methylation data was downloaded from Encode
#' (see `scripts/make_methylation_in_hESC.R` for details).
#'
#' @name methylation_in_hESC
#'
#' @docType data
NULL

#' All genes' promoters mean methylation in hESC
#'
#' @description
#'
#' Mean methylation values of all CpGs located within all genes
#' promoters in human embryonic stem cells
#'
#' @format
#'
#' A `SummarizedExperiment` object with 24488 rows and 3 columns
#'
#' - Rows correspond to all genes (gene names as rownames)
#'
#' - Mean methylation levels in hESC types are stored in columns
#'
#' @details
#'
#' The rowData contains:
#'
#' - A column named `ensembl_gene_id` containing gene ids.
#'
#' The colData contains
#'
#' - Column `genotype` gives the sexual genotype of the cells
#'
#' @source
#'
#' WGBS methylation data was downloaded from Encode. Mean methylation levels are
#' evaluated using methylation values of CpGs located in promoter region
#' (defined as 1000 nt upstream TSS and 200 nt downstream TSS) (see
#' `scripts/make_mean_methylation_in_hESC.R` for details).
#'
#' @name mean_methylation_in_hESC
#'
#' @docType data
NULL

#' Methylation of CpGs within all genes promoters in FGC
#'
#' @description
#'
#' Methylation values of CpGs located within all genes
#' promoters in fetal germ cells. Data is based on hg19 reference genome ! From
#' `Dissecting the epigenomic dynamics of human fetal germ cell development at
#' single-cell resolution (Li et al. 2021)`
#'
#' @format
#'
#' A `RangedSummarizedExperiment` object with 1915545 rows and 337 columns
#'
#' - Rows correspond to CpGs (located within all genes promoters (TSS +- 1000
#' nt))
#'
#' - Columns correspond to cells
#'
#' - Methylation values from scWGBS data
#'
#' - rowRanges correspond to CpG positions
#'
#' @details
#'
#' Description of the colData:
#'
#' - Column `type` indicates if the cell type is somatic or FGC
#'
#' - Column `time_week` specifies the time of the embryo when cells were removed.
#'
#' - Column `sex` indicates the sex of the cells.
#'
#' - Other information about the sequencing of each sample are clearly labelled
#'
#' @source
#'
#' scWGBS methylation data was downloaded from GEO database
#' (see `scripts/make_methylation_in_FGC.R` for details).
#'
#' @name methylation_in_FGC
#'
#' @docType data
NULL

#' All genes' promoters mean methylation in FGC
#'
#' @description
#'
#' Mean methylation values of all CpGs located within all genes
#' promoters in fetal germ cells. Data is based on hg19 reference genome ! From
#' `Dissecting the epigenomic dynamics of human fetal germ cell development at
#' single-cell resolution (Li et al. 2021)`
#'
#' @format
#'
#' A `RangedSummarizedExperiment` object with 24441 rows and 337 columns
#'
#' - Rows correspond to all genes (gene names as rownames)
#'
#' - Mean methylation levels in FGC types are stored in columns
#'
#' - rowRanges correspond to the hg19 promoter positions
#'
#' @details
#'
#' The rowData contains:
#'
#' - A column named `ensembl_gene_id` containing gene ids.
#'
#' @source
#'
#' WGBS methylation data was downloaded from GEO. Mean methylation levels are
#' evaluated using methylation values of CpGs located in promoter region
#' (defined as 1000 nt upstream TSS and 500 nt downstream TSS) (see
#' `scripts/make_mean_methylation_in_FGC.R` for details).
#'
#' @name mean_methylation_in_FGC
#'
#' @docType data
NULL

#' Methylation of CpGs within all genes promoters in embryo
#'
#' @description
#'
#' Methylation values of CpGs located within all genes
#' promoters in embryo. Data is based on hg19 reference genome ! From
#' `Single Cell DNA Methylome Sequencing of Human Preimplantation
#' Embryos` (Zhu et al. 2018)
#'
#' @format
#'
#' A `RangedSummarizedExperiment` object with 1915545 rows and 492 columns
#'
#' - Rows correspond to CpGs (located within all genes promoters (TSS +- 1000
#' nt))
#'
#' - Columns correspond to cells
#'
#' - Methylation values from scWGBS data
#'
#' - rowRanges correspond to CpG positions
#'
#' @details
#'
#' Description of the colData:
#'
#' - Column `cell_type` indicates the embryo type.
#'
#' - Column `bulk_or_single_cell` specifies if the sample was indeed only a
#' single cell or a bulk of several cells.
#'
#' - Other information about the sequencing of each sample are clearly labelled
#'
#' @source
#'
#' scWGBS methylation data was downloaded from GEO database
#' (see `scripts/make_methylation_in_embryo.R` for details).
#'
#' @name methylation_in_embryo
#'
#' @docType data
NULL

#' All genes' promoters mean methylation in embryos
#'
#' @description
#'
#' Mean methylation values of all CpGs located within all genes
#' promoters in early embryos. Data is based on hg19 reference genome ! From
#' `Single Cell DNA Methylome Sequencing of Human Preimplantation
#' Embryos` (Zhu et al. 2018)
#'
#' @format
#'
#' A `RangedSummarizedExperiment` object with 24441 rows and 492 columns
#'
#' - Rows correspond to all genes (gene names as rownames)
#'
#' - Mean methylation levels in embryos types are stored in columns
#'
#' - rowRanges correspond to the hg19 promoter positions
#'
#' @details
#'
#' The rowData contains:
#'
#' - A column named `ensembl_gene_id` containing gene ids.
#'
#' @source
#'
#' WGBS methylation data was downloaded from GEO. Mean methylation levels are
#' evaluated using methylation values of CpGs located in promoter region
#' (defined as 1000 nt upstream TSS and 500 nt downstream TSS) (see
#' `scripts/make_mean_methylation_in_embryos.R` for details).
#'
#' @name mean_methylation_in_embryo
#'
#' @docType data
NULL

#' Methylation of CpGs within CT promoters
#'
#' @description
#'
#' DEPRECATED after v1.5, see `methylation_in_tissues`
#' Methylation values of CpGs located within Cancer-Testis (CT)
#' promoters in a set of normal tissues.
#'
#' @format
#'
#' A `RangedSummarizedExperiment` object with 51725 rows and 14 columns
#'
#' - Rows correspond to CpGs (located within CT genes promoters)
#'
#' - Columns correspond to normal tissues
#'
#' - Methylation values from WGBS data
#'
#' - rowRanges correspond to CpG positions
#'
#' @source
#'
#' WGBS methylation data was downloaded from Encode and from GEO
#' databases (see `scripts/make_CT_methylation_in_tissues.R` for
#' details).
#'
#' @name CT_methylation_in_tissues
#'
#' @docType data
NULL

#' CT genes' promoters mean methylation
#'
#' @description
#' DEPRECATED after v1.5, see `mean_methylation_in_tissues`
#' Mean methylation values of all CpGs located within Cancer-Testis
#' (CT) promoters in a set of normal tissues
#'
#' @format
#'
#' A `SummarizedExperiment` object with 298 rows and 14 columns
#'
#' - Rows correspond to CT genes
#'
#' - Mean methylation levels in normal tissues are stored in columns
#'
#' - CpG densities and results of methylation analysis are stored in
#'   rowData
#'
#' @details
#'
#' The rowData contains:
#'
#' - A column named `CpG_density`, gives the density of CpG within
#'   each promoter (number of CpG / promoter length * 100).
#'
#' - A column `CpG_promoter` that classifies the promoters according
#'   to their CpG densities: "low" (CpG_density < 2), "intermediate"
#'   (CpG_density >= 2 & CpG_density < 4), and "high" (CpG_density >=
#'   4).
#'
#' - A column `somatic_met_level` that gives the mean methylation
#'   level of each promoter in somatic tissues.
#'
#' - A column `sperm_met_level` that gives the methylation level of
#'   each promoter in sperm.
#'
#' - A column `somatic_methylation` indicates if the promoter's mean
#'   methylation level in somatic tissues is higher than 50%.
#'
#' - A column `germline_methylation`indicates if the promoter is
#'   methylated in germline, based on the ratio with somatic tissues
#'   (FALSE if somatic_met_level is at least twice higher than
#'   germline_met_level).
#'
#' @source
#'
#' WGBS methylation data was downloaded from Encode and from GEO
#' databases. Mean methylation levels are evaluated using methylation
#' values of CpGs located in promoter region (defined as 1000 nt
#' upstream TSS and 200 nt downstream TSS) (see
#' `scripts/make_CT_mean_methylation_in_tissues.R` for details).
#'
#' @name CT_mean_methylation_in_tissues
#'
#' @docType data
NULL



#' Methylation of CT promoters in TCGA samples
#'
#' @description
#'
#' DEPRECATED after v1.5, see `TCGA_methylation`
#' Methylation values of probes located within Cancer-Testis (CT)
#' promoters in samples from TCGA (tumor and peritumoral samples)
#'
#' @format
#'
#' A `RangedSummarizedExperiment` object with 666 rows and 3423
#' columns
#'
#' - Rows correspond to Infinium 450k probes
#'
#' - Columns correspond to samples
#'
#' - Methylation data from the assay are Beta values
#'
#' - Clinical information are stored in colData
#'
#' - Probe information (hg38 coordinates) are stored in rowRanges
#'
#' @source
#'
#' SKCM, LUAD, LUSC, COAD, ESCA, BRCA and HNSC methylation data were
#' downloaded with TCGAbiolinks and subsetted to select probes located
#' in CT genes promoter regions (see
#' `scripts/make_TCGA_CT_methylation.R` for details).
#'
#' @name TCGA_CT_methylation
#'
#' @docType data
NULL

---
title: "Cancer Testis Datasets"
author:
- name: Julie Devis, Laurent Gatto, Axelle Loriot
package: CTdata
output:
  BiocStyle::html_document:
    toc_float: true
vignette: >
  %\VignetteIndexEntry{Cancer Testis Datasets}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteKeywords{ExperimentHub, Cancer, Testis, Gene expression, methylation, Homo sapiens}
  %\VignetteEncoding{UTF-8}
---

```{r style, echo = FALSE, results = 'asis'}
BiocStyle::markdown()
```

# Introduction

`CTdata` is the companion Package for `CTexploreR` and provides omics
data to select and characterise cancer testis genes. Data come from
public databases and include expression and methylation values of
genes in normal, fetal and tumor samples as well as in tumor cell lines, and
expression in cells treated with a demethylating agent is also
available.

The data are served through the `ExperimentHub` infrastructure, which
allows download them only once and cache them for further
use. Currently available data are summarised in the table below and
details in the next section.

```{r data}
library("CTdata")
DT::datatable(CTdata())
```

# Installation

To install the package:

```{r install1, eval = FALSE}
if (!require("BiocManager"))
    install.packages("CTdata")

BiocManager::install("CTdata")
```

To install the package from GitHub:

```{r install2, eval = FALSE}
if (!require("BiocManager"))
    install.packages("BiocManager")

BiocManager::install("UCLouvain-CBIO/CTdata")
```

# Available data

```{r, echo=FALSE, fig.align='center', out.width = '100%'}
knitr::include_graphics("Datasets.png")
```

For details about each data, see their respective manual pages.

## Normal adult tissues

### GTEX data

A `SummarizedExperiment` object with gene expression data in normal
tissues from GTEx database:

```{r, message = FALSE}
library("SummarizedExperiment")
```

```{r}
GTEX_data()
```

### Normal tissue gene expression

A `SummarizedExperiment` object with gene expression values in normal
tissues with or without allowing multimapping:

```{r}
normal_tissues_multimapping_data()
```

### Methylation in normal adult tissues

A `RangedSummarizedExperiment` containing methylation of CpGs located
within gene promoters in normal tissues:

```{r}
methylation_in_tissues()
```

(`CT_methylation_in_tissues` before v 1.5)


A `SummarizedExperiment` with all genes' promoters mean
methylation in normal tissues:

```{r}
mean_methylation_in_tissues()
```

(`CT_mean_methylation_in_tissues` before v 1.5)


### Testis scRNAseq data

A `SingleCellExperiment` object containing gene expression from testis
single cell RNAseq experiment (*The adult human testis transcriptional
cell atlas* (Guo et al. 2018)):

```{r, message = FALSE}
library("SingleCellExperiment")
```

```{r}
testis_sce()
```


### Oocytes scRNAseq data

A `SingleCellExperiment` object containing gene expression from oocytes
single cell RNAseq experiment (Yan et al. 2021):

```{r}
oocytes_sce()
```


### Human Protein Atlas scRNAseq data

A `SingleCellExperiment` object containing gene expression in different human
cell types based on scRNAseq data obtained from the Human Protein Atlas
(https://www.proteinatlas.org)

```{r}
scRNAseq_HPA()
```

### Human Protein Atlas cell type specificity data

A `tibble` object containing cell type specificities based on scRNAseq data 
analysis from the Human Protein Atlas (https://www.proteinatlas.org)

```{r}
HPA_cell_type_specificities()
```

## Fetal cells

### Fetal germ cell scRNAseq data

A `SingleCellExperiment` object containing gene expression from fetal germ cells
single cell RNAseq experiment (*Single-cell roadmap of human gonadal development
*(Garcia-Alonso et al. 2022)):

```{r}
FGC_sce()
```

### Methylation in fetal germ cells (scWGBS)

A `RangedSummarizedExperiment` containing methylation of CpGs (hg19 based) 
located within gene promoters in fetal germ cells (*Dissecting the epigenomic 
dynamics of human fetal germ cell development at single-cell resolution*(Li et 
al. 2021)):

```{r}
methylation_in_FGC()
```

A `SummarizedExperiment` with all genes' promoters mean
methylation in fetal germ cells:

```{r}
mean_methylation_in_FGC()
```

### Embryonic stem cells RNA-Seq data

A `SummarizedExperiment` object with gene expression data in embryonic stem
cells from ENCODE database:

```{r}
hESC_data()
```

### Methylation in embryonic stem cells

A `RangedSummarizedExperiment` containing methylation of CpGs
located within gene promoters in embryonic stem cells from ENCODE

```{r}
methylation_in_hESC()
```

A `SummarizedExperiment` with all genes' promoters mean
methylation in embryonic stem cells:

```{r}
mean_methylation_in_hESC()
```

### Early embryo scRNA-seq data

A `SingleCellExperiment` object containing gene expression from early embryo
single cell RNAseq experiment (Petropulous et al, 2014):

```{r}
embryo_sce_Petropoulos()
```

A `SingleCellExperiment` object containing gene expression from early embryo
single cell RNAseq experiment (Zhu et al, 2018):

```{r}
embryo_sce_Zhu()
```


### Methylation in early embryo 

A `RangedSummarizedExperiment` containing methylation of CpGs (hg19 based) 
located within gene promoters in early embryo (*Single Cell DNA Methylome 
Sequencing of Human Preimplantation Embryos* (Zhu et al. 2018)):

```{r}
methylation_in_embryo()
```

A `RangedSummarizedExperiment ` with all genes' promoters mean
methylation in early embryo:

```{r}
mean_methylation_in_embryo()
```





## Demethylated gene expression

A `SummarizedExperiment` object containing genes differential
expression analysis (with RNAseq expression values) in cell lines
treated or not with a demethylating agent (5-Aza-2'-Deoxycytidine).

```{r}
DAC_treated_cells()
```

As above, with multimapping:

```{r}
DAC_treated_cells_multimapping()
```

## Tumor cells

### CCLE data

A `SummarizedExperiment` object with gene expression data in cancer
cell lines from CCLE:

```{r}
CCLE_data()
```

Also, a `matrix` with gene expression correlations in CCLE cancer cell lines:

```{r}
dim(CCLE_correlation_matrix())
CCLE_correlation_matrix()[1:10, 1:5]
```

### TCGA data

A `SummarizedExperiment` with gene expression data in TCGA samples
(tumor and peritumoral samples : SKCM, LUAD, LUSC, COAD, ESCA, BRCA
and HNSC):

```{r}
TCGA_TPM()
```

Also, a `SummarizedExperiment` with gene promoters methylation data in TCGA 
samples (tumor and peritumoral samples : SKCM, LUAD, LUSC, COAD, ESCA, BRCA
and HNSC):


```{r}
TCGA_methylation()
```


(`TCGA_CT_methylation` before v 1.5)


## CT genes determination

### All genes

```{r, echo = FALSE}
all_genes <- all_genes()
n <- nrow(all_genes)
```

The analysis for all genes can be found in `all_genes`, a tibble like `CT_genes` 
containing all `r n` genes characterisation. 

```{r}
all_genes()
```


###  CT genes 

```{r, echo = FALSE}
ctgenes <- CT_genes()
n <- nrow(ctgenes)
```

With the datasets above, we generated a list of `r n` CT and CTP genes (see
figure below for details).

We used multimapping because many CT genes belong to gene families
from which members have identical or nearly identical sequences. This
is likely the reason why these genes are not detected in GTEx
database, as GTEx processing pipeline specifies that overlapping
intervals between genes are excluded from all genes for counting. Some
CT genes can thus only be detected in RNAseq data in which
multimapping reads are not discarded.

```{r, echo=FALSE, fig.align='center', out.width = '100%'}
knitr::include_graphics("Figure_CT.png")
```


A `tibble` with Cancer-Testis (CT) genes and their characteristics:

```{r}
CT_genes()
```


# Session information {-}

```{r sessioninfo, echo=FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{mean_methylation_in_FGC}
\alias{mean_methylation_in_FGC}
\title{All genes' promoters mean methylation in FGC}
\format{
A \code{RangedSummarizedExperiment} object with 24441 rows and 337 columns
\itemize{
\item Rows correspond to all genes (gene names as rownames)
\item Mean methylation levels in FGC types are stored in columns
\item rowRanges correspond to the hg19 promoter positions
}
}
\source{
WGBS methylation data was downloaded from GEO. Mean methylation levels are
evaluated using methylation values of CpGs located in promoter region
(defined as 1000 nt upstream TSS and 500 nt downstream TSS) (see
\code{scripts/make_mean_methylation_in_FGC.R} for details).
}
\description{
Mean methylation values of all CpGs located within all genes
promoters in fetal germ cells. Data is based on hg19 reference genome ! From
\verb{Dissecting the epigenomic dynamics of human fetal germ cell development at single-cell resolution (Li et al. 2021)}
}
\details{
The rowData contains:
\itemize{
\item A column named \code{ensembl_gene_id} containing gene ids.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{CT_methylation_in_tissues}
\alias{CT_methylation_in_tissues}
\title{Methylation of CpGs within CT promoters}
\format{
A \code{RangedSummarizedExperiment} object with 51725 rows and 14 columns
\itemize{
\item Rows correspond to CpGs (located within CT genes promoters)
\item Columns correspond to normal tissues
\item Methylation values from WGBS data
\item rowRanges correspond to CpG positions
}
}
\source{
WGBS methylation data was downloaded from Encode and from GEO
databases (see \code{scripts/make_CT_methylation_in_tissues.R} for
details).
}
\description{
DEPRECATED after v1.5, see \code{methylation_in_tissues}
Methylation values of CpGs located within Cancer-Testis (CT)
promoters in a set of normal tissues.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{mean_methylation_in_tissues}
\alias{mean_methylation_in_tissues}
\title{All genes' promoters mean methylation}
\format{
A \code{SummarizedExperiment} object with 24502 rows and 14 columns
\itemize{
\item Rows correspond to all genes (gene names as rownames)
\item Mean methylation levels in normal tissues are stored in columns
\item CpG densities and results of methylation analysis are stored in
rowData
}
}
\source{
WGBS methylation data was downloaded from Encode and from GEO
databases. Mean methylation levels are evaluated using methylation
values of CpGs located in promoter region (defined as 1000 nt
upstream TSS and 200 nt downstream TSS) (see
\code{scripts/make_mean_methylation_in_tissues.R} for details).
}
\description{
Mean methylation values of all CpGs located within all genes
promoters in a set of normal tissues
}
\details{
The rowData contains:
\itemize{
\item A column named \code{CpG_density}, gives the density of CpG within
each promoter (number of CpG / promoter length * 100).
\item A column \code{CpG_promoter} that classifies the promoters according
to their CpG densities: "low" (CpG_density < 2), "intermediate"
(CpG_density >= 2 & CpG_density < 4), and "high" (CpG_density >=
4).
\item A column \code{somatic_met_level} that gives the mean methylation
level of each promoter in somatic tissues.
\item A column \code{sperm_met_level} that gives the methylation level of
each promoter in sperm.
\item A column \code{somatic_methylation} indicates if the promoter's mean
methylation level in somatic tissues is higher than 50\%.
\item A column \code{germline_methylation}indicates if the promoter is
methylated in germline, based on the ratio with somatic tissues
(FALSE if somatic_met_level is at least twice higher than
germline_met_level).
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{CCLE_correlation_matrix}
\alias{CCLE_correlation_matrix}
\title{Gene correlations in CCLE cancer cell lines}
\format{
A \code{matrix} object with 238 rows and 24483 columns.
\itemize{
\item Rows correspond to CT genes
\item Columns correspond to all genes from CCLE database
}
}
\source{
See \code{scripts/make_CCLE_correlation_matrix.R} for details.
}
\description{
Correlation coefficients between Cancer-Testis genes and all genes
found on the CCLE database.
}
\details{
Correlation coefficients (Pearson) between CT genes and all other
genes are given in the matrix. These correlation coefficients were
calculated using log transformed expression values from \code{CCLE_data}
(all cell lines).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{mean_methylation_in_embryo}
\alias{mean_methylation_in_embryo}
\title{All genes' promoters mean methylation in embryos}
\format{
A \code{RangedSummarizedExperiment} object with 24441 rows and 492 columns
\itemize{
\item Rows correspond to all genes (gene names as rownames)
\item Mean methylation levels in embryos types are stored in columns
\item rowRanges correspond to the hg19 promoter positions
}
}
\source{
WGBS methylation data was downloaded from GEO. Mean methylation levels are
evaluated using methylation values of CpGs located in promoter region
(defined as 1000 nt upstream TSS and 500 nt downstream TSS) (see
\code{scripts/make_mean_methylation_in_embryos.R} for details).
}
\description{
Mean methylation values of all CpGs located within all genes
promoters in early embryos. Data is based on hg19 reference genome ! From
\verb{Single Cell DNA Methylome Sequencing of Human Preimplantation Embryos} (Zhu et al. 2018)
}
\details{
The rowData contains:
\itemize{
\item A column named \code{ensembl_gene_id} containing gene ids.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{TCGA_methylation}
\alias{TCGA_methylation}
\title{Methylation of all genes promoters in TCGA samples}
\format{
A \code{RangedSummarizedExperiment} object with 79445 rows and 3423
columns
\itemize{
\item Rows correspond to Infinium 450k probes
\item Columns correspond to samples
\item Methylation data from the assay are Beta values
\item Clinical information are stored in colData
\item Probe information (hg38 coordinates) are stored in rowRanges
}
}
\source{
SKCM, LUAD, LUSC, COAD, ESCA, BRCA and HNSC methylation data were
downloaded with TCGAbiolinks and subsetted to select probes located
in CT genes promoter regions (see
\code{scripts/make_TCGA_methylation.R} for details).
}
\description{
Methylation values of probes located within all genes
promoters in samples from TCGA (tumor and peritumoral samples)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{embryo_sce_Petropoulos}
\alias{embryo_sce_Petropoulos}
\title{Embryo scRNAseq}
\format{
A \code{SingleCellExperiment} object with 26178 rows and 1481 columns
\itemize{
\item Rows correspond to genes (gene names as rownames)
\item Columns correspond to cells
}
}
\source{
RPKM and metadata files were downloaded from
https://www.ebi.ac.uk/biostudies/files/E-MTAB-3929/
The data were converted in a SingleCellExperiment
(see \code{scripts/make_embryo_sce_Petropoulos.R} for details).
}
\description{
Human embryo single cell RNAseq data in RPKM from
\verb{Single-Cell RNA-Seq Reveals Lineage and X Chromosome Dynamics in Human Preimplantation Embryos} (Petropulous et al, 2014)
}
\details{
Description of the colData:
\itemize{
\item Column \code{individual} gives the sample the cell is coming from.
\item Column \code{stage} specifies the stage of the early embryo.
\item Column \code{sex} is the sex inference made using the expression of 11
Y-linked genes, made for each day individually.
\item Column \code{ambigous} indicates if the inference of the embryo's sex was
ambigous due to some cells expression of the Y-linked genes.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{scRNAseq_HPA}
\alias{scRNAseq_HPA}
\title{Gene expression in human cell types}
\format{
A \code{SingleCellExperiment} object with 20082 rows and 66 columns
\itemize{
\item Rows correspond to genes (ensembl gene id as rownames)
\item Columns correspond to cell types
\item Expression values correspond to transcripts per million protein coding genes
(pTPM)
}
}
\source{
Gene expression values in cell types, based on multiple scRNAseq datasets
obtained from the Human Protein Atlas
(https://www.proteinatlas.org/about/download)
The data were converted in a SummarizedExperiment
(see \verb{scripts/14_make_scRNAseq_HPA.R} for details).
}
\description{
Gene expression profiles in different human cell types based on scRNAseq data
obtained from the Human Protein Atlas (https://www.proteinatlas.org)
}
\details{
Description of the colData:
\itemize{
\item Column \code{Cell_type} gives cell type.
\item Column \code{group} gives the cell type group (defined in the Human Protein Atlas).
}

Description of the rowData:
\itemize{
\item Column \code{max_TPM_in_a_somatic_cell_type} gives the maximum expression value
found in a somatic cell type
\item Column \code{max_in_germcells_group} gives the maximum expression value found
in a germ cell type
\item Column \code{Higher_in_somatic_cell_type} specifies if a somatic cell type
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{makeTags}
\alias{makeTags}
\title{A short function that returns the default CTdata tags and, if
provided, additional data-specific tags.}
\usage{
makeTags(x)
}
\arguments{
\item{x}{An optional \code{character()} containing specific tags.}
}
\value{
A \code{character} containing the default tags and optional
data-specific tags. If \code{x} is missing or is of length 0, the
default tags are returned. Otherwise, a vector of length equal to
\code{length(x)} is returned.
}
\description{
A short function that returns the default CTdata tags and, if
provided, additional data-specific tags.
}
\examples{

CTdata:::makeTags() ## only default tags

CTdata:::makeTags(character()) ## only default tags

CTdata:::makeTags("myTag") ## one additional tag

CTdata:::makeTags(c("myTag", "myOtherTag")) ## two additional tag
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{CCLE_data}
\alias{CCLE_data}
\title{Genes expression data in CCLE}
\format{
A \code{SummarizedExperiment} object with 24473 rows and 1229 columns
\itemize{
\item Rows correspond to genes (ensembl_gene_id)
\item Columns correspond to CCLE cell lines
\item Expression data from the assay are TPM values
\item Cell lines metadata are stored in colData
}
}
\source{
TPM values downloaded using depmap bioconductor package (see
\code{scripts/make_CCLE_data.R} for details).
}
\description{
Gene expression data in cancer cell lines from CCLE
}
\details{
The rowData contains
\itemize{
\item A column \code{percent_of_positive_CCLE_cell_lines} that gives the
percentage of CCLE cell lines (all cell lines combined)
expressing the gene (TPM >= 1).
\item A column \code{percent_of_negative_CCLE_cell_lines} that gives the
percent of CCLE cell lines (all cell lines combined) in which
genes are repressed (TPM < 0.5)
\item A column \code{max_TPM_in_CCLE} that gives the maximal expression (in
TPM) found in all cell lines.
\item A column \code{CCLE_category} gives the category ("activated",
"not_activated", "leaky") assigned to each gene.  "activated"
category corresponds to genes expressed (TPM >= 1) in at
least 1\% of cell lines, repressed (TPM <= 0.5) in at least 20\% of
cell lines with a maximal expression higher than 5 TPM.
"not_activated" category corresponds to genes
repressed (TPM <= 0.5) in at least 20\% of cell lines but
expressed (TPM >= 1) less than 1\%.  "leaky" category
corresponds to genes repressed (TPM <= 0.5) in less than 20\% of
cell lines. "lowly_expressed" corresponds to genes repressed (TPM <= 0.5)
in at least 20\%, expressed (TPM >= 1) in more than 1 \% of cell lines, with
a maximum expression lower than 5 TPM.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{DAC_treated_cells_multimapping}
\alias{DAC_treated_cells_multimapping}
\title{DE genes treated or not with a demethylating agent}
\format{
A \code{SummarizedExperiment} object with 24516 rows and 32 columns
\itemize{
\item Rows correspond to genes (ensembl_gene_id).
\item Columns correspond to samples.
\item Expression data correspond to counts that have been normalised
(by DESeq2 method) and log-transformed (log1p).
\item The colData contains the SRA references of the fastq files that
were downloaded, and informations about the cell lines and the
DAC treatment.
\item The rowData contains the results of a differential expression
evaluating the DAC treatment effect. For each each cell line, the
log2FC between treated and control cells is given, as well as the
p-adjusted value. The column \code{induced} flags genes significantly
induced (log2FoldChange >= 2 and padj <= 0.1) in at least one
cell line. The threshold is not too stringent as DAC is expected to induce
low expression levels (demethylation doesn't necessarily occurs in
all treated cells...).
When all cells lines already express the gene before DAC treatment, no
assessment of induction was done.
}
}
\source{
RNAseq fastq files were downloaded from Encode database.  SRA
reference of samples are stored in the colData.
}
\description{
Gene expression values in a set of cell lines treated or not with
5-Aza-2'-Deoxycytidine (DAC), a demethylating agent.  Many CT genes
belong to gene families from which members have identical or nearly
identical sequences. Some CT can only be detected in RNAseq data in
which multimapping reads are not discarded.
}
\details{
Differential expression analysis was done using DESeq2_1.36.0,
using as \code{design = ~ treatment} (see
\code{scripts/make_DAC_treated_cells_multimapping.R} for details).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{HPA_cell_type_specificities}
\alias{HPA_cell_type_specificities}
\title{Cell type specificities (from HPA)}
\format{
A \code{tibble} object with 24504 rows and 7 columns.
\itemize{
\item Rows correspond to genes (ensembl_gene_id)
\item Columns give genes cell type specificities
}
}
\source{
\code{proteinatlas.tsv} was downloaded from the Human Protein Atlas
(https://www.proteinatlas.org)
See \code{scripts/make_HPA_cell_type_specificities.R} for details.
}
\description{
Cell type specificities based on scRNAseq data from the
Human Protein Atlas (https://www.proteinatlas.org)
}
\details{
\itemize{
\item Column \code{HPA_scRNAseq_celltype_specific_nTPM} gives the cell types in
which genes were detected (corresponds to column
\verb{RNA single cell type specific nTPM} of proteinatlas.tsv file.
\item Column \code{max_HPA_germcell} specifies if the maximum expression value in a
germ cell type
\item Column \code{max_HPA_somatic} specifies if the maximum expression value in a
somatic cell type
\item Column \code{not_detected_in_somatic_HPA} specifies if the gene is detected or
not in a somatic cell type. Genes are flagged as
\code{TRUE} if the \code{max_HPA_somatic} value is equal to 0, and \code{FALSE} if
\code{max_HPA_somatic} value is > 0. \code{NA} is set when the original table from HPA
had no values for that gene.
\item Column \code{HPA_ratio_germ_som} gives the ratio between \code{max_HPA_germcell} and
\code{max_HPA_somatic} columns.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{embryo_sce_Zhu}
\alias{embryo_sce_Zhu}
\title{Embryo scRNAseq}
\format{
A \code{SingleCellExperiment} object with 26255 rows and 50 columns
\itemize{
\item Rows correspond to genes (gene names as rownames)
\item Columns correspond to cells
}
}
\source{
50 FPKM files were downloaded from GEO
(accession: GSE81233). The data were converted in a SingleCellExperiment
(see \code{scripts/make_embryo_sce_Zhu.R} for details).
}
\description{
Human embryo single cell RNAseq data in FPKM from
\verb{Single Cell DNA Methylome Sequencing of Human Preimplantation Embryos} (Zhu et al. 2018)
}
\details{
Description of the colData:
\itemize{
\item Column \code{embryo} gives the embryo the cell is coming from.
\item Column \code{stage} specifies the stage of the early embryo.
\item Column \code{sex} is the sex inference made using the expression of RPS4Y1. If
mean expression of RPS4Y1 is higher than 50 FPKM, the sample is male.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{testis_sce}
\alias{testis_sce}
\title{Testis scRNAseq data}
\format{
A \code{SingleCellExperiment} object with 20891 rows and 6490 columns
\itemize{
\item Rows correspond to genes (gene names as rownames)
\item Columns correspond to testis cells
}
}
\source{
The count matrix \code{GSE112013_Combined_UMI_table.txt.gz} was downloaded from
GEO (accession: GSE112013). Metadata correspond to \code{TableS1} from the paper's
supplemental data. The data were converted in a SingleCellExperiment
(see \verb{scripts/13_make_testis_sce.R} for details).
}
\description{
Testis single cell RNAseq data from
\verb{The adult human testis transcriptional cell atlas} (Guo et al. 2018)
}
\details{
Description of the colData:
\itemize{
\item Column \code{nGene} gives the number of distinct genes detected per cell.
\item Column \code{nUMI} gives the total UMI number per cell.
\item Column \code{clusters} gives cluster number defined in the Guo's paper.
\item Column \code{type} gives the testis cell type associated to the cluster number.
\item Column \code{Donor} gives the Donor origin of the cells.
}

Description of the rowData:
\itemize{
\item Column \code{percent_pos_testis_germcells} gives the percent of testis germ cells
in wich the genes are detected (count > 0) (based on testis scRNAseq data).
\item Column \code{percent_pos_testis_somatic} gives the percent of testis somatic cells
in wich the genes are detected (count > 0) (based on testis scRNAseq data).
\item Column\code{testis_cell_type} specifies the testis cell-type showing the highest
mean expression of each gene (based on testis scRNAseq data).
}

The rowData contains the \code{testis_cell_type} column, specifying the testis
cell-type showing the highest mean expression of each gene.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{mean_methylation_in_hESC}
\alias{mean_methylation_in_hESC}
\title{All genes' promoters mean methylation in hESC}
\format{
A \code{SummarizedExperiment} object with 24488 rows and 3 columns
\itemize{
\item Rows correspond to all genes (gene names as rownames)
\item Mean methylation levels in hESC types are stored in columns
}
}
\source{
WGBS methylation data was downloaded from Encode. Mean methylation levels are
evaluated using methylation values of CpGs located in promoter region
(defined as 1000 nt upstream TSS and 200 nt downstream TSS) (see
\code{scripts/make_mean_methylation_in_hESC.R} for details).
}
\description{
Mean methylation values of all CpGs located within all genes
promoters in human embryonic stem cells
}
\details{
The rowData contains:
\itemize{
\item A column named \code{ensembl_gene_id} containing gene ids.
}

The colData contains
\itemize{
\item Column \code{genotype} gives the sexual genotype of the cells
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{normal_tissues_multimapping_data}
\alias{normal_tissues_multimapping_data}
\title{Gene expression values in normal tissues}
\format{
A \code{SummarizedExperiment} object with 24504 rows and 18 columns
\itemize{
\item Rows correspond to genes (ensembl_gene_id)
\item Columns correspond to normal tissues.
\item First assay, \code{TPM_no_multimapping}, gives TPM expression values
obtained when discarding multimapped reads.
\item Second assay, \code{TPM_with_multimapping}, gives TPM expression
values obtained by counting multimapped reads.
}
}
\source{
RNAseq fastq files were downloaded from Encode database (see
\code{scripts/make_normal_tissues_multimapping.R} for details).
}
\description{
Gene expression values (TPM) in a set of normal tissues obtained by
counting or not multi-mapped reads. Many CT genes belong to gene
families from which members have identical or nearly identical
sequences.  Some CT can only be detected in RNAseq data in which
multimapping reads are not discarded.
}
\details{
A column named \code{multimapping_analysis} has been added to the
rowData. It summarizes the testis specificity analysis of genes
flagged as "lowly_expressed" in GTEX_data. Genes are considered
"testis_specific" when, with multimapping allowed, they are
detectable in testis (TPM >= 1), their TPM value has increased
compared to without multimapping (ratio > 5), and their TPM value
is at least 10 times higher in testis than in any other somatic
tissue (where the maximum expression always has to be below 1 TPM).
Genes are considered "testis_preferential" when, with multimapping allowed,
they are detectable in testis (TPM >= 1), their TPM value has increased
compared to without multimapping (ratio > 5), and their TPM value
is at least 10 times higher in testis than in any other somatic
tissue (where the maximum expression is above 1 TPM).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{FGC_sce}
\alias{FGC_sce}
\title{Fetal gonad scRNAseq}
\format{
A \code{SingleCellExperiment} object with 22489 rows and 10850 columns
\itemize{
\item Rows correspond to genes (gene names as rownames)
\item Columns correspond to cells
}
}
\source{
ee58527e-e1e4-465d-8dc8-800ee40f14f2.rds file dowloaded from
https://cellxgene.cziscience.com/collections/661a402a-2a5a-4c71-9b05-b346c57bc451Data.
The data were converted in a SingleCellExperiment
(see \code{scripts/make_FGC_sce.R} for details).
}
\description{
Human fetal gonad single cell RNAseq data from
\verb{Single-cell roadmap of human gonadal development}
(Garcia-Alonso, Nature 2022)
}
\details{
Description of the colData:
\itemize{
\item Column \code{type} gives the gender and the cell type.
\item Column \code{stage} specifies if the cell type is "pre-meiotic" or "meiotic".
\item Column \code{germcell} is set to TRUE when the cell type is a germ cell.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CTdata.R
\name{CTdata}
\alias{CTdata}
\title{All CTdata datasets}
\usage{
CTdata()
}
\value{
A \code{data.frame} describing the data available in
\code{CTdata}.
}
\description{
This is the companion Package for \code{CTexploreR} containing omics
data to select and characterise CT genes.

Data come from public databases and include expression and
methylation values of genes in normal and tumor samples as well as
in tumor cell lines, and expression in cells treated with a
demethylating agent is also available.

The \code{\link[=CTdata]{CTdata()}} function returns a \code{data.frame} with all the
annotated datasets provided in the package. For details on these
individual datasets, refer to their respective manual pages.

See the vignette and the respective manuals pages for more details
about the package and the data themselves.
}
\examples{

CTdata()
}
\author{
Laurent Gatto
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{oocytes_sce}
\alias{oocytes_sce}
\title{Oocytes scRNAseq}
\format{
A \code{SingleCellExperiment} object with 26500 rows and 899 columns
\itemize{
\item Rows correspond to genes(gene names as rownames)
\item Columns correspond to cells
}
}
\source{
GSE154762_hO_scChaRM_count_matix.txt.gz\verb{was downloaded from GEO (accession: GSE154762). The data were converted in a SingleCellExperiment (see}scripts/make_oocytes_sce.R` for details).
}
\description{
Human oocytes single cell RNAseq data from
\verb{Decoding dynamic epigenetic landscapes in human oocytes using single-cell multi-omics sequencing} (Yan et al. Cell Stem Cell 2021)
}
\details{
Description of the colData:
\itemize{
\item Column \code{type} gives the cell type.
\item Column \code{stage} specifies if the cell type is "pre-meiotic" or "meiotic".
\item Column \code{germcell} is set to TRUE when the cell type is a germ cell.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{methylation_in_tissues}
\alias{methylation_in_tissues}
\title{Methylation of CpGs within all genes promoters}
\format{
A \code{RangedSummarizedExperiment} object with 4280327 rows and 14 columns
\itemize{
\item Rows correspond to CpGs (located within all genes promoters (TSS +- 5000
nt))
\item Columns correspond to normal tissues
\item Methylation values from WGBS data
\item rowRanges correspond to CpG positions
}
}
\source{
WGBS methylation data was downloaded from Encode and from GEO
databases (see \code{scripts/make_methylation_in_tissues.R} for
details).
}
\description{
Methylation values of CpGs located within all genes
promoters in a set of normal tissues.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{methylation_in_FGC}
\alias{methylation_in_FGC}
\title{Methylation of CpGs within all genes promoters in FGC}
\format{
A \code{RangedSummarizedExperiment} object with 1915545 rows and 337 columns
\itemize{
\item Rows correspond to CpGs (located within all genes promoters (TSS +- 1000
nt))
\item Columns correspond to cells
\item Methylation values from scWGBS data
\item rowRanges correspond to CpG positions
}
}
\source{
scWGBS methylation data was downloaded from GEO database
(see \code{scripts/make_methylation_in_FGC.R} for details).
}
\description{
Methylation values of CpGs located within all genes
promoters in fetal germ cells. Data is based on hg19 reference genome ! From
\verb{Dissecting the epigenomic dynamics of human fetal germ cell development at single-cell resolution (Li et al. 2021)}
}
\details{
Description of the colData:
\itemize{
\item Column \code{type} indicates if the cell type is somatic or FGC
\item Column \code{time_week} specifies the time of the embryo when cells were removed.
\item Column \code{sex} indicates the sex of the cells.
\item Other information about the sequencing of each sample are clearly labelled
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{GTEX_data}
\alias{GTEX_data}
\title{Genes expression in GTEX}
\format{
A \code{SummarizedExperiment} object with 24504 rows and 32 columns
\itemize{
\item Rows correspond to genes (ensembl_gene_id as rownames)
\item Columns correspond to tissues
\item Expression data from the assay are TPM values
}
}
\source{
Downloaded from
https://storage.googleapis.com/gtex_analysis_v8/rna_seq_data/GTEx_Analysis_2017-06-05_v8_RNASeQCv1.1.9_gene_median_tpm.gct.gz.
Some categories of tissues were pooled (mean expression values are
given in pooled tissues) (see \code{scripts/make_GTEX_data.R} for
details).
}
\description{
Gene expression data in normal tissues from GTEx database.
}
\details{
The rowData contains
\itemize{
\item A column named \code{GTEX_category}, specifying the tissue specificity
category ("testis_specific", "testis-preferential",
"lowly_expressed" or "other") assigned to each gene using
expression values in testis and in somatic tissues, has been
added to the rowData. "testis_specific" genes are expressed
exclusively in testis (expression in testis >= 1 TPM, highest
expression in somatic tissues < 0.5 TPM, and expressed at least
10x more in testis than in any somatic
tissue). "testis-preferential" genes are genes expressed in
testis but also in a few somatic tissues (expression in testis >=
1 TPM, and allowed in a minority of somatic tissues
(q75_TPM_somatic < 0.5) and expressed at least 10x more in testis than in
any somatic tissue). "lowly_expressed" genes are genes undetectable in GTEX
database probably due to multi-mapping issues (expression in all
GTEX tissues < 1 TPM).
\item A column named \code{q75_TPM_somatic} giving the quantile 75\% of TPM
in a somatic tissue.
\item A column named \code{max_TPM_somatic} giving the maximum expression
level found in a somatic tissue.
\item A column named \code{ratio_testis_somatic} giving the ratio between the TPM
in testis and the max TPM in a somatic tissue
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{methylation_in_embryo}
\alias{methylation_in_embryo}
\title{Methylation of CpGs within all genes promoters in embryo}
\format{
A \code{RangedSummarizedExperiment} object with 1915545 rows and 492 columns
\itemize{
\item Rows correspond to CpGs (located within all genes promoters (TSS +- 1000
nt))
\item Columns correspond to cells
\item Methylation values from scWGBS data
\item rowRanges correspond to CpG positions
}
}
\source{
scWGBS methylation data was downloaded from GEO database
(see \code{scripts/make_methylation_in_embryo.R} for details).
}
\description{
Methylation values of CpGs located within all genes
promoters in embryo. Data is based on hg19 reference genome ! From
\verb{Single Cell DNA Methylome Sequencing of Human Preimplantation Embryos} (Zhu et al. 2018)
}
\details{
Description of the colData:
\itemize{
\item Column \code{cell_type} indicates the embryo type.
\item Column \code{bulk_or_single_cell} specifies if the sample was indeed only a
single cell or a bulk of several cells.
\item Other information about the sequencing of each sample are clearly labelled
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{TCGA_TPM}
\alias{TCGA_TPM}
\title{Gene expression in TCGA samples}
\format{
A \code{SummarizedExperiment} object with 24497 rows and 4141 columns
\itemize{
\item Rows correspond to genes (ensembl_gene_id)
\item Columns correspond to samples
\item Expression data from the assay are TPM values
\item Clinical information are stored in colData
\item Genes information are stored in rowData
}
}
\source{
SKCM, LUAD, LUSC, COAD, ESCA, BRCA and HNSC expression data were
downloaded with TCGAbiolinks (see \code{scripts/make_TCGA_TPM.R}
for details).
}
\description{
Gene expression data in TCGA samples (tumor and peritumoral
samples).
}
\details{
\itemize{
\item The colData contains clinical data from TCGA as well as global
hypomethylation levels obtained from paper \emph{DNA methylation loss
promotes immune evasion of tumours with high mutation and copy
number load} from Jang et al., Nature Commun 2019 that were added
(see \code{inst/scripts/make_TCGA_TPM.R} for details).
\item The rowData contains genes information and, for each gene, the
percentage of tumors that are positive (TPM >= 1), and the
percentage of tumors that are negative (TPM < 0.5). In column
\code{TCGA_category}, genes are labelled as "activated" when the
percentage of positive tumors is > 1, with a maximal expression higher than
5 TPM, and when at least 20\% of tumors are negative. Genes are labelled as
"not_activated" when the percentage of positive tumors is lower than 1.
Genes are labelled as "leaky" when less than 20\% of tumors are negative.
Genes are labelled as "lowly_expressed" when repressed (TPM <= 0.5)
in at least 20\%, expressed (TPM >= 1) in more than 1 \% of cell lines, with
a maximum expression lower than 5 TPM.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{methylation_in_hESC}
\alias{methylation_in_hESC}
\title{Methylation of CpGs within all genes promoters in hESC}
\format{
A \code{RangedSummarizedExperiment} object with 4280098 rows and 3 columns
\itemize{
\item Rows correspond to CpGs (located within all genes promoters (TSS +- 5000
nt))
\item Columns correspond to hESC
\item Methylation values from WGBS data
\item rowRanges correspond to CpG positions
}
}
\source{
WGBS methylation data was downloaded from Encode
(see \code{scripts/make_methylation_in_hESC.R} for details).
}
\description{
Methylation values of CpGs located within all genes
promoters in human embryonic stem cells.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{CT_genes}
\alias{CT_genes}
\title{CT genes description table}
\format{
A \code{tibble} object with 280 rows and 47 columns.
\itemize{
\item Rows correspond to CT genes
\item Columns give CT genes characteristics
}
}
\source{
See \code{scripts/make_all_genes_prelim.R} and
\code{scripts/make_all_genes_and_CT_genes.R}for details on how this list of
curated CT genes was created.
}
\description{
Cancer-Testis (CT) genes description
}
\details{
When the promoter is mentionned, it has been determined as 1000 nt
upstream TSS and 200 nt downstream TSS.

CT_genes characteristics column:
\itemize{
\item Column \code{CT_gene_type} indicates if the gene is a CT specific gene
("CT_gene" : testis_specific in \code{testis_specificity}) and activated in
"TCGA_category" and "CCLE_category) or CT preferential gene ("CTP_gene" :
testis_preferential in \code{testis_specificity}) and activated in"TCGA_category"
and "CCLE_category").
\item Column \code{testis_specificity} gives the testis-specificity of genes
assigned to each gene using \code{GTEX_category} and \code{multimapping_analysis}
("testis_specific" or "testis_preferential"). Genes were assigned
"testis-preferential" if testis-specific in these categories but not testis
specific in \code{HPA_category} or leaky in \code{CCLE_category} or \code{TCGA_category}.
\item Column \code{regulated_by_methylation} indicates if the gene is
regulated by methylation (\code{TRUE}) based on DAC induction (has to
be TRUE) and on promoter methylation level in normal somatic tissues
(when available, has to be methylated in somatic tissues).
\item Column \code{X_linked} indicates if the gene is on the chromosome X
(TRUE) or not (FALSE).
\item Columns \code{chr}, \code{strand} and \code{transcription_start_site} give the
genomic location.
\item Column \code{GTEX_category} gives the category ("testis_specific",
"testis_preferential" or "lowly_expressed") assigned to each gene
using GTEx database (see \code{?GTEX_data} for details).
\item Column \code{q75_TPM_somatic} gives the q75 expression level found
in a somatic tissue (using GTEx database).
\item Column \code{max_TPM_somatic} gives the maximum expression level found
in a somatic tissue (using GTEx database).
\item Column \code{ratio_testis_somatic} gives the ratio between expression in testis
and the highest expression found in a somatic tissue (using GTEx database).
\item Column \code{TPM_testis} gives the gene expression level in testis
(using GTEx database).
\item Column \code{lowly_expressed_in_GTEX} indicates if the gene is lowly
expressed in GTEX database and thus needed to be analysed with
multimapping allowed.
\item Column \code{multimapping_analysis} informs if the gene (flagged as
"lowly_expressed" in GTEX_data) was found to be testis-specific
when multi-mapped reads were counted for gene expression in
normal tissues ("not_analysed" or "testis_specific") (see
\code{?normal_tissues_multimapping_data} for details).
\item Column \code{HPA_RNA_single_cell_type_specific_nTPM} specifies the cell types in
which genes were detected in the HPA single cell data (see
\code{?HPA_cell_type_specificity} for details).
\item Column \code{max_HPA_germcell} specifies if the maximum expression value in a
germ cell type. (see  \code{?HPA_cell_type_specificity} for details).
\item Column \code{max_HPA_somatic} specifies if the maximum expression value in a
somatic cell type. (see  \code{?HPA_cell_type_specificity} for details).
\item Column \code{not_detected_in_somatic_HPA} specifies if the gene is detected or
not in a somatic cell type. (see  \code{?HPA_cell_type_specificity} for details).
\item Column \code{HPA_ratio_germ_som} gives the ratio between \code{max_HPA_germcell} and
\code{max_HPA_somatic} columns.
\item Column \code{percent_of_positive_CCLE_cell_lines} gives the percentage
of CCLE cancer cell lines in which genes are expressed (genes
were considered as expressed if TPM >= 1).
\item Column \code{percent_of_negative_CCLE_cell_lines} gives the percentage
of CCLE cancer cell lines in which genes are repressed (TPM <=
0.5).
\item Column \code{max_TPM_in_CCLE} gives the highest expression level of
genes in CCLE cell lines.
\item Column \code{CCLE_category} gives the category assigned to each gene
using CCLE data. "Activated" category corresponds to genes
expressed in at least 1\% of cell lines (TPM >= 1) and repressed in
at least 20\% of cell lines.
\item Column \code{percent_pos_tum} gives the percentage of TCGA cancer
samples in which genes are expressed (genes were considered as
expressed if TPM >= 1).
\item Column \code{percent_neg_tum} gives the percentage of TCGA cancer samples in
which genes are repressed (TPM <= 0.5).
\item Column \code{max_TPM_in_TCGA} gives the highest expression level of
genes in TCGA cancer sample.
\item Column \code{max_q75_in_NT} gives the maximum q75 expression in normal
peritumoral tissues from TCGA.
\item Column \code{TCGA_category} gives the category assigned to each gene
using TCGA data. "activated" category corresponds to genes
expressed in at least 1\% of tumors (TPM >= 1) and repressed in at
least 20\% of samples.  "multimapping_issue" corresponds to genes
that need multi-mapping to be allowed in order to be analysed
properly.
\item Columns \code{external_transcript_name}, \code{ensembl_transcript_id}, and
\code{transcript_biotype} give the references and informations about
the most biologically relevant transcript associated to each
gene.
\item Column \code{IGV_backbone} indicates if a gene has been removed from CT genes
as RNA-Seq reads were not properly aligned on exons, but were instead
spread across a wide genomic region spanning the genes.
\item Column \code{family} gives the gene family name.
\item Column \code{DAC_induced} summarises the results (\code{TRUE} or \code{FALSE})
of a differential expression evaluating gene induction upon DAC
treatment in a series of cell lines.
\item Column named \code{CpG_density}, gives the density of CpG within each
promoter (number of CpG / promoter length * 100).
\item Column \code{CpG_promoter} classifies the promoters according to their
CpG densities: "low" (CpG_density < 2), "intermediate"
(CpG_density >= 2 & CpG_density < 4), and "high" (CpG_density >=
4).
\item Column \code{somatic_met_level} that gives the mean methylation level
of each promoter in somatic tissues.
\item Column \code{sperm_met_level} that gives the methylation level of each
promoter in sperm.
\item Column \code{somatic_methylation} indicates if the promoter's mean
methylation level in somatic tissues is higher than 50\%.
\item Column \code{germline_methylation}indicates if the promoter is
methylated in germline, based on the ratio with somatic tissues
(\code{FALSE} if somatic_met_level is at least twice higher than
\code{germline_met_level}).
\item Columns \code{oncogene} and \code{tumor_suppressor} informs if oncogenic
and tumor-suppressor functions have been associated to genes
(source: \href{http://bionlp.bcgsc.ca/cancermine/}{Cancermine}).
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{hESC_data}
\alias{hESC_data}
\title{Genes expression in hESC}
\format{
A \code{SummarizedExperiment} object with 24488 rows and 4 columns
\itemize{
\item Rows correspond to genes (ensembl_gene_id as rownames)
\item Columns correspond to hESC types
\item Expression data from the assay are TPM values
}
}
\source{
RNAseq fastq files were downloaded from Encode databas (see
\code{scripts/make_hESC_data.R} for details).
}
\description{
Gene expression data in human embryonic stem cells
}
\details{
The colData contains
\itemize{
\item Column \code{genotype} gives the sexual genotype of the cells
}
}
